// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_MEDIA_MEDIA_ENGAGEMENT_SCORE_DETAILS_MOJOM_TEST_UTILS_H_
#define CHROME_BROWSER_MEDIA_MEDIA_ENGAGEMENT_SCORE_DETAILS_MOJOM_TEST_UTILS_H_

#include "chrome/browser/media/media_engagement_score_details.mojom.h"


namespace media {
namespace mojom {


class  MediaEngagementScoreDetailsProviderInterceptorForTesting : public MediaEngagementScoreDetailsProvider {
  virtual MediaEngagementScoreDetailsProvider* GetForwardingInterface() = 0;
  void GetMediaEngagementScoreDetails(GetMediaEngagementScoreDetailsCallback callback) override;
  void GetMediaEngagementConfig(GetMediaEngagementConfigCallback callback) override;
};
class  MediaEngagementScoreDetailsProviderAsyncWaiter {
 public:
  explicit MediaEngagementScoreDetailsProviderAsyncWaiter(MediaEngagementScoreDetailsProvider* proxy);
  ~MediaEngagementScoreDetailsProviderAsyncWaiter();
  void GetMediaEngagementScoreDetails(
      std::vector<MediaEngagementScoreDetailsPtr>* out_info);
  void GetMediaEngagementConfig(
      MediaEngagementConfigPtr* out_config);

 private:
  MediaEngagementScoreDetailsProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MediaEngagementScoreDetailsProviderAsyncWaiter);
};




}  // namespace mojom
}  // namespace media

#endif  // CHROME_BROWSER_MEDIA_MEDIA_ENGAGEMENT_SCORE_DETAILS_MOJOM_TEST_UTILS_H_