// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_PARAMS_DATA_H_
#define CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace performance_manager {
namespace mojom {
namespace internal {
class  WebUIGraphChangeStream_FrameCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphChangeStream_FrameCreated_Params_Data));
      new (data()) WebUIGraphChangeStream_FrameCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphChangeStream_FrameCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphChangeStream_FrameCreated_Params_Data>(index_);
    }
    WebUIGraphChangeStream_FrameCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIFrameInfo_Data> frame;

 private:
  WebUIGraphChangeStream_FrameCreated_Params_Data();
  ~WebUIGraphChangeStream_FrameCreated_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphChangeStream_FrameCreated_Params_Data) == 16,
              "Bad sizeof(WebUIGraphChangeStream_FrameCreated_Params_Data)");
class  WebUIGraphChangeStream_PageCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphChangeStream_PageCreated_Params_Data));
      new (data()) WebUIGraphChangeStream_PageCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphChangeStream_PageCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphChangeStream_PageCreated_Params_Data>(index_);
    }
    WebUIGraphChangeStream_PageCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIPageInfo_Data> pages;

 private:
  WebUIGraphChangeStream_PageCreated_Params_Data();
  ~WebUIGraphChangeStream_PageCreated_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphChangeStream_PageCreated_Params_Data) == 16,
              "Bad sizeof(WebUIGraphChangeStream_PageCreated_Params_Data)");
class  WebUIGraphChangeStream_ProcessCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphChangeStream_ProcessCreated_Params_Data));
      new (data()) WebUIGraphChangeStream_ProcessCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphChangeStream_ProcessCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphChangeStream_ProcessCreated_Params_Data>(index_);
    }
    WebUIGraphChangeStream_ProcessCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIProcessInfo_Data> process;

 private:
  WebUIGraphChangeStream_ProcessCreated_Params_Data();
  ~WebUIGraphChangeStream_ProcessCreated_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphChangeStream_ProcessCreated_Params_Data) == 16,
              "Bad sizeof(WebUIGraphChangeStream_ProcessCreated_Params_Data)");
class  WebUIGraphChangeStream_FrameChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphChangeStream_FrameChanged_Params_Data));
      new (data()) WebUIGraphChangeStream_FrameChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphChangeStream_FrameChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphChangeStream_FrameChanged_Params_Data>(index_);
    }
    WebUIGraphChangeStream_FrameChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIFrameInfo_Data> frame;

 private:
  WebUIGraphChangeStream_FrameChanged_Params_Data();
  ~WebUIGraphChangeStream_FrameChanged_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphChangeStream_FrameChanged_Params_Data) == 16,
              "Bad sizeof(WebUIGraphChangeStream_FrameChanged_Params_Data)");
class  WebUIGraphChangeStream_PageChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphChangeStream_PageChanged_Params_Data));
      new (data()) WebUIGraphChangeStream_PageChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphChangeStream_PageChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphChangeStream_PageChanged_Params_Data>(index_);
    }
    WebUIGraphChangeStream_PageChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIPageInfo_Data> page;

 private:
  WebUIGraphChangeStream_PageChanged_Params_Data();
  ~WebUIGraphChangeStream_PageChanged_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphChangeStream_PageChanged_Params_Data) == 16,
              "Bad sizeof(WebUIGraphChangeStream_PageChanged_Params_Data)");
class  WebUIGraphChangeStream_ProcessChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphChangeStream_ProcessChanged_Params_Data));
      new (data()) WebUIGraphChangeStream_ProcessChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphChangeStream_ProcessChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphChangeStream_ProcessChanged_Params_Data>(index_);
    }
    WebUIGraphChangeStream_ProcessChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIProcessInfo_Data> process;

 private:
  WebUIGraphChangeStream_ProcessChanged_Params_Data();
  ~WebUIGraphChangeStream_ProcessChanged_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphChangeStream_ProcessChanged_Params_Data) == 16,
              "Bad sizeof(WebUIGraphChangeStream_ProcessChanged_Params_Data)");
class  WebUIGraphChangeStream_FavIconDataAvailable_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphChangeStream_FavIconDataAvailable_Params_Data));
      new (data()) WebUIGraphChangeStream_FavIconDataAvailable_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphChangeStream_FavIconDataAvailable_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphChangeStream_FavIconDataAvailable_Params_Data>(index_);
    }
    WebUIGraphChangeStream_FavIconDataAvailable_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIFavIconInfo_Data> favicon;

 private:
  WebUIGraphChangeStream_FavIconDataAvailable_Params_Data();
  ~WebUIGraphChangeStream_FavIconDataAvailable_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphChangeStream_FavIconDataAvailable_Params_Data) == 16,
              "Bad sizeof(WebUIGraphChangeStream_FavIconDataAvailable_Params_Data)");
class  WebUIGraphChangeStream_NodeDeleted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphChangeStream_NodeDeleted_Params_Data));
      new (data()) WebUIGraphChangeStream_NodeDeleted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphChangeStream_NodeDeleted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphChangeStream_NodeDeleted_Params_Data>(index_);
    }
    WebUIGraphChangeStream_NodeDeleted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t node_id;

 private:
  WebUIGraphChangeStream_NodeDeleted_Params_Data();
  ~WebUIGraphChangeStream_NodeDeleted_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphChangeStream_NodeDeleted_Params_Data) == 16,
              "Bad sizeof(WebUIGraphChangeStream_NodeDeleted_Params_Data)");
class  WebUIGraphDump_SubscribeToChanges_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphDump_SubscribeToChanges_Params_Data));
      new (data()) WebUIGraphDump_SubscribeToChanges_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphDump_SubscribeToChanges_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphDump_SubscribeToChanges_Params_Data>(index_);
    }
    WebUIGraphDump_SubscribeToChanges_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data change_subscriber;

 private:
  WebUIGraphDump_SubscribeToChanges_Params_Data();
  ~WebUIGraphDump_SubscribeToChanges_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphDump_SubscribeToChanges_Params_Data) == 16,
              "Bad sizeof(WebUIGraphDump_SubscribeToChanges_Params_Data)");

}  // namespace internal
class WebUIGraphChangeStream_FrameCreated_ParamsDataView {
 public:
  WebUIGraphChangeStream_FrameCreated_ParamsDataView() {}

  WebUIGraphChangeStream_FrameCreated_ParamsDataView(
      internal::WebUIGraphChangeStream_FrameCreated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFrameDataView(
      WebUIFrameInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrame(UserType* output) {
    auto* pointer = data_->frame.Get();
    return mojo::internal::Deserialize<::performance_manager::mojom::WebUIFrameInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUIGraphChangeStream_FrameCreated_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUIGraphChangeStream_PageCreated_ParamsDataView {
 public:
  WebUIGraphChangeStream_PageCreated_ParamsDataView() {}

  WebUIGraphChangeStream_PageCreated_ParamsDataView(
      internal::WebUIGraphChangeStream_PageCreated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPagesDataView(
      WebUIPageInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPages(UserType* output) {
    auto* pointer = data_->pages.Get();
    return mojo::internal::Deserialize<::performance_manager::mojom::WebUIPageInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUIGraphChangeStream_PageCreated_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUIGraphChangeStream_ProcessCreated_ParamsDataView {
 public:
  WebUIGraphChangeStream_ProcessCreated_ParamsDataView() {}

  WebUIGraphChangeStream_ProcessCreated_ParamsDataView(
      internal::WebUIGraphChangeStream_ProcessCreated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetProcessDataView(
      WebUIProcessInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadProcess(UserType* output) {
    auto* pointer = data_->process.Get();
    return mojo::internal::Deserialize<::performance_manager::mojom::WebUIProcessInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUIGraphChangeStream_ProcessCreated_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUIGraphChangeStream_FrameChanged_ParamsDataView {
 public:
  WebUIGraphChangeStream_FrameChanged_ParamsDataView() {}

  WebUIGraphChangeStream_FrameChanged_ParamsDataView(
      internal::WebUIGraphChangeStream_FrameChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFrameDataView(
      WebUIFrameInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrame(UserType* output) {
    auto* pointer = data_->frame.Get();
    return mojo::internal::Deserialize<::performance_manager::mojom::WebUIFrameInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUIGraphChangeStream_FrameChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUIGraphChangeStream_PageChanged_ParamsDataView {
 public:
  WebUIGraphChangeStream_PageChanged_ParamsDataView() {}

  WebUIGraphChangeStream_PageChanged_ParamsDataView(
      internal::WebUIGraphChangeStream_PageChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageDataView(
      WebUIPageInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPage(UserType* output) {
    auto* pointer = data_->page.Get();
    return mojo::internal::Deserialize<::performance_manager::mojom::WebUIPageInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUIGraphChangeStream_PageChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUIGraphChangeStream_ProcessChanged_ParamsDataView {
 public:
  WebUIGraphChangeStream_ProcessChanged_ParamsDataView() {}

  WebUIGraphChangeStream_ProcessChanged_ParamsDataView(
      internal::WebUIGraphChangeStream_ProcessChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetProcessDataView(
      WebUIProcessInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadProcess(UserType* output) {
    auto* pointer = data_->process.Get();
    return mojo::internal::Deserialize<::performance_manager::mojom::WebUIProcessInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUIGraphChangeStream_ProcessChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUIGraphChangeStream_FavIconDataAvailable_ParamsDataView {
 public:
  WebUIGraphChangeStream_FavIconDataAvailable_ParamsDataView() {}

  WebUIGraphChangeStream_FavIconDataAvailable_ParamsDataView(
      internal::WebUIGraphChangeStream_FavIconDataAvailable_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFaviconDataView(
      WebUIFavIconInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFavicon(UserType* output) {
    auto* pointer = data_->favicon.Get();
    return mojo::internal::Deserialize<::performance_manager::mojom::WebUIFavIconInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUIGraphChangeStream_FavIconDataAvailable_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class WebUIGraphChangeStream_NodeDeleted_ParamsDataView {
 public:
  WebUIGraphChangeStream_NodeDeleted_ParamsDataView() {}

  WebUIGraphChangeStream_NodeDeleted_ParamsDataView(
      internal::WebUIGraphChangeStream_NodeDeleted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t node_id() const {
    return data_->node_id;
  }
 private:
  internal::WebUIGraphChangeStream_NodeDeleted_Params_Data* data_ = nullptr;
};

class WebUIGraphDump_SubscribeToChanges_ParamsDataView {
 public:
  WebUIGraphDump_SubscribeToChanges_ParamsDataView() {}

  WebUIGraphDump_SubscribeToChanges_ParamsDataView(
      internal::WebUIGraphDump_SubscribeToChanges_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeChangeSubscriber() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::performance_manager::mojom::WebUIGraphChangeStreamPtrDataView>(
            &data_->change_subscriber, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::WebUIGraphDump_SubscribeToChanges_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void WebUIGraphChangeStream_FrameCreated_ParamsDataView::GetFrameDataView(
    WebUIFrameInfoDataView* output) {
  auto pointer = data_->frame.Get();
  *output = WebUIFrameInfoDataView(pointer, context_);
}


inline void WebUIGraphChangeStream_PageCreated_ParamsDataView::GetPagesDataView(
    WebUIPageInfoDataView* output) {
  auto pointer = data_->pages.Get();
  *output = WebUIPageInfoDataView(pointer, context_);
}


inline void WebUIGraphChangeStream_ProcessCreated_ParamsDataView::GetProcessDataView(
    WebUIProcessInfoDataView* output) {
  auto pointer = data_->process.Get();
  *output = WebUIProcessInfoDataView(pointer, context_);
}


inline void WebUIGraphChangeStream_FrameChanged_ParamsDataView::GetFrameDataView(
    WebUIFrameInfoDataView* output) {
  auto pointer = data_->frame.Get();
  *output = WebUIFrameInfoDataView(pointer, context_);
}


inline void WebUIGraphChangeStream_PageChanged_ParamsDataView::GetPageDataView(
    WebUIPageInfoDataView* output) {
  auto pointer = data_->page.Get();
  *output = WebUIPageInfoDataView(pointer, context_);
}


inline void WebUIGraphChangeStream_ProcessChanged_ParamsDataView::GetProcessDataView(
    WebUIProcessInfoDataView* output) {
  auto pointer = data_->process.Get();
  *output = WebUIProcessInfoDataView(pointer, context_);
}


inline void WebUIGraphChangeStream_FavIconDataAvailable_ParamsDataView::GetFaviconDataView(
    WebUIFavIconInfoDataView* output) {
  auto pointer = data_->favicon.Get();
  *output = WebUIFavIconInfoDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace performance_manager

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_PARAMS_DATA_H_