// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_SHARED_INTERNAL_H_
#define CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/process_id.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace performance_manager {
namespace mojom {
namespace internal {
class WebUIPageInfo_Data;
class WebUIFrameInfo_Data;
class WebUIProcessInfo_Data;
class WebUIFavIconInfo_Data;

#pragma pack(push, 1)
class  WebUIPageInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIPageInfo_Data));
      new (data()) WebUIPageInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIPageInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIPageInfo_Data>(index_);
    }
    WebUIPageInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t id;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> main_frame_url;

 private:
  WebUIPageInfo_Data();
  ~WebUIPageInfo_Data() = delete;
};
static_assert(sizeof(WebUIPageInfo_Data) == 24,
              "Bad sizeof(WebUIPageInfo_Data)");
// Used by WebUIPageInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WebUIPageInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WebUIPageInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WebUIPageInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WebUIPageInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WebUIPageInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  WebUIFrameInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIFrameInfo_Data));
      new (data()) WebUIFrameInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIFrameInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIFrameInfo_Data>(index_);
    }
    WebUIFrameInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t id;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  int64_t page_id;
  int64_t parent_frame_id;
  int64_t process_id;

 private:
  WebUIFrameInfo_Data();
  ~WebUIFrameInfo_Data() = delete;
};
static_assert(sizeof(WebUIFrameInfo_Data) == 48,
              "Bad sizeof(WebUIFrameInfo_Data)");
// Used by WebUIFrameInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WebUIFrameInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WebUIFrameInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WebUIFrameInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WebUIFrameInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WebUIFrameInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  WebUIProcessInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIProcessInfo_Data));
      new (data()) WebUIProcessInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIProcessInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIProcessInfo_Data>(index_);
    }
    WebUIProcessInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t id;
  mojo::internal::Pointer<::mojo_base::mojom::internal::ProcessId_Data> pid;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> cumulative_cpu_usage;
  uint64_t private_footprint_kb;

 private:
  WebUIProcessInfo_Data();
  ~WebUIProcessInfo_Data() = delete;
};
static_assert(sizeof(WebUIProcessInfo_Data) == 40,
              "Bad sizeof(WebUIProcessInfo_Data)");
// Used by WebUIProcessInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WebUIProcessInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WebUIProcessInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WebUIProcessInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WebUIProcessInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WebUIProcessInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  WebUIFavIconInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIFavIconInfo_Data));
      new (data()) WebUIFavIconInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIFavIconInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIFavIconInfo_Data>(index_);
    }
    WebUIFavIconInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t node_id;
  mojo::internal::Pointer<mojo::internal::String_Data> icon_data;

 private:
  WebUIFavIconInfo_Data();
  ~WebUIFavIconInfo_Data() = delete;
};
static_assert(sizeof(WebUIFavIconInfo_Data) == 24,
              "Bad sizeof(WebUIFavIconInfo_Data)");
// Used by WebUIFavIconInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WebUIFavIconInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WebUIFavIconInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WebUIFavIconInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WebUIFavIconInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WebUIFavIconInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace performance_manager

#endif  // CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_SHARED_INTERNAL_H_