// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/browser/performance_manager/webui_graph_dump.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/process_id.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "url/mojom/url.mojom.h"


#ifndef CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_JUMBO_H_
#define CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/process_id_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace performance_manager {
namespace mojom {


void WebUIGraphChangeStreamInterceptorForTesting::FrameCreated(WebUIFrameInfoPtr frame) {
  GetForwardingInterface()->FrameCreated(std::move(frame));
}
void WebUIGraphChangeStreamInterceptorForTesting::PageCreated(WebUIPageInfoPtr pages) {
  GetForwardingInterface()->PageCreated(std::move(pages));
}
void WebUIGraphChangeStreamInterceptorForTesting::ProcessCreated(WebUIProcessInfoPtr process) {
  GetForwardingInterface()->ProcessCreated(std::move(process));
}
void WebUIGraphChangeStreamInterceptorForTesting::FrameChanged(WebUIFrameInfoPtr frame) {
  GetForwardingInterface()->FrameChanged(std::move(frame));
}
void WebUIGraphChangeStreamInterceptorForTesting::PageChanged(WebUIPageInfoPtr page) {
  GetForwardingInterface()->PageChanged(std::move(page));
}
void WebUIGraphChangeStreamInterceptorForTesting::ProcessChanged(WebUIProcessInfoPtr process) {
  GetForwardingInterface()->ProcessChanged(std::move(process));
}
void WebUIGraphChangeStreamInterceptorForTesting::FavIconDataAvailable(WebUIFavIconInfoPtr favicon) {
  GetForwardingInterface()->FavIconDataAvailable(std::move(favicon));
}
void WebUIGraphChangeStreamInterceptorForTesting::NodeDeleted(int64_t node_id) {
  GetForwardingInterface()->NodeDeleted(std::move(node_id));
}
WebUIGraphChangeStreamAsyncWaiter::WebUIGraphChangeStreamAsyncWaiter(
    WebUIGraphChangeStream* proxy) : proxy_(proxy) {}

WebUIGraphChangeStreamAsyncWaiter::~WebUIGraphChangeStreamAsyncWaiter() = default;




void WebUIGraphDumpInterceptorForTesting::SubscribeToChanges(WebUIGraphChangeStreamPtr change_subscriber) {
  GetForwardingInterface()->SubscribeToChanges(std::move(change_subscriber));
}
WebUIGraphDumpAsyncWaiter::WebUIGraphDumpAsyncWaiter(
    WebUIGraphDump* proxy) : proxy_(proxy) {}

WebUIGraphDumpAsyncWaiter::~WebUIGraphDumpAsyncWaiter() = default;






}  // namespace mojom
}  // namespace performance_manager

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif