// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_TEST_UTILS_H_
#define CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_TEST_UTILS_H_

#include "chrome/browser/performance_manager/webui_graph_dump.mojom.h"


namespace performance_manager {
namespace mojom {


class  WebUIGraphChangeStreamInterceptorForTesting : public WebUIGraphChangeStream {
  virtual WebUIGraphChangeStream* GetForwardingInterface() = 0;
  void FrameCreated(WebUIFrameInfoPtr frame) override;
  void PageCreated(WebUIPageInfoPtr pages) override;
  void ProcessCreated(WebUIProcessInfoPtr process) override;
  void FrameChanged(WebUIFrameInfoPtr frame) override;
  void PageChanged(WebUIPageInfoPtr page) override;
  void ProcessChanged(WebUIProcessInfoPtr process) override;
  void FavIconDataAvailable(WebUIFavIconInfoPtr favicon) override;
  void NodeDeleted(int64_t node_id) override;
};
class  WebUIGraphChangeStreamAsyncWaiter {
 public:
  explicit WebUIGraphChangeStreamAsyncWaiter(WebUIGraphChangeStream* proxy);
  ~WebUIGraphChangeStreamAsyncWaiter();

 private:
  WebUIGraphChangeStream* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WebUIGraphChangeStreamAsyncWaiter);
};


class  WebUIGraphDumpInterceptorForTesting : public WebUIGraphDump {
  virtual WebUIGraphDump* GetForwardingInterface() = 0;
  void SubscribeToChanges(WebUIGraphChangeStreamPtr change_subscriber) override;
};
class  WebUIGraphDumpAsyncWaiter {
 public:
  explicit WebUIGraphDumpAsyncWaiter(WebUIGraphDump* proxy);
  ~WebUIGraphDumpAsyncWaiter();

 private:
  WebUIGraphDump* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WebUIGraphDumpAsyncWaiter);
};




}  // namespace mojom
}  // namespace performance_manager

#endif  // CHROME_BROWSER_PERFORMANCE_MANAGER_WEBUI_GRAPH_DUMP_MOJOM_TEST_UTILS_H_