// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_PARAMS_DATA_H_
#define CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace app_management {
namespace mojom {
namespace internal {
class  PageHandlerFactory_CreatePageHandler_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandlerFactory_CreatePageHandler_Params_Data));
      new (data()) PageHandlerFactory_CreatePageHandler_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandlerFactory_CreatePageHandler_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandlerFactory_CreatePageHandler_Params_Data>(index_);
    }
    PageHandlerFactory_CreatePageHandler_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data page;
  mojo::internal::Handle_Data handler;
  uint8_t padfinal_[4];

 private:
  PageHandlerFactory_CreatePageHandler_Params_Data();
  ~PageHandlerFactory_CreatePageHandler_Params_Data() = delete;
};
static_assert(sizeof(PageHandlerFactory_CreatePageHandler_Params_Data) == 24,
              "Bad sizeof(PageHandlerFactory_CreatePageHandler_Params_Data)");
class  PageHandler_GetApps_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_GetApps_Params_Data));
      new (data()) PageHandler_GetApps_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_GetApps_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_GetApps_Params_Data>(index_);
    }
    PageHandler_GetApps_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageHandler_GetApps_Params_Data();
  ~PageHandler_GetApps_Params_Data() = delete;
};
static_assert(sizeof(PageHandler_GetApps_Params_Data) == 8,
              "Bad sizeof(PageHandler_GetApps_Params_Data)");
class  PageHandler_GetApps_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_GetApps_ResponseParams_Data));
      new (data()) PageHandler_GetApps_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_GetApps_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_GetApps_ResponseParams_Data>(index_);
    }
    PageHandler_GetApps_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::App_Data>>> apps;

 private:
  PageHandler_GetApps_ResponseParams_Data();
  ~PageHandler_GetApps_ResponseParams_Data() = delete;
};
static_assert(sizeof(PageHandler_GetApps_ResponseParams_Data) == 16,
              "Bad sizeof(PageHandler_GetApps_ResponseParams_Data)");
class  PageHandler_GetExtensionAppPermissionMessages_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_GetExtensionAppPermissionMessages_Params_Data));
      new (data()) PageHandler_GetExtensionAppPermissionMessages_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_GetExtensionAppPermissionMessages_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_GetExtensionAppPermissionMessages_Params_Data>(index_);
    }
    PageHandler_GetExtensionAppPermissionMessages_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;

 private:
  PageHandler_GetExtensionAppPermissionMessages_Params_Data();
  ~PageHandler_GetExtensionAppPermissionMessages_Params_Data() = delete;
};
static_assert(sizeof(PageHandler_GetExtensionAppPermissionMessages_Params_Data) == 16,
              "Bad sizeof(PageHandler_GetExtensionAppPermissionMessages_Params_Data)");
class  PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data));
      new (data()) PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data>(index_);
    }
    PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::ExtensionAppPermissionMessage_Data>>> messages;

 private:
  PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data();
  ~PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data() = delete;
};
static_assert(sizeof(PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data) == 16,
              "Bad sizeof(PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data)");
class  PageHandler_SetPinned_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_SetPinned_Params_Data));
      new (data()) PageHandler_SetPinned_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_SetPinned_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_SetPinned_Params_Data>(index_);
    }
    PageHandler_SetPinned_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;
  int32_t pinned;
  uint8_t padfinal_[4];

 private:
  PageHandler_SetPinned_Params_Data();
  ~PageHandler_SetPinned_Params_Data() = delete;
};
static_assert(sizeof(PageHandler_SetPinned_Params_Data) == 24,
              "Bad sizeof(PageHandler_SetPinned_Params_Data)");
class  PageHandler_SetPermission_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_SetPermission_Params_Data));
      new (data()) PageHandler_SetPermission_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_SetPermission_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_SetPermission_Params_Data>(index_);
    }
    PageHandler_SetPermission_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;
  mojo::internal::Pointer<::apps::mojom::internal::Permission_Data> permission;

 private:
  PageHandler_SetPermission_Params_Data();
  ~PageHandler_SetPermission_Params_Data() = delete;
};
static_assert(sizeof(PageHandler_SetPermission_Params_Data) == 24,
              "Bad sizeof(PageHandler_SetPermission_Params_Data)");
class  PageHandler_Uninstall_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_Uninstall_Params_Data));
      new (data()) PageHandler_Uninstall_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_Uninstall_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_Uninstall_Params_Data>(index_);
    }
    PageHandler_Uninstall_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;

 private:
  PageHandler_Uninstall_Params_Data();
  ~PageHandler_Uninstall_Params_Data() = delete;
};
static_assert(sizeof(PageHandler_Uninstall_Params_Data) == 16,
              "Bad sizeof(PageHandler_Uninstall_Params_Data)");
class  PageHandler_OpenNativeSettings_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_OpenNativeSettings_Params_Data));
      new (data()) PageHandler_OpenNativeSettings_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_OpenNativeSettings_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_OpenNativeSettings_Params_Data>(index_);
    }
    PageHandler_OpenNativeSettings_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;

 private:
  PageHandler_OpenNativeSettings_Params_Data();
  ~PageHandler_OpenNativeSettings_Params_Data() = delete;
};
static_assert(sizeof(PageHandler_OpenNativeSettings_Params_Data) == 16,
              "Bad sizeof(PageHandler_OpenNativeSettings_Params_Data)");
class  Page_OnAppAdded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Page_OnAppAdded_Params_Data));
      new (data()) Page_OnAppAdded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Page_OnAppAdded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Page_OnAppAdded_Params_Data>(index_);
    }
    Page_OnAppAdded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::App_Data> app;

 private:
  Page_OnAppAdded_Params_Data();
  ~Page_OnAppAdded_Params_Data() = delete;
};
static_assert(sizeof(Page_OnAppAdded_Params_Data) == 16,
              "Bad sizeof(Page_OnAppAdded_Params_Data)");
class  Page_OnAppChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Page_OnAppChanged_Params_Data));
      new (data()) Page_OnAppChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Page_OnAppChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Page_OnAppChanged_Params_Data>(index_);
    }
    Page_OnAppChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::App_Data> update;

 private:
  Page_OnAppChanged_Params_Data();
  ~Page_OnAppChanged_Params_Data() = delete;
};
static_assert(sizeof(Page_OnAppChanged_Params_Data) == 16,
              "Bad sizeof(Page_OnAppChanged_Params_Data)");
class  Page_OnAppRemoved_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Page_OnAppRemoved_Params_Data));
      new (data()) Page_OnAppRemoved_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Page_OnAppRemoved_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Page_OnAppRemoved_Params_Data>(index_);
    }
    Page_OnAppRemoved_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;

 private:
  Page_OnAppRemoved_Params_Data();
  ~Page_OnAppRemoved_Params_Data() = delete;
};
static_assert(sizeof(Page_OnAppRemoved_Params_Data) == 16,
              "Bad sizeof(Page_OnAppRemoved_Params_Data)");

}  // namespace internal
class PageHandlerFactory_CreatePageHandler_ParamsDataView {
 public:
  PageHandlerFactory_CreatePageHandler_ParamsDataView() {}

  PageHandlerFactory_CreatePageHandler_ParamsDataView(
      internal::PageHandlerFactory_CreatePageHandler_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakePage() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::app_management::mojom::PagePtrDataView>(
            &data_->page, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeHandler() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::app_management::mojom::PageHandlerRequestDataView>(
            &data_->handler, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::PageHandlerFactory_CreatePageHandler_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageHandler_GetApps_ParamsDataView {
 public:
  PageHandler_GetApps_ParamsDataView() {}

  PageHandler_GetApps_ParamsDataView(
      internal::PageHandler_GetApps_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PageHandler_GetApps_Params_Data* data_ = nullptr;
};

class PageHandler_GetApps_ResponseParamsDataView {
 public:
  PageHandler_GetApps_ResponseParamsDataView() {}

  PageHandler_GetApps_ResponseParamsDataView(
      internal::PageHandler_GetApps_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppsDataView(
      mojo::ArrayDataView<AppDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadApps(UserType* output) {
    auto* pointer = data_->apps.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::app_management::mojom::AppDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PageHandler_GetApps_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageHandler_GetExtensionAppPermissionMessages_ParamsDataView {
 public:
  PageHandler_GetExtensionAppPermissionMessages_ParamsDataView() {}

  PageHandler_GetExtensionAppPermissionMessages_ParamsDataView(
      internal::PageHandler_GetExtensionAppPermissionMessages_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppId(UserType* output) {
    auto* pointer = data_->app_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageHandler_GetExtensionAppPermissionMessages_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageHandler_GetExtensionAppPermissionMessages_ResponseParamsDataView {
 public:
  PageHandler_GetExtensionAppPermissionMessages_ResponseParamsDataView() {}

  PageHandler_GetExtensionAppPermissionMessages_ResponseParamsDataView(
      internal::PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMessagesDataView(
      mojo::ArrayDataView<ExtensionAppPermissionMessageDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessages(UserType* output) {
    auto* pointer = data_->messages.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::app_management::mojom::ExtensionAppPermissionMessageDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PageHandler_GetExtensionAppPermissionMessages_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageHandler_SetPinned_ParamsDataView {
 public:
  PageHandler_SetPinned_ParamsDataView() {}

  PageHandler_SetPinned_ParamsDataView(
      internal::PageHandler_SetPinned_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppId(UserType* output) {
    auto* pointer = data_->app_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPinned(UserType* output) const {
    auto data_value = data_->pinned;
    return mojo::internal::Deserialize<::apps::mojom::OptionalBool>(
        data_value, output);
  }

  ::apps::mojom::OptionalBool pinned() const {
    return static_cast<::apps::mojom::OptionalBool>(data_->pinned);
  }
 private:
  internal::PageHandler_SetPinned_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageHandler_SetPermission_ParamsDataView {
 public:
  PageHandler_SetPermission_ParamsDataView() {}

  PageHandler_SetPermission_ParamsDataView(
      internal::PageHandler_SetPermission_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppId(UserType* output) {
    auto* pointer = data_->app_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetPermissionDataView(
      ::apps::mojom::PermissionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPermission(UserType* output) {
    auto* pointer = data_->permission.Get();
    return mojo::internal::Deserialize<::apps::mojom::PermissionDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageHandler_SetPermission_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageHandler_Uninstall_ParamsDataView {
 public:
  PageHandler_Uninstall_ParamsDataView() {}

  PageHandler_Uninstall_ParamsDataView(
      internal::PageHandler_Uninstall_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppId(UserType* output) {
    auto* pointer = data_->app_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageHandler_Uninstall_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageHandler_OpenNativeSettings_ParamsDataView {
 public:
  PageHandler_OpenNativeSettings_ParamsDataView() {}

  PageHandler_OpenNativeSettings_ParamsDataView(
      internal::PageHandler_OpenNativeSettings_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppId(UserType* output) {
    auto* pointer = data_->app_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageHandler_OpenNativeSettings_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Page_OnAppAdded_ParamsDataView {
 public:
  Page_OnAppAdded_ParamsDataView() {}

  Page_OnAppAdded_ParamsDataView(
      internal::Page_OnAppAdded_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppDataView(
      AppDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadApp(UserType* output) {
    auto* pointer = data_->app.Get();
    return mojo::internal::Deserialize<::app_management::mojom::AppDataView>(
        pointer, output, context_);
  }
 private:
  internal::Page_OnAppAdded_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Page_OnAppChanged_ParamsDataView {
 public:
  Page_OnAppChanged_ParamsDataView() {}

  Page_OnAppChanged_ParamsDataView(
      internal::Page_OnAppChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUpdateDataView(
      AppDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdate(UserType* output) {
    auto* pointer = data_->update.Get();
    return mojo::internal::Deserialize<::app_management::mojom::AppDataView>(
        pointer, output, context_);
  }
 private:
  internal::Page_OnAppChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Page_OnAppRemoved_ParamsDataView {
 public:
  Page_OnAppRemoved_ParamsDataView() {}

  Page_OnAppRemoved_ParamsDataView(
      internal::Page_OnAppRemoved_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAppIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAppId(UserType* output) {
    auto* pointer = data_->app_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::Page_OnAppRemoved_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};






inline void PageHandler_GetApps_ResponseParamsDataView::GetAppsDataView(
    mojo::ArrayDataView<AppDataView>* output) {
  auto pointer = data_->apps.Get();
  *output = mojo::ArrayDataView<AppDataView>(pointer, context_);
}


inline void PageHandler_GetExtensionAppPermissionMessages_ParamsDataView::GetAppIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->app_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void PageHandler_GetExtensionAppPermissionMessages_ResponseParamsDataView::GetMessagesDataView(
    mojo::ArrayDataView<ExtensionAppPermissionMessageDataView>* output) {
  auto pointer = data_->messages.Get();
  *output = mojo::ArrayDataView<ExtensionAppPermissionMessageDataView>(pointer, context_);
}


inline void PageHandler_SetPinned_ParamsDataView::GetAppIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->app_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void PageHandler_SetPermission_ParamsDataView::GetAppIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->app_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void PageHandler_SetPermission_ParamsDataView::GetPermissionDataView(
    ::apps::mojom::PermissionDataView* output) {
  auto pointer = data_->permission.Get();
  *output = ::apps::mojom::PermissionDataView(pointer, context_);
}


inline void PageHandler_Uninstall_ParamsDataView::GetAppIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->app_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void PageHandler_OpenNativeSettings_ParamsDataView::GetAppIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->app_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void Page_OnAppAdded_ParamsDataView::GetAppDataView(
    AppDataView* output) {
  auto pointer = data_->app.Get();
  *output = AppDataView(pointer, context_);
}


inline void Page_OnAppChanged_ParamsDataView::GetUpdateDataView(
    AppDataView* output) {
  auto pointer = data_->update.Get();
  *output = AppDataView(pointer, context_);
}


inline void Page_OnAppRemoved_ParamsDataView::GetAppIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->app_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace app_management

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_PARAMS_DATA_H_