// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/browser/ui/webui/app_management/app_management.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "chrome/services/app_service/public/mojom/types.mojom.h"


#ifndef CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_JUMBO_H_
#define CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_JUMBO_H_
#endif


namespace app_management {
namespace mojom {


void PageHandlerFactoryInterceptorForTesting::CreatePageHandler(PagePtr page, PageHandlerRequest handler) {
  GetForwardingInterface()->CreatePageHandler(std::move(page), std::move(handler));
}
PageHandlerFactoryAsyncWaiter::PageHandlerFactoryAsyncWaiter(
    PageHandlerFactory* proxy) : proxy_(proxy) {}

PageHandlerFactoryAsyncWaiter::~PageHandlerFactoryAsyncWaiter() = default;




void PageHandlerInterceptorForTesting::GetApps(GetAppsCallback callback) {
  GetForwardingInterface()->GetApps(std::move(callback));
}
void PageHandlerInterceptorForTesting::GetExtensionAppPermissionMessages(const std::string& app_id, GetExtensionAppPermissionMessagesCallback callback) {
  GetForwardingInterface()->GetExtensionAppPermissionMessages(std::move(app_id), std::move(callback));
}
void PageHandlerInterceptorForTesting::SetPinned(const std::string& app_id, ::apps::mojom::OptionalBool pinned) {
  GetForwardingInterface()->SetPinned(std::move(app_id), std::move(pinned));
}
void PageHandlerInterceptorForTesting::SetPermission(const std::string& app_id, ::apps::mojom::PermissionPtr permission) {
  GetForwardingInterface()->SetPermission(std::move(app_id), std::move(permission));
}
void PageHandlerInterceptorForTesting::Uninstall(const std::string& app_id) {
  GetForwardingInterface()->Uninstall(std::move(app_id));
}
void PageHandlerInterceptorForTesting::OpenNativeSettings(const std::string& app_id) {
  GetForwardingInterface()->OpenNativeSettings(std::move(app_id));
}
PageHandlerAsyncWaiter::PageHandlerAsyncWaiter(
    PageHandler* proxy) : proxy_(proxy) {}

PageHandlerAsyncWaiter::~PageHandlerAsyncWaiter() = default;

void PageHandlerAsyncWaiter::GetApps(
    std::vector<AppPtr>* out_apps) {
  base::RunLoop loop;
  proxy_->GetApps(
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<AppPtr>* out_apps
,
             std::vector<AppPtr> apps) {*out_apps = std::move(apps);
            loop->Quit();
          },
          &loop,
          out_apps));
  loop.Run();
}
void PageHandlerAsyncWaiter::GetExtensionAppPermissionMessages(
    const std::string& app_id, std::vector<ExtensionAppPermissionMessagePtr>* out_messages) {
  base::RunLoop loop;
  proxy_->GetExtensionAppPermissionMessages(std::move(app_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<ExtensionAppPermissionMessagePtr>* out_messages
,
             std::vector<ExtensionAppPermissionMessagePtr> messages) {*out_messages = std::move(messages);
            loop->Quit();
          },
          &loop,
          out_messages));
  loop.Run();
}



void PageInterceptorForTesting::OnAppAdded(AppPtr app) {
  GetForwardingInterface()->OnAppAdded(std::move(app));
}
void PageInterceptorForTesting::OnAppChanged(AppPtr update) {
  GetForwardingInterface()->OnAppChanged(std::move(update));
}
void PageInterceptorForTesting::OnAppRemoved(const std::string& app_id) {
  GetForwardingInterface()->OnAppRemoved(std::move(app_id));
}
PageAsyncWaiter::PageAsyncWaiter(
    Page* proxy) : proxy_(proxy) {}

PageAsyncWaiter::~PageAsyncWaiter() = default;






}  // namespace mojom
}  // namespace app_management

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif