// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/browser/ui/webui/bluetooth_internals/bluetooth_internals.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "device/bluetooth/public/mojom/adapter.mojom.h"


#ifndef CHROME_BROWSER_UI_WEBUI_BLUETOOTH_INTERNALS_BLUETOOTH_INTERNALS_MOJOM_JUMBO_H_
#define CHROME_BROWSER_UI_WEBUI_BLUETOOTH_INTERNALS_BLUETOOTH_INTERNALS_MOJOM_JUMBO_H_
#endif


namespace mojom {


void BluetoothInternalsHandlerInterceptorForTesting::GetAdapter(GetAdapterCallback callback) {
  GetForwardingInterface()->GetAdapter(std::move(callback));
}
BluetoothInternalsHandlerAsyncWaiter::BluetoothInternalsHandlerAsyncWaiter(
    BluetoothInternalsHandler* proxy) : proxy_(proxy) {}

BluetoothInternalsHandlerAsyncWaiter::~BluetoothInternalsHandlerAsyncWaiter() = default;

void BluetoothInternalsHandlerAsyncWaiter::GetAdapter(
    ::bluetooth::mojom::AdapterPtr* out_adapter) {
  base::RunLoop loop;
  proxy_->GetAdapter(
      base::BindOnce(
          [](base::RunLoop* loop,
             ::bluetooth::mojom::AdapterPtr* out_adapter
,
             ::bluetooth::mojom::AdapterPtr adapter) {*out_adapter = std::move(adapter);
            loop->Quit();
          },
          &loop,
          out_adapter));
  loop.Run();
}





}  // namespace mojom

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif