// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_PARAMS_DATA_H_
#define CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace mojom {
namespace internal {
class  DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data));
      new (data()) DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data>(index_);
    }
    DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data();
  ~DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data) == 8,
              "Bad sizeof(DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data)");
class  DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data));
      new (data()) DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data>(index_);
    }
    DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::TabDiscardsInfo_Data>>> infos;

 private:
  DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data();
  ~DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data)");
class  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data));
      new (data()) DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data>(index_);
    }
    DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> explicitly_requested_origins;

 private:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data();
  ~DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data)");
class  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data));
      new (data()) DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data>(index_);
    }
    DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::SiteCharacteristicsDatabase_Data> result;

 private:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data();
  ~DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data)");
class  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data));
      new (data()) DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data>(index_);
    }
    DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data();
  ~DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data) == 8,
              "Bad sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data)");
class  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data));
      new (data()) DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data>(index_);
    }
    DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::SiteCharacteristicsDatabaseSize_Data> db_size;

 private:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data();
  ~DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data)");
class  DiscardsDetailsProvider_SetAutoDiscardable_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_SetAutoDiscardable_Params_Data));
      new (data()) DiscardsDetailsProvider_SetAutoDiscardable_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_SetAutoDiscardable_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_SetAutoDiscardable_Params_Data>(index_);
    }
    DiscardsDetailsProvider_SetAutoDiscardable_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t tab_id;
  uint8_t is_auto_discardable : 1;
  uint8_t padfinal_[3];

 private:
  DiscardsDetailsProvider_SetAutoDiscardable_Params_Data();
  ~DiscardsDetailsProvider_SetAutoDiscardable_Params_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_SetAutoDiscardable_Params_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_SetAutoDiscardable_Params_Data)");
class  DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data));
      new (data()) DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data>(index_);
    }
    DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data();
  ~DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data) == 8,
              "Bad sizeof(DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data)");
class  DiscardsDetailsProvider_DiscardById_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_DiscardById_Params_Data));
      new (data()) DiscardsDetailsProvider_DiscardById_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_DiscardById_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_DiscardById_Params_Data>(index_);
    }
    DiscardsDetailsProvider_DiscardById_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t tab_id;
  uint8_t urgent : 1;
  uint8_t padfinal_[3];

 private:
  DiscardsDetailsProvider_DiscardById_Params_Data();
  ~DiscardsDetailsProvider_DiscardById_Params_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_DiscardById_Params_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_DiscardById_Params_Data)");
class  DiscardsDetailsProvider_DiscardById_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_DiscardById_ResponseParams_Data));
      new (data()) DiscardsDetailsProvider_DiscardById_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_DiscardById_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_DiscardById_ResponseParams_Data>(index_);
    }
    DiscardsDetailsProvider_DiscardById_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DiscardsDetailsProvider_DiscardById_ResponseParams_Data();
  ~DiscardsDetailsProvider_DiscardById_ResponseParams_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_DiscardById_ResponseParams_Data) == 8,
              "Bad sizeof(DiscardsDetailsProvider_DiscardById_ResponseParams_Data)");
class  DiscardsDetailsProvider_FreezeById_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_FreezeById_Params_Data));
      new (data()) DiscardsDetailsProvider_FreezeById_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_FreezeById_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_FreezeById_Params_Data>(index_);
    }
    DiscardsDetailsProvider_FreezeById_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t tab_id;
  uint8_t padfinal_[4];

 private:
  DiscardsDetailsProvider_FreezeById_Params_Data();
  ~DiscardsDetailsProvider_FreezeById_Params_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_FreezeById_Params_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_FreezeById_Params_Data)");
class  DiscardsDetailsProvider_LoadById_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_LoadById_Params_Data));
      new (data()) DiscardsDetailsProvider_LoadById_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_LoadById_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_LoadById_Params_Data>(index_);
    }
    DiscardsDetailsProvider_LoadById_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t tab_id;
  uint8_t padfinal_[4];

 private:
  DiscardsDetailsProvider_LoadById_Params_Data();
  ~DiscardsDetailsProvider_LoadById_Params_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_LoadById_Params_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_LoadById_Params_Data)");
class  DiscardsDetailsProvider_Discard_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_Discard_Params_Data));
      new (data()) DiscardsDetailsProvider_Discard_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_Discard_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_Discard_Params_Data>(index_);
    }
    DiscardsDetailsProvider_Discard_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t urgent : 1;
  uint8_t padfinal_[7];

 private:
  DiscardsDetailsProvider_Discard_Params_Data();
  ~DiscardsDetailsProvider_Discard_Params_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_Discard_Params_Data) == 16,
              "Bad sizeof(DiscardsDetailsProvider_Discard_Params_Data)");
class  DiscardsDetailsProvider_Discard_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DiscardsDetailsProvider_Discard_ResponseParams_Data));
      new (data()) DiscardsDetailsProvider_Discard_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DiscardsDetailsProvider_Discard_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DiscardsDetailsProvider_Discard_ResponseParams_Data>(index_);
    }
    DiscardsDetailsProvider_Discard_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DiscardsDetailsProvider_Discard_ResponseParams_Data();
  ~DiscardsDetailsProvider_Discard_ResponseParams_Data() = delete;
};
static_assert(sizeof(DiscardsDetailsProvider_Discard_ResponseParams_Data) == 8,
              "Bad sizeof(DiscardsDetailsProvider_Discard_ResponseParams_Data)");

}  // namespace internal
class DiscardsDetailsProvider_GetTabDiscardsInfo_ParamsDataView {
 public:
  DiscardsDetailsProvider_GetTabDiscardsInfo_ParamsDataView() {}

  DiscardsDetailsProvider_GetTabDiscardsInfo_ParamsDataView(
      internal::DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParamsDataView {
 public:
  DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParamsDataView() {}

  DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParamsDataView(
      internal::DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetInfosDataView(
      mojo::ArrayDataView<TabDiscardsInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInfos(UserType* output) {
    auto* pointer = data_->infos.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::mojom::TabDiscardsInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ParamsDataView {
 public:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ParamsDataView() {}

  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ParamsDataView(
      internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetExplicitlyRequestedOriginsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadExplicitlyRequestedOrigins(UserType* output) {
    auto* pointer = data_->explicitly_requested_origins.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
 private:
  internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParamsDataView {
 public:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParamsDataView() {}

  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParamsDataView(
      internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetResultDataView(
      SiteCharacteristicsDatabaseDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) {
    auto* pointer = data_->result.Get();
    return mojo::internal::Deserialize<::mojom::SiteCharacteristicsDatabaseDataView>(
        pointer, output, context_);
  }
 private:
  internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ParamsDataView {
 public:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ParamsDataView() {}

  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ParamsDataView(
      internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParamsDataView {
 public:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParamsDataView() {}

  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParamsDataView(
      internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDbSizeDataView(
      SiteCharacteristicsDatabaseSizeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDbSize(UserType* output) {
    auto* pointer = data_->db_size.Get();
    return mojo::internal::Deserialize<::mojom::SiteCharacteristicsDatabaseSizeDataView>(
        pointer, output, context_);
  }
 private:
  internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DiscardsDetailsProvider_SetAutoDiscardable_ParamsDataView {
 public:
  DiscardsDetailsProvider_SetAutoDiscardable_ParamsDataView() {}

  DiscardsDetailsProvider_SetAutoDiscardable_ParamsDataView(
      internal::DiscardsDetailsProvider_SetAutoDiscardable_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t tab_id() const {
    return data_->tab_id;
  }
  bool is_auto_discardable() const {
    return data_->is_auto_discardable;
  }
 private:
  internal::DiscardsDetailsProvider_SetAutoDiscardable_Params_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_SetAutoDiscardable_ResponseParamsDataView {
 public:
  DiscardsDetailsProvider_SetAutoDiscardable_ResponseParamsDataView() {}

  DiscardsDetailsProvider_SetAutoDiscardable_ResponseParamsDataView(
      internal::DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_DiscardById_ParamsDataView {
 public:
  DiscardsDetailsProvider_DiscardById_ParamsDataView() {}

  DiscardsDetailsProvider_DiscardById_ParamsDataView(
      internal::DiscardsDetailsProvider_DiscardById_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t tab_id() const {
    return data_->tab_id;
  }
  bool urgent() const {
    return data_->urgent;
  }
 private:
  internal::DiscardsDetailsProvider_DiscardById_Params_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_DiscardById_ResponseParamsDataView {
 public:
  DiscardsDetailsProvider_DiscardById_ResponseParamsDataView() {}

  DiscardsDetailsProvider_DiscardById_ResponseParamsDataView(
      internal::DiscardsDetailsProvider_DiscardById_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DiscardsDetailsProvider_DiscardById_ResponseParams_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_FreezeById_ParamsDataView {
 public:
  DiscardsDetailsProvider_FreezeById_ParamsDataView() {}

  DiscardsDetailsProvider_FreezeById_ParamsDataView(
      internal::DiscardsDetailsProvider_FreezeById_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t tab_id() const {
    return data_->tab_id;
  }
 private:
  internal::DiscardsDetailsProvider_FreezeById_Params_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_LoadById_ParamsDataView {
 public:
  DiscardsDetailsProvider_LoadById_ParamsDataView() {}

  DiscardsDetailsProvider_LoadById_ParamsDataView(
      internal::DiscardsDetailsProvider_LoadById_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t tab_id() const {
    return data_->tab_id;
  }
 private:
  internal::DiscardsDetailsProvider_LoadById_Params_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_Discard_ParamsDataView {
 public:
  DiscardsDetailsProvider_Discard_ParamsDataView() {}

  DiscardsDetailsProvider_Discard_ParamsDataView(
      internal::DiscardsDetailsProvider_Discard_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool urgent() const {
    return data_->urgent;
  }
 private:
  internal::DiscardsDetailsProvider_Discard_Params_Data* data_ = nullptr;
};

class DiscardsDetailsProvider_Discard_ResponseParamsDataView {
 public:
  DiscardsDetailsProvider_Discard_ResponseParamsDataView() {}

  DiscardsDetailsProvider_Discard_ResponseParamsDataView(
      internal::DiscardsDetailsProvider_Discard_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DiscardsDetailsProvider_Discard_ResponseParams_Data* data_ = nullptr;
};




inline void DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParamsDataView::GetInfosDataView(
    mojo::ArrayDataView<TabDiscardsInfoDataView>* output) {
  auto pointer = data_->infos.Get();
  *output = mojo::ArrayDataView<TabDiscardsInfoDataView>(pointer, context_);
}


inline void DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ParamsDataView::GetExplicitlyRequestedOriginsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->explicitly_requested_origins.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}


inline void DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParamsDataView::GetResultDataView(
    SiteCharacteristicsDatabaseDataView* output) {
  auto pointer = data_->result.Get();
  *output = SiteCharacteristicsDatabaseDataView(pointer, context_);
}




inline void DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParamsDataView::GetDbSizeDataView(
    SiteCharacteristicsDatabaseSizeDataView* output) {
  auto pointer = data_->db_size.Get();
  *output = SiteCharacteristicsDatabaseSizeDataView(pointer, context_);
}

















}  // namespace mojom

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_PARAMS_DATA_H_