// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_SHARED_H_
#define CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/browser/ui/webui/discards/discards.mojom-shared-internal.h"
#include "chrome/browser/resource_coordinator/lifecycle_unit_state.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace mojom {
class SiteCharacteristicsFeatureDataView;

class SiteCharacteristicsPerformanceMeasurementDataView;

class SiteCharacteristicsDatabaseSizeDataView;

class SiteCharacteristicsDatabaseValueDataView;

class SiteCharacteristicsDatabaseEntryDataView;

class SiteCharacteristicsDatabaseDataView;

class TabDiscardsInfoDataView;



}  // namespace mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::mojom::SiteCharacteristicsFeatureDataView> {
  using Data = ::mojom::internal::SiteCharacteristicsFeature_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::mojom::SiteCharacteristicsPerformanceMeasurementDataView> {
  using Data = ::mojom::internal::SiteCharacteristicsPerformanceMeasurement_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::mojom::SiteCharacteristicsDatabaseSizeDataView> {
  using Data = ::mojom::internal::SiteCharacteristicsDatabaseSize_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::mojom::SiteCharacteristicsDatabaseValueDataView> {
  using Data = ::mojom::internal::SiteCharacteristicsDatabaseValue_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::mojom::SiteCharacteristicsDatabaseEntryDataView> {
  using Data = ::mojom::internal::SiteCharacteristicsDatabaseEntry_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::mojom::SiteCharacteristicsDatabaseDataView> {
  using Data = ::mojom::internal::SiteCharacteristicsDatabase_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

template <>
struct MojomTypeTraits<::mojom::TabDiscardsInfoDataView> {
  using Data = ::mojom::internal::TabDiscardsInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace mojom {


enum class LifecycleUnitVisibility : int32_t {
  
  HIDDEN = 0,
  
  OCCLUDED = 1,
  
  VISIBLE = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, LifecycleUnitVisibility value);
inline bool IsKnownEnumValue(LifecycleUnitVisibility value) {
  return internal::LifecycleUnitVisibility_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class DiscardsDetailsProviderInterfaceBase {};

using DiscardsDetailsProviderPtrDataView =
    mojo::InterfacePtrDataView<DiscardsDetailsProviderInterfaceBase>;
using DiscardsDetailsProviderRequestDataView =
    mojo::InterfaceRequestDataView<DiscardsDetailsProviderInterfaceBase>;
using DiscardsDetailsProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DiscardsDetailsProviderInterfaceBase>;
using DiscardsDetailsProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DiscardsDetailsProviderInterfaceBase>;
class SiteCharacteristicsFeatureDataView {
 public:
  SiteCharacteristicsFeatureDataView() {}

  SiteCharacteristicsFeatureDataView(
      internal::SiteCharacteristicsFeature_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t observation_duration() const {
    return data_->observation_duration;
  }
  int64_t use_timestamp() const {
    return data_->use_timestamp;
  }
 private:
  internal::SiteCharacteristicsFeature_Data* data_ = nullptr;
};

class SiteCharacteristicsPerformanceMeasurementDataView {
 public:
  SiteCharacteristicsPerformanceMeasurementDataView() {}

  SiteCharacteristicsPerformanceMeasurementDataView(
      internal::SiteCharacteristicsPerformanceMeasurement_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  float avg_cpu_usage_us() const {
    return data_->avg_cpu_usage_us;
  }
  float avg_footprint_kb() const {
    return data_->avg_footprint_kb;
  }
  float avg_load_duration_us() const {
    return data_->avg_load_duration_us;
  }
 private:
  internal::SiteCharacteristicsPerformanceMeasurement_Data* data_ = nullptr;
};

class SiteCharacteristicsDatabaseSizeDataView {
 public:
  SiteCharacteristicsDatabaseSizeDataView() {}

  SiteCharacteristicsDatabaseSizeDataView(
      internal::SiteCharacteristicsDatabaseSize_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t num_rows() const {
    return data_->num_rows;
  }
  int64_t on_disk_size_kb() const {
    return data_->on_disk_size_kb;
  }
 private:
  internal::SiteCharacteristicsDatabaseSize_Data* data_ = nullptr;
};

class SiteCharacteristicsDatabaseValueDataView {
 public:
  SiteCharacteristicsDatabaseValueDataView() {}

  SiteCharacteristicsDatabaseValueDataView(
      internal::SiteCharacteristicsDatabaseValue_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t last_loaded() const {
    return data_->last_loaded;
  }
  inline void GetUpdatesFaviconInBackgroundDataView(
      SiteCharacteristicsFeatureDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdatesFaviconInBackground(UserType* output) {
    auto* pointer = data_->updates_favicon_in_background.Get();
    return mojo::internal::Deserialize<::mojom::SiteCharacteristicsFeatureDataView>(
        pointer, output, context_);
  }
  inline void GetUpdatesTitleInBackgroundDataView(
      SiteCharacteristicsFeatureDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdatesTitleInBackground(UserType* output) {
    auto* pointer = data_->updates_title_in_background.Get();
    return mojo::internal::Deserialize<::mojom::SiteCharacteristicsFeatureDataView>(
        pointer, output, context_);
  }
  inline void GetUsesAudioInBackgroundDataView(
      SiteCharacteristicsFeatureDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUsesAudioInBackground(UserType* output) {
    auto* pointer = data_->uses_audio_in_background.Get();
    return mojo::internal::Deserialize<::mojom::SiteCharacteristicsFeatureDataView>(
        pointer, output, context_);
  }
  inline void GetUsesNotificationsInBackgroundDataView(
      SiteCharacteristicsFeatureDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUsesNotificationsInBackground(UserType* output) {
    auto* pointer = data_->uses_notifications_in_background.Get();
    return mojo::internal::Deserialize<::mojom::SiteCharacteristicsFeatureDataView>(
        pointer, output, context_);
  }
  inline void GetLoadTimeEstimatesDataView(
      SiteCharacteristicsPerformanceMeasurementDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLoadTimeEstimates(UserType* output) {
    auto* pointer = data_->load_time_estimates.Get();
    return mojo::internal::Deserialize<::mojom::SiteCharacteristicsPerformanceMeasurementDataView>(
        pointer, output, context_);
  }
 private:
  internal::SiteCharacteristicsDatabaseValue_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SiteCharacteristicsDatabaseEntryDataView {
 public:
  SiteCharacteristicsDatabaseEntryDataView() {}

  SiteCharacteristicsDatabaseEntryDataView(
      internal::SiteCharacteristicsDatabaseEntry_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetOriginDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOrigin(UserType* output) {
    auto* pointer = data_->origin.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool is_dirty() const {
    return data_->is_dirty;
  }
  inline void GetValueDataView(
      SiteCharacteristicsDatabaseValueDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::mojom::SiteCharacteristicsDatabaseValueDataView>(
        pointer, output, context_);
  }
 private:
  internal::SiteCharacteristicsDatabaseEntry_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SiteCharacteristicsDatabaseDataView {
 public:
  SiteCharacteristicsDatabaseDataView() {}

  SiteCharacteristicsDatabaseDataView(
      internal::SiteCharacteristicsDatabase_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDbRowsDataView(
      mojo::ArrayDataView<SiteCharacteristicsDatabaseEntryDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDbRows(UserType* output) {
    auto* pointer = data_->db_rows.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::mojom::SiteCharacteristicsDatabaseEntryDataView>>(
        pointer, output, context_);
  }
 private:
  internal::SiteCharacteristicsDatabase_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class TabDiscardsInfoDataView {
 public:
  TabDiscardsInfoDataView() {}

  TabDiscardsInfoDataView(
      internal::TabDiscardsInfo_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTabUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTabUrl(UserType* output) {
    auto* pointer = data_->tab_url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetTitleDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTitle(UserType* output) {
    auto* pointer = data_->title.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadVisibility(UserType* output) const {
    auto data_value = data_->visibility;
    return mojo::internal::Deserialize<::mojom::LifecycleUnitVisibility>(
        data_value, output);
  }

  LifecycleUnitVisibility visibility() const {
    return static_cast<LifecycleUnitVisibility>(data_->visibility);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLoadingState(UserType* output) const {
    auto data_value = data_->loading_state;
    return mojo::internal::Deserialize<::mojom::LifecycleUnitLoadingState>(
        data_value, output);
  }

  ::mojom::LifecycleUnitLoadingState loading_state() const {
    return static_cast<::mojom::LifecycleUnitLoadingState>(data_->loading_state);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::mojom::LifecycleUnitState>(
        data_value, output);
  }

  ::mojom::LifecycleUnitState state() const {
    return static_cast<::mojom::LifecycleUnitState>(data_->state);
  }
  bool can_freeze() const {
    return data_->can_freeze;
  }
  inline void GetCannotFreezeReasonsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCannotFreezeReasons(UserType* output) {
    auto* pointer = data_->cannot_freeze_reasons.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
  bool can_discard() const {
    return data_->can_discard;
  }
  inline void GetCannotDiscardReasonsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCannotDiscardReasons(UserType* output) {
    auto* pointer = data_->cannot_discard_reasons.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
  int32_t discard_count() const {
    return data_->discard_count;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDiscardReason(UserType* output) const {
    auto data_value = data_->discard_reason;
    return mojo::internal::Deserialize<::mojom::LifecycleUnitDiscardReason>(
        data_value, output);
  }

  ::mojom::LifecycleUnitDiscardReason discard_reason() const {
    return static_cast<::mojom::LifecycleUnitDiscardReason>(data_->discard_reason);
  }
  int32_t utility_rank() const {
    return data_->utility_rank;
  }
  int32_t last_active_seconds() const {
    return data_->last_active_seconds;
  }
  int32_t id() const {
    return data_->id;
  }
  bool is_auto_discardable() const {
    return data_->is_auto_discardable;
  }
  bool has_reactivation_score() const {
    return data_->has_reactivation_score;
  }
  double reactivation_score() const {
    return data_->reactivation_score;
  }
  double site_engagement_score() const {
    return data_->site_engagement_score;
  }
  bool has_focus() const {
    return data_->has_focus;
  }
 private:
  internal::TabDiscardsInfo_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom

namespace std {

template <>
struct hash<::mojom::LifecycleUnitVisibility>
    : public mojo::internal::EnumHashImpl<::mojom::LifecycleUnitVisibility> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::mojom::LifecycleUnitVisibility, ::mojom::LifecycleUnitVisibility> {
  static ::mojom::LifecycleUnitVisibility ToMojom(::mojom::LifecycleUnitVisibility input) { return input; }
  static bool FromMojom(::mojom::LifecycleUnitVisibility input, ::mojom::LifecycleUnitVisibility* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::LifecycleUnitVisibility, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::mojom::LifecycleUnitVisibility, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::mojom::LifecycleUnitVisibility>(input), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::SiteCharacteristicsFeatureDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::SiteCharacteristicsFeatureDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojom::internal::SiteCharacteristicsFeature_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->observation_duration = Traits::observation_duration(input);
    (*output)->use_timestamp = Traits::use_timestamp(input);
  }

  static bool Deserialize(::mojom::internal::SiteCharacteristicsFeature_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::SiteCharacteristicsFeatureDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::SiteCharacteristicsPerformanceMeasurementDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::SiteCharacteristicsPerformanceMeasurementDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojom::internal::SiteCharacteristicsPerformanceMeasurement_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->avg_cpu_usage_us = Traits::avg_cpu_usage_us(input);
    (*output)->avg_footprint_kb = Traits::avg_footprint_kb(input);
    (*output)->avg_load_duration_us = Traits::avg_load_duration_us(input);
  }

  static bool Deserialize(::mojom::internal::SiteCharacteristicsPerformanceMeasurement_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::SiteCharacteristicsPerformanceMeasurementDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::SiteCharacteristicsDatabaseSizeDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::SiteCharacteristicsDatabaseSizeDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojom::internal::SiteCharacteristicsDatabaseSize_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->num_rows = Traits::num_rows(input);
    (*output)->on_disk_size_kb = Traits::on_disk_size_kb(input);
  }

  static bool Deserialize(::mojom::internal::SiteCharacteristicsDatabaseSize_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::SiteCharacteristicsDatabaseSizeDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::SiteCharacteristicsDatabaseValueDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::SiteCharacteristicsDatabaseValueDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojom::internal::SiteCharacteristicsDatabaseValue_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    (*output)->last_loaded = Traits::last_loaded(input);
    decltype(Traits::updates_favicon_in_background(input)) in_updates_favicon_in_background = Traits::updates_favicon_in_background(input);
    typename decltype((*output)->updates_favicon_in_background)::BaseType::BufferWriter
        updates_favicon_in_background_writer;
    mojo::internal::Serialize<::mojom::SiteCharacteristicsFeatureDataView>(
        in_updates_favicon_in_background, buffer, &updates_favicon_in_background_writer, context);
    (*output)->updates_favicon_in_background.Set(
        updates_favicon_in_background_writer.is_null() ? nullptr : updates_favicon_in_background_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->updates_favicon_in_background.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null updates_favicon_in_background in SiteCharacteristicsDatabaseValue struct");
    decltype(Traits::updates_title_in_background(input)) in_updates_title_in_background = Traits::updates_title_in_background(input);
    typename decltype((*output)->updates_title_in_background)::BaseType::BufferWriter
        updates_title_in_background_writer;
    mojo::internal::Serialize<::mojom::SiteCharacteristicsFeatureDataView>(
        in_updates_title_in_background, buffer, &updates_title_in_background_writer, context);
    (*output)->updates_title_in_background.Set(
        updates_title_in_background_writer.is_null() ? nullptr : updates_title_in_background_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->updates_title_in_background.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null updates_title_in_background in SiteCharacteristicsDatabaseValue struct");
    decltype(Traits::uses_audio_in_background(input)) in_uses_audio_in_background = Traits::uses_audio_in_background(input);
    typename decltype((*output)->uses_audio_in_background)::BaseType::BufferWriter
        uses_audio_in_background_writer;
    mojo::internal::Serialize<::mojom::SiteCharacteristicsFeatureDataView>(
        in_uses_audio_in_background, buffer, &uses_audio_in_background_writer, context);
    (*output)->uses_audio_in_background.Set(
        uses_audio_in_background_writer.is_null() ? nullptr : uses_audio_in_background_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->uses_audio_in_background.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null uses_audio_in_background in SiteCharacteristicsDatabaseValue struct");
    decltype(Traits::uses_notifications_in_background(input)) in_uses_notifications_in_background = Traits::uses_notifications_in_background(input);
    typename decltype((*output)->uses_notifications_in_background)::BaseType::BufferWriter
        uses_notifications_in_background_writer;
    mojo::internal::Serialize<::mojom::SiteCharacteristicsFeatureDataView>(
        in_uses_notifications_in_background, buffer, &uses_notifications_in_background_writer, context);
    (*output)->uses_notifications_in_background.Set(
        uses_notifications_in_background_writer.is_null() ? nullptr : uses_notifications_in_background_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->uses_notifications_in_background.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null uses_notifications_in_background in SiteCharacteristicsDatabaseValue struct");
    decltype(Traits::load_time_estimates(input)) in_load_time_estimates = Traits::load_time_estimates(input);
    typename decltype((*output)->load_time_estimates)::BaseType::BufferWriter
        load_time_estimates_writer;
    mojo::internal::Serialize<::mojom::SiteCharacteristicsPerformanceMeasurementDataView>(
        in_load_time_estimates, buffer, &load_time_estimates_writer, context);
    (*output)->load_time_estimates.Set(
        load_time_estimates_writer.is_null() ? nullptr : load_time_estimates_writer.data());
  }

  static bool Deserialize(::mojom::internal::SiteCharacteristicsDatabaseValue_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::SiteCharacteristicsDatabaseValueDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::SiteCharacteristicsDatabaseEntryDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::SiteCharacteristicsDatabaseEntryDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojom::internal::SiteCharacteristicsDatabaseEntry_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::origin(input)) in_origin = Traits::origin(input);
    typename decltype((*output)->origin)::BaseType::BufferWriter
        origin_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_origin, buffer, &origin_writer, context);
    (*output)->origin.Set(
        origin_writer.is_null() ? nullptr : origin_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->origin.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null origin in SiteCharacteristicsDatabaseEntry struct");
    (*output)->is_dirty = Traits::is_dirty(input);
    decltype(Traits::value(input)) in_value = Traits::value(input);
    typename decltype((*output)->value)::BaseType::BufferWriter
        value_writer;
    mojo::internal::Serialize<::mojom::SiteCharacteristicsDatabaseValueDataView>(
        in_value, buffer, &value_writer, context);
    (*output)->value.Set(
        value_writer.is_null() ? nullptr : value_writer.data());
  }

  static bool Deserialize(::mojom::internal::SiteCharacteristicsDatabaseEntry_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::SiteCharacteristicsDatabaseEntryDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::SiteCharacteristicsDatabaseDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::SiteCharacteristicsDatabaseDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojom::internal::SiteCharacteristicsDatabase_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::db_rows(input)) in_db_rows = Traits::db_rows(input);
    typename decltype((*output)->db_rows)::BaseType::BufferWriter
        db_rows_writer;
    const mojo::internal::ContainerValidateParams db_rows_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<::mojom::SiteCharacteristicsDatabaseEntryDataView>>(
        in_db_rows, buffer, &db_rows_writer, &db_rows_validate_params,
        context);
    (*output)->db_rows.Set(
        db_rows_writer.is_null() ? nullptr : db_rows_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->db_rows.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null db_rows in SiteCharacteristicsDatabase struct");
  }

  static bool Deserialize(::mojom::internal::SiteCharacteristicsDatabase_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::SiteCharacteristicsDatabaseDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojom::TabDiscardsInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::mojom::TabDiscardsInfoDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::mojom::internal::TabDiscardsInfo_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    (*output).Allocate(buffer);
    decltype(Traits::tab_url(input)) in_tab_url = Traits::tab_url(input);
    typename decltype((*output)->tab_url)::BaseType::BufferWriter
        tab_url_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_tab_url, buffer, &tab_url_writer, context);
    (*output)->tab_url.Set(
        tab_url_writer.is_null() ? nullptr : tab_url_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->tab_url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null tab_url in TabDiscardsInfo struct");
    decltype(Traits::title(input)) in_title = Traits::title(input);
    typename decltype((*output)->title)::BaseType::BufferWriter
        title_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_title, buffer, &title_writer, context);
    (*output)->title.Set(
        title_writer.is_null() ? nullptr : title_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->title.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null title in TabDiscardsInfo struct");
    mojo::internal::Serialize<::mojom::LifecycleUnitVisibility>(
        Traits::visibility(input), &(*output)->visibility);
    mojo::internal::Serialize<::mojom::LifecycleUnitLoadingState>(
        Traits::loading_state(input), &(*output)->loading_state);
    mojo::internal::Serialize<::mojom::LifecycleUnitState>(
        Traits::state(input), &(*output)->state);
    (*output)->can_freeze = Traits::can_freeze(input);
    decltype(Traits::cannot_freeze_reasons(input)) in_cannot_freeze_reasons = Traits::cannot_freeze_reasons(input);
    typename decltype((*output)->cannot_freeze_reasons)::BaseType::BufferWriter
        cannot_freeze_reasons_writer;
    const mojo::internal::ContainerValidateParams cannot_freeze_reasons_validate_params(
        0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_cannot_freeze_reasons, buffer, &cannot_freeze_reasons_writer, &cannot_freeze_reasons_validate_params,
        context);
    (*output)->cannot_freeze_reasons.Set(
        cannot_freeze_reasons_writer.is_null() ? nullptr : cannot_freeze_reasons_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->cannot_freeze_reasons.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null cannot_freeze_reasons in TabDiscardsInfo struct");
    (*output)->can_discard = Traits::can_discard(input);
    decltype(Traits::cannot_discard_reasons(input)) in_cannot_discard_reasons = Traits::cannot_discard_reasons(input);
    typename decltype((*output)->cannot_discard_reasons)::BaseType::BufferWriter
        cannot_discard_reasons_writer;
    const mojo::internal::ContainerValidateParams cannot_discard_reasons_validate_params(
        0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_cannot_discard_reasons, buffer, &cannot_discard_reasons_writer, &cannot_discard_reasons_validate_params,
        context);
    (*output)->cannot_discard_reasons.Set(
        cannot_discard_reasons_writer.is_null() ? nullptr : cannot_discard_reasons_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->cannot_discard_reasons.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null cannot_discard_reasons in TabDiscardsInfo struct");
    (*output)->discard_count = Traits::discard_count(input);
    mojo::internal::Serialize<::mojom::LifecycleUnitDiscardReason>(
        Traits::discard_reason(input), &(*output)->discard_reason);
    (*output)->utility_rank = Traits::utility_rank(input);
    (*output)->last_active_seconds = Traits::last_active_seconds(input);
    (*output)->id = Traits::id(input);
    (*output)->is_auto_discardable = Traits::is_auto_discardable(input);
    (*output)->has_reactivation_score = Traits::has_reactivation_score(input);
    (*output)->reactivation_score = Traits::reactivation_score(input);
    (*output)->site_engagement_score = Traits::site_engagement_score(input);
    (*output)->has_focus = Traits::has_focus(input);
  }

  static bool Deserialize(::mojom::internal::TabDiscardsInfo_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::mojom::TabDiscardsInfoDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace mojom {







inline void SiteCharacteristicsDatabaseValueDataView::GetUpdatesFaviconInBackgroundDataView(
    SiteCharacteristicsFeatureDataView* output) {
  auto pointer = data_->updates_favicon_in_background.Get();
  *output = SiteCharacteristicsFeatureDataView(pointer, context_);
}
inline void SiteCharacteristicsDatabaseValueDataView::GetUpdatesTitleInBackgroundDataView(
    SiteCharacteristicsFeatureDataView* output) {
  auto pointer = data_->updates_title_in_background.Get();
  *output = SiteCharacteristicsFeatureDataView(pointer, context_);
}
inline void SiteCharacteristicsDatabaseValueDataView::GetUsesAudioInBackgroundDataView(
    SiteCharacteristicsFeatureDataView* output) {
  auto pointer = data_->uses_audio_in_background.Get();
  *output = SiteCharacteristicsFeatureDataView(pointer, context_);
}
inline void SiteCharacteristicsDatabaseValueDataView::GetUsesNotificationsInBackgroundDataView(
    SiteCharacteristicsFeatureDataView* output) {
  auto pointer = data_->uses_notifications_in_background.Get();
  *output = SiteCharacteristicsFeatureDataView(pointer, context_);
}
inline void SiteCharacteristicsDatabaseValueDataView::GetLoadTimeEstimatesDataView(
    SiteCharacteristicsPerformanceMeasurementDataView* output) {
  auto pointer = data_->load_time_estimates.Get();
  *output = SiteCharacteristicsPerformanceMeasurementDataView(pointer, context_);
}


inline void SiteCharacteristicsDatabaseEntryDataView::GetOriginDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->origin.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void SiteCharacteristicsDatabaseEntryDataView::GetValueDataView(
    SiteCharacteristicsDatabaseValueDataView* output) {
  auto pointer = data_->value.Get();
  *output = SiteCharacteristicsDatabaseValueDataView(pointer, context_);
}


inline void SiteCharacteristicsDatabaseDataView::GetDbRowsDataView(
    mojo::ArrayDataView<SiteCharacteristicsDatabaseEntryDataView>* output) {
  auto pointer = data_->db_rows.Get();
  *output = mojo::ArrayDataView<SiteCharacteristicsDatabaseEntryDataView>(pointer, context_);
}


inline void TabDiscardsInfoDataView::GetTabUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->tab_url.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void TabDiscardsInfoDataView::GetTitleDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->title.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void TabDiscardsInfoDataView::GetCannotFreezeReasonsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->cannot_freeze_reasons.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}
inline void TabDiscardsInfoDataView::GetCannotDiscardReasonsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->cannot_discard_reasons.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}



}  // namespace mojom

#endif  // CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_SHARED_H_