// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_TEST_UTILS_H_
#define CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_TEST_UTILS_H_

#include "chrome/browser/ui/webui/discards/discards.mojom.h"


namespace mojom {


class  DiscardsDetailsProviderInterceptorForTesting : public DiscardsDetailsProvider {
  virtual DiscardsDetailsProvider* GetForwardingInterface() = 0;
  void GetTabDiscardsInfo(GetTabDiscardsInfoCallback callback) override;
  void GetSiteCharacteristicsDatabase(const std::vector<std::string>& explicitly_requested_origins, GetSiteCharacteristicsDatabaseCallback callback) override;
  void GetSiteCharacteristicsDatabaseSize(GetSiteCharacteristicsDatabaseSizeCallback callback) override;
  void SetAutoDiscardable(int32_t tab_id, bool is_auto_discardable, SetAutoDiscardableCallback callback) override;
  void DiscardById(int32_t tab_id, bool urgent, DiscardByIdCallback callback) override;
  void FreezeById(int32_t tab_id) override;
  void LoadById(int32_t tab_id) override;
  void Discard(bool urgent, DiscardCallback callback) override;
};
class  DiscardsDetailsProviderAsyncWaiter {
 public:
  explicit DiscardsDetailsProviderAsyncWaiter(DiscardsDetailsProvider* proxy);
  ~DiscardsDetailsProviderAsyncWaiter();
  void GetTabDiscardsInfo(
      std::vector<TabDiscardsInfoPtr>* out_infos);
  void GetSiteCharacteristicsDatabase(
      const std::vector<std::string>& explicitly_requested_origins, SiteCharacteristicsDatabasePtr* out_result);
  void GetSiteCharacteristicsDatabaseSize(
      SiteCharacteristicsDatabaseSizePtr* out_db_size);
  void SetAutoDiscardable(
      int32_t tab_id, bool is_auto_discardable);
  void DiscardById(
      int32_t tab_id, bool urgent);
  void Discard(
      bool urgent);

 private:
  DiscardsDetailsProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProviderAsyncWaiter);
};




}  // namespace mojom

#endif  // CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_TEST_UTILS_H_