// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_FEED_INTERNALS_FEED_INTERNALS_MOJOM_TEST_UTILS_H_
#define CHROME_BROWSER_UI_WEBUI_FEED_INTERNALS_FEED_INTERNALS_MOJOM_TEST_UTILS_H_

#include "chrome/browser/ui/webui/feed_internals/feed_internals.mojom.h"


namespace feed_internals {
namespace mojom {


class  PageHandlerInterceptorForTesting : public PageHandler {
  virtual PageHandler* GetForwardingInterface() = 0;
  void GetGeneralProperties(GetGeneralPropertiesCallback callback) override;
  void GetUserClassifierProperties(GetUserClassifierPropertiesCallback callback) override;
  void ClearUserClassifierProperties() override;
  void GetLastFetchProperties(GetLastFetchPropertiesCallback callback) override;
  void ClearCachedDataAndRefreshFeed() override;
  void RefreshFeed() override;
  void GetCurrentContent(GetCurrentContentCallback callback) override;
  void GetFeedProcessScopeDump(GetFeedProcessScopeDumpCallback callback) override;
  void GetFeedHistograms(GetFeedHistogramsCallback callback) override;
};
class  PageHandlerAsyncWaiter {
 public:
  explicit PageHandlerAsyncWaiter(PageHandler* proxy);
  ~PageHandlerAsyncWaiter();
  void GetGeneralProperties(
      PropertiesPtr* out_properties);
  void GetUserClassifierProperties(
      UserClassifierPtr* out_properties);
  void GetLastFetchProperties(
      LastFetchPropertiesPtr* out_properties);
  void GetCurrentContent(
      std::vector<SuggestionPtr>* out_suggestions);
  void GetFeedProcessScopeDump(
      std::string* out_dump);
  void GetFeedHistograms(
      std::string* out_log);

 private:
  PageHandler* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PageHandlerAsyncWaiter);
};




}  // namespace mojom
}  // namespace feed_internals

#endif  // CHROME_BROWSER_UI_WEBUI_FEED_INTERNALS_FEED_INTERNALS_MOJOM_TEST_UTILS_H_