// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/browser/ui/webui/omnibox/omnibox.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef CHROME_BROWSER_UI_WEBUI_OMNIBOX_OMNIBOX_MOJOM_JUMBO_H_
#define CHROME_BROWSER_UI_WEBUI_OMNIBOX_OMNIBOX_MOJOM_JUMBO_H_
#endif


namespace mojom {


void OmniboxPageHandlerInterceptorForTesting::SetClientPage(OmniboxPagePtr page) {
  GetForwardingInterface()->SetClientPage(std::move(page));
}
void OmniboxPageHandlerInterceptorForTesting::StartOmniboxQuery(const std::string& input_string, bool reset_autocomplete_controller, int32_t cursor_position, bool zero_suggest, bool prevent_inline_autocomplete, bool prefer_keyword, const std::string& current_url, int32_t page_classification) {
  GetForwardingInterface()->StartOmniboxQuery(std::move(input_string), std::move(reset_autocomplete_controller), std::move(cursor_position), std::move(zero_suggest), std::move(prevent_inline_autocomplete), std::move(prefer_keyword), std::move(current_url), std::move(page_classification));
}
OmniboxPageHandlerAsyncWaiter::OmniboxPageHandlerAsyncWaiter(
    OmniboxPageHandler* proxy) : proxy_(proxy) {}

OmniboxPageHandlerAsyncWaiter::~OmniboxPageHandlerAsyncWaiter() = default;




void OmniboxPageInterceptorForTesting::handleNewAutocompleteResponse(OmniboxResponsePtr response, bool isPageController) {
  GetForwardingInterface()->handleNewAutocompleteResponse(std::move(response), std::move(isPageController));
}
void OmniboxPageInterceptorForTesting::HandleNewAutocompleteQuery(bool isPageController, const std::string& input_text) {
  GetForwardingInterface()->HandleNewAutocompleteQuery(std::move(isPageController), std::move(input_text));
}
void OmniboxPageInterceptorForTesting::HandleAnswerImageData(const std::string& image_url, const std::string& image_data) {
  GetForwardingInterface()->HandleAnswerImageData(std::move(image_url), std::move(image_data));
}
OmniboxPageAsyncWaiter::OmniboxPageAsyncWaiter(
    OmniboxPage* proxy) : proxy_(proxy) {}

OmniboxPageAsyncWaiter::~OmniboxPageAsyncWaiter() = default;






}  // namespace mojom

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif