// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_USB_INTERNALS_USB_INTERNALS_MOJOM_H_
#define CHROME_BROWSER_UI_WEBUI_USB_INTERNALS_USB_INTERNALS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "chrome/browser/ui/webui/usb_internals/usb_internals.mojom-shared.h"
#include "chrome/browser/ui/webui/usb_internals/usb_internals.mojom-forward.h"
#include "services/device/public/mojom/usb_manager.mojom-forward.h"
#include "services/device/public/mojom/usb_manager_test.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace mojom {

class UsbInternalsPageHandlerProxy;

template <typename ImplRefTraits>
class UsbInternalsPageHandlerStub;

class UsbInternalsPageHandlerRequestValidator;


class  UsbInternalsPageHandler
    : public UsbInternalsPageHandlerInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Base_ = UsbInternalsPageHandlerInterfaceBase;
  using Proxy_ = UsbInternalsPageHandlerProxy;

  template <typename ImplRefTraits>
  using Stub_ = UsbInternalsPageHandlerStub<ImplRefTraits>;

  using RequestValidator_ = UsbInternalsPageHandlerRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kBindUsbDeviceManagerInterfaceMinVersion = 0,
    kBindTestInterfaceMinVersion = 0,
  };
  virtual ~UsbInternalsPageHandler() {}

  
  virtual void BindUsbDeviceManagerInterface(::device::mojom::UsbDeviceManagerRequest request) = 0;

  
  virtual void BindTestInterface(::device::mojom::UsbDeviceManagerTestRequest request) = 0;
};

class  UsbInternalsPageHandlerProxy
    : public UsbInternalsPageHandler {
 public:
  using InterfaceType = UsbInternalsPageHandler;

  explicit UsbInternalsPageHandlerProxy(mojo::MessageReceiverWithResponder* receiver);
  void BindUsbDeviceManagerInterface(::device::mojom::UsbDeviceManagerRequest request) final;
  void BindTestInterface(::device::mojom::UsbDeviceManagerTestRequest request) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  UsbInternalsPageHandlerStubDispatch {
 public:
  static bool Accept(UsbInternalsPageHandler* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      UsbInternalsPageHandler* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<UsbInternalsPageHandler>>
class UsbInternalsPageHandlerStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  UsbInternalsPageHandlerStub() {}
  ~UsbInternalsPageHandlerStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return UsbInternalsPageHandlerStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return UsbInternalsPageHandlerStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  UsbInternalsPageHandlerRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace mojom

namespace mojo {

}  // namespace mojo

#endif  // CHROME_BROWSER_UI_WEBUI_USB_INTERNALS_USB_INTERNALS_MOJOM_H_