// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_TEST_UTILS_H_

#include "chrome/common/available_offline_content.mojom.h"


namespace chrome {
namespace mojom {


class  AvailableOfflineContentProviderInterceptorForTesting : public AvailableOfflineContentProvider {
  virtual AvailableOfflineContentProvider* GetForwardingInterface() = 0;
  void List(ListCallback callback) override;
  void LaunchItem(const std::string& item_id, const std::string& name_space) override;
  void LaunchDownloadsPage(bool open_prefetched_articles_tab) override;
  void ListVisibilityChanged(bool is_visible) override;
};
class  AvailableOfflineContentProviderAsyncWaiter {
 public:
  explicit AvailableOfflineContentProviderAsyncWaiter(AvailableOfflineContentProvider* proxy);
  ~AvailableOfflineContentProviderAsyncWaiter();
  void List(
      bool* out_list_visible_by_prefs, std::vector<AvailableOfflineContentPtr>* out_out);

 private:
  AvailableOfflineContentProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AvailableOfflineContentProviderAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_TEST_UTILS_H_