// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_CACHE_STATS_RECORDER_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_CACHE_STATS_RECORDER_MOJOM_TEST_UTILS_H_

#include "chrome/common/cache_stats_recorder.mojom.h"


namespace chrome {
namespace mojom {


class  CacheStatsRecorderInterceptorForTesting : public CacheStatsRecorder {
  virtual CacheStatsRecorder* GetForwardingInterface() = 0;
  void RecordCacheStats(uint64_t capacity, uint64_t size) override;
};
class  CacheStatsRecorderAsyncWaiter {
 public:
  explicit CacheStatsRecorderAsyncWaiter(CacheStatsRecorder* proxy);
  ~CacheStatsRecorderAsyncWaiter();

 private:
  CacheStatsRecorder* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(CacheStatsRecorderAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_CACHE_STATS_RECORDER_MOJOM_TEST_UTILS_H_