// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_CONTENT_SETTINGS_RENDERER_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_CONTENT_SETTINGS_RENDERER_MOJOM_TEST_UTILS_H_

#include "chrome/common/content_settings_renderer.mojom.h"


namespace chrome {
namespace mojom {


class  ContentSettingsRendererInterceptorForTesting : public ContentSettingsRenderer {
  virtual ContentSettingsRenderer* GetForwardingInterface() = 0;
  void SetAllowRunningInsecureContent() override;
  void SetAsInterstitial() override;
};
class  ContentSettingsRendererAsyncWaiter {
 public:
  explicit ContentSettingsRendererAsyncWaiter(ContentSettingsRenderer* proxy);
  ~ContentSettingsRendererAsyncWaiter();

 private:
  ContentSettingsRenderer* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ContentSettingsRendererAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_CONTENT_SETTINGS_RENDERER_MOJOM_TEST_UTILS_H_