// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/common/importer/profile_import.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "components/autofill/core/common/mojom/autofill_types.mojom.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "url/mojom/url.mojom.h"


#ifndef CHROME_COMMON_IMPORTER_PROFILE_IMPORT_MOJOM_JUMBO_H_
#define CHROME_COMMON_IMPORTER_PROFILE_IMPORT_MOJOM_JUMBO_H_
#include "chrome/common/importer/profile_import_process_param_traits.h"
#include "components/autofill/core/common/mojom/autofill_types_struct_traits.h"
#include "mojo/public/cpp/base/string16_mojom_traits.h"
#include "mojo/public/cpp/base/text_direction_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "url/mojom/origin_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace chrome {
namespace mojom {


void ProfileImportObserverInterceptorForTesting::OnImportStart() {
  GetForwardingInterface()->OnImportStart();
}
void ProfileImportObserverInterceptorForTesting::OnImportFinished(bool succeeded, const std::string& error_msg) {
  GetForwardingInterface()->OnImportFinished(std::move(succeeded), std::move(error_msg));
}
void ProfileImportObserverInterceptorForTesting::OnImportItemStart(::importer::ImportItem item) {
  GetForwardingInterface()->OnImportItemStart(std::move(item));
}
void ProfileImportObserverInterceptorForTesting::OnImportItemFinished(::importer::ImportItem item) {
  GetForwardingInterface()->OnImportItemFinished(std::move(item));
}
void ProfileImportObserverInterceptorForTesting::OnHistoryImportStart(uint32_t total_history_rows_count) {
  GetForwardingInterface()->OnHistoryImportStart(std::move(total_history_rows_count));
}
void ProfileImportObserverInterceptorForTesting::OnHistoryImportGroup(const std::vector<::ImporterURLRow>& history_rows_group, int32_t visit_source) {
  GetForwardingInterface()->OnHistoryImportGroup(std::move(history_rows_group), std::move(visit_source));
}
void ProfileImportObserverInterceptorForTesting::OnHomePageImportReady(const GURL& home_page) {
  GetForwardingInterface()->OnHomePageImportReady(std::move(home_page));
}
void ProfileImportObserverInterceptorForTesting::OnBookmarksImportStart(const base::string16& first_folder_name, uint32_t total_bookmarks_count) {
  GetForwardingInterface()->OnBookmarksImportStart(std::move(first_folder_name), std::move(total_bookmarks_count));
}
void ProfileImportObserverInterceptorForTesting::OnBookmarksImportGroup(const std::vector<::ImportedBookmarkEntry>& bookmarks_group) {
  GetForwardingInterface()->OnBookmarksImportGroup(std::move(bookmarks_group));
}
void ProfileImportObserverInterceptorForTesting::OnFaviconsImportStart(uint32_t total_favicons_count) {
  GetForwardingInterface()->OnFaviconsImportStart(std::move(total_favicons_count));
}
void ProfileImportObserverInterceptorForTesting::OnFaviconsImportGroup(const ::favicon_base::FaviconUsageDataList& favicons_group) {
  GetForwardingInterface()->OnFaviconsImportGroup(std::move(favicons_group));
}
void ProfileImportObserverInterceptorForTesting::OnPasswordFormImportReady(const autofill::PasswordForm& form) {
  GetForwardingInterface()->OnPasswordFormImportReady(std::move(form));
}
void ProfileImportObserverInterceptorForTesting::OnKeywordsImportReady(const std::vector<::importer::SearchEngineInfo>& search_engines, bool unique_on_host_and_path) {
  GetForwardingInterface()->OnKeywordsImportReady(std::move(search_engines), std::move(unique_on_host_and_path));
}
void ProfileImportObserverInterceptorForTesting::OnFirefoxSearchEngineDataReceived(const std::vector<std::string>& search_engine_data) {
  GetForwardingInterface()->OnFirefoxSearchEngineDataReceived(std::move(search_engine_data));
}
void ProfileImportObserverInterceptorForTesting::OnAutofillFormDataImportStart(uint32_t total_autofill_form_data_entry_count) {
  GetForwardingInterface()->OnAutofillFormDataImportStart(std::move(total_autofill_form_data_entry_count));
}
void ProfileImportObserverInterceptorForTesting::OnAutofillFormDataImportGroup(const std::vector<::ImporterAutofillFormDataEntry>& autofill_form_data_entry_group) {
  GetForwardingInterface()->OnAutofillFormDataImportGroup(std::move(autofill_form_data_entry_group));
}
ProfileImportObserverAsyncWaiter::ProfileImportObserverAsyncWaiter(
    ProfileImportObserver* proxy) : proxy_(proxy) {}

ProfileImportObserverAsyncWaiter::~ProfileImportObserverAsyncWaiter() = default;




void ProfileImportInterceptorForTesting::StartImport(const ::importer::SourceProfile& source_profile, uint16_t items, const base::flat_map<uint32_t, std::string>& localized_strings, ProfileImportObserverPtr observer) {
  GetForwardingInterface()->StartImport(std::move(source_profile), std::move(items), std::move(localized_strings), std::move(observer));
}
void ProfileImportInterceptorForTesting::CancelImport() {
  GetForwardingInterface()->CancelImport();
}
void ProfileImportInterceptorForTesting::ReportImportItemFinished(::importer::ImportItem item) {
  GetForwardingInterface()->ReportImportItemFinished(std::move(item));
}
ProfileImportAsyncWaiter::ProfileImportAsyncWaiter(
    ProfileImport* proxy) : proxy_(proxy) {}

ProfileImportAsyncWaiter::~ProfileImportAsyncWaiter() = default;






}  // namespace mojom
}  // namespace chrome

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif