// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_NAVIGATION_CORRECTOR_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_NAVIGATION_CORRECTOR_MOJOM_TEST_UTILS_H_

#include "chrome/common/navigation_corrector.mojom.h"


namespace chrome {
namespace mojom {


class  NavigationCorrectorInterceptorForTesting : public NavigationCorrector {
  virtual NavigationCorrector* GetForwardingInterface() = 0;
  void SetNavigationCorrectionInfo(const GURL& navigation_correction_url, const std::string& language, const std::string& country_code, const std::string& api_key, const GURL& search_url) override;
};
class  NavigationCorrectorAsyncWaiter {
 public:
  explicit NavigationCorrectorAsyncWaiter(NavigationCorrector* proxy);
  ~NavigationCorrectorAsyncWaiter();

 private:
  NavigationCorrector* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(NavigationCorrectorAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_NAVIGATION_CORRECTOR_MOJOM_TEST_UTILS_H_