// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_NET_BENCHMARKING_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_NET_BENCHMARKING_MOJOM_TEST_UTILS_H_

#include "chrome/common/net_benchmarking.mojom.h"


namespace chrome {
namespace mojom {


class  NetBenchmarkingInterceptorForTesting : public NetBenchmarking {
  virtual NetBenchmarking* GetForwardingInterface() = 0;
  void CloseCurrentConnections(CloseCurrentConnectionsCallback callback) override;
  void ClearCache(ClearCacheCallback callback) override;
  void ClearHostResolverCache(ClearHostResolverCacheCallback callback) override;
  void ClearPredictorCache(ClearPredictorCacheCallback callback) override;
};
class  NetBenchmarkingAsyncWaiter {
 public:
  explicit NetBenchmarkingAsyncWaiter(NetBenchmarking* proxy);
  ~NetBenchmarkingAsyncWaiter();
  void CloseCurrentConnections(
      );
  void ClearCache(
      );
  void ClearHostResolverCache(
      );
  void ClearPredictorCache(
      );

 private:
  NetBenchmarking* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(NetBenchmarkingAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_NET_BENCHMARKING_MOJOM_TEST_UTILS_H_