// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_PRERENDER_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_PRERENDER_MOJOM_TEST_UTILS_H_

#include "chrome/common/prerender.mojom.h"


namespace chrome {
namespace mojom {


class  PrerenderCancelerInterceptorForTesting : public PrerenderCanceler {
  virtual PrerenderCanceler* GetForwardingInterface() = 0;
  void CancelPrerenderForPrinting() override;
  void CancelPrerenderForUnsupportedMethod() override;
  void CancelPrerenderForUnsupportedScheme(const GURL& url) override;
  void CancelPrerenderForSyncDeferredRedirect() override;
};
class  PrerenderCancelerAsyncWaiter {
 public:
  explicit PrerenderCancelerAsyncWaiter(PrerenderCanceler* proxy);
  ~PrerenderCancelerAsyncWaiter();

 private:
  PrerenderCanceler* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PrerenderCancelerAsyncWaiter);
};


class  PrerenderDispatcherInterceptorForTesting : public PrerenderDispatcher {
  virtual PrerenderDispatcher* GetForwardingInterface() = 0;
  void PrerenderStart(int32_t prerender_id) override;
  void PrerenderStopLoading(int32_t prerender_id) override;
  void PrerenderDomContentLoaded(int32_t prerender_id) override;
  void PrerenderAddAlias(const GURL& alias) override;
  void PrerenderRemoveAliases(const std::vector<GURL>& aliases) override;
  void PrerenderStop(int32_t prerender_id) override;
};
class  PrerenderDispatcherAsyncWaiter {
 public:
  explicit PrerenderDispatcherAsyncWaiter(PrerenderDispatcher* proxy);
  ~PrerenderDispatcherAsyncWaiter();

 private:
  PrerenderDispatcher* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PrerenderDispatcherAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_PRERENDER_MOJOM_TEST_UTILS_H_