// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_SERVICE_PROCESS_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_SERVICE_PROCESS_MOJOM_TEST_UTILS_H_

#include "chrome/common/service_process.mojom.h"


namespace chrome {
namespace mojom {


class  ServiceProcessInterceptorForTesting : public ServiceProcess {
  virtual ServiceProcess* GetForwardingInterface() = 0;
  void Hello(HelloCallback callback) override;
  void GetHistograms(GetHistogramsCallback callback) override;
  void UpdateAvailable() override;
  void ShutDown() override;
};
class  ServiceProcessAsyncWaiter {
 public:
  explicit ServiceProcessAsyncWaiter(ServiceProcess* proxy);
  ~ServiceProcessAsyncWaiter();
  void Hello(
      );
  void GetHistograms(
      std::vector<std::string>* out_histograms);

 private:
  ServiceProcess* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ServiceProcessAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_SERVICE_PROCESS_MOJOM_TEST_UTILS_H_