// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/services/app_service/public/mojom/app_service.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "chrome/services/app_service/public/mojom/types.mojom.h"


#ifndef CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_JUMBO_H_
#define CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/big_buffer_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "skia/public/interfaces/bitmap_skbitmap_struct_traits.h"
#include "skia/public/interfaces/image_info_struct_traits.h"
#include "ui/gfx/image/mojo/image_skia_struct_traits.h"
#endif


namespace apps {
namespace mojom {


void AppServiceInterceptorForTesting::RegisterPublisher(PublisherPtr publisher, ::apps::mojom::AppType app_type) {
  GetForwardingInterface()->RegisterPublisher(std::move(publisher), std::move(app_type));
}
void AppServiceInterceptorForTesting::RegisterSubscriber(SubscriberPtr subscriber, ConnectOptionsPtr opts) {
  GetForwardingInterface()->RegisterSubscriber(std::move(subscriber), std::move(opts));
}
void AppServiceInterceptorForTesting::LoadIcon(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::IconKeyPtr icon_key, ::apps::mojom::IconCompression icon_compression, int32_t size_hint_in_dip, bool allow_placeholder_icon, LoadIconCallback callback) {
  GetForwardingInterface()->LoadIcon(std::move(app_type), std::move(app_id), std::move(icon_key), std::move(icon_compression), std::move(size_hint_in_dip), std::move(allow_placeholder_icon), std::move(callback));
}
void AppServiceInterceptorForTesting::Launch(::apps::mojom::AppType app_type, const std::string& app_id, int32_t event_flags, ::apps::mojom::LaunchSource launch_source, int64_t display_id) {
  GetForwardingInterface()->Launch(std::move(app_type), std::move(app_id), std::move(event_flags), std::move(launch_source), std::move(display_id));
}
void AppServiceInterceptorForTesting::SetPermission(::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::PermissionPtr permission) {
  GetForwardingInterface()->SetPermission(std::move(app_type), std::move(app_id), std::move(permission));
}
void AppServiceInterceptorForTesting::Uninstall(::apps::mojom::AppType app_type, const std::string& app_id) {
  GetForwardingInterface()->Uninstall(std::move(app_type), std::move(app_id));
}
void AppServiceInterceptorForTesting::OpenNativeSettings(::apps::mojom::AppType app_type, const std::string& app_id) {
  GetForwardingInterface()->OpenNativeSettings(std::move(app_type), std::move(app_id));
}
AppServiceAsyncWaiter::AppServiceAsyncWaiter(
    AppService* proxy) : proxy_(proxy) {}

AppServiceAsyncWaiter::~AppServiceAsyncWaiter() = default;

void AppServiceAsyncWaiter::LoadIcon(
    ::apps::mojom::AppType app_type, const std::string& app_id, ::apps::mojom::IconKeyPtr icon_key, ::apps::mojom::IconCompression icon_compression, int32_t size_hint_in_dip, bool allow_placeholder_icon, ::apps::mojom::IconValuePtr* out_icon_value) {
  base::RunLoop loop;
  proxy_->LoadIcon(std::move(app_type),std::move(app_id),std::move(icon_key),std::move(icon_compression),std::move(size_hint_in_dip),std::move(allow_placeholder_icon),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::apps::mojom::IconValuePtr* out_icon_value
,
             ::apps::mojom::IconValuePtr icon_value) {*out_icon_value = std::move(icon_value);
            loop->Quit();
          },
          &loop,
          out_icon_value));
  loop.Run();
}



void PublisherInterceptorForTesting::Connect(SubscriberPtr subscriber, ConnectOptionsPtr opts) {
  GetForwardingInterface()->Connect(std::move(subscriber), std::move(opts));
}
void PublisherInterceptorForTesting::LoadIcon(const std::string& app_id, ::apps::mojom::IconKeyPtr icon_key, ::apps::mojom::IconCompression icon_compression, int32_t size_hint_in_dip, bool allow_placeholder_icon, LoadIconCallback callback) {
  GetForwardingInterface()->LoadIcon(std::move(app_id), std::move(icon_key), std::move(icon_compression), std::move(size_hint_in_dip), std::move(allow_placeholder_icon), std::move(callback));
}
void PublisherInterceptorForTesting::Launch(const std::string& app_id, int32_t event_flags, ::apps::mojom::LaunchSource launch_source, int64_t display_id) {
  GetForwardingInterface()->Launch(std::move(app_id), std::move(event_flags), std::move(launch_source), std::move(display_id));
}
void PublisherInterceptorForTesting::SetPermission(const std::string& app_id, ::apps::mojom::PermissionPtr permission) {
  GetForwardingInterface()->SetPermission(std::move(app_id), std::move(permission));
}
void PublisherInterceptorForTesting::Uninstall(const std::string& app_id) {
  GetForwardingInterface()->Uninstall(std::move(app_id));
}
void PublisherInterceptorForTesting::OpenNativeSettings(const std::string& app_id) {
  GetForwardingInterface()->OpenNativeSettings(std::move(app_id));
}
PublisherAsyncWaiter::PublisherAsyncWaiter(
    Publisher* proxy) : proxy_(proxy) {}

PublisherAsyncWaiter::~PublisherAsyncWaiter() = default;

void PublisherAsyncWaiter::LoadIcon(
    const std::string& app_id, ::apps::mojom::IconKeyPtr icon_key, ::apps::mojom::IconCompression icon_compression, int32_t size_hint_in_dip, bool allow_placeholder_icon, ::apps::mojom::IconValuePtr* out_icon_value) {
  base::RunLoop loop;
  proxy_->LoadIcon(std::move(app_id),std::move(icon_key),std::move(icon_compression),std::move(size_hint_in_dip),std::move(allow_placeholder_icon),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::apps::mojom::IconValuePtr* out_icon_value
,
             ::apps::mojom::IconValuePtr icon_value) {*out_icon_value = std::move(icon_value);
            loop->Quit();
          },
          &loop,
          out_icon_value));
  loop.Run();
}



void SubscriberInterceptorForTesting::OnApps(std::vector<::apps::mojom::AppPtr> deltas) {
  GetForwardingInterface()->OnApps(std::move(deltas));
}
void SubscriberInterceptorForTesting::Clone(SubscriberRequest request) {
  GetForwardingInterface()->Clone(std::move(request));
}
SubscriberAsyncWaiter::SubscriberAsyncWaiter(
    Subscriber* proxy) : proxy_(proxy) {}

SubscriberAsyncWaiter::~SubscriberAsyncWaiter() = default;






}  // namespace mojom
}  // namespace apps

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif