// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "chrome/services/app_service/public/mojom/app_service.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/services/app_service/public/mojom/app_service.mojom-params-data.h"
#include "chrome/services/app_service/public/mojom/app_service.mojom-shared-message-ids.h"

#include "chrome/services/app_service/public/mojom/app_service.mojom-import-headers.h"


#ifndef CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_JUMBO_H_
#define CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/big_buffer_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "skia/public/interfaces/bitmap_skbitmap_struct_traits.h"
#include "skia/public/interfaces/image_info_struct_traits.h"
#include "ui/gfx/image/mojo/image_skia_struct_traits.h"
#endif
namespace apps {
namespace mojom {
ConnectOptions::ConnectOptions() {}

ConnectOptions::~ConnectOptions() = default;
size_t ConnectOptions::Hash(size_t seed) const {
  return seed;
}

bool ConnectOptions::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char AppService::Name_[] = "apps.mojom.AppService";

class AppService_LoadIcon_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  AppService_LoadIcon_ForwardToCallback(
      AppService::LoadIconCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  AppService::LoadIconCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(AppService_LoadIcon_ForwardToCallback);
};

AppServiceProxy::AppServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void AppServiceProxy::RegisterPublisher(
    PublisherPtr in_publisher, ::apps::mojom::AppType in_app_type) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::AppService::RegisterPublisher");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAppService_RegisterPublisher_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::AppService_RegisterPublisher_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::PublisherPtrDataView>(
      in_publisher, &params->publisher, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->publisher),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid publisher in AppService.RegisterPublisher request");
  mojo::internal::Serialize<::apps::mojom::AppType>(
      in_app_type, &params->app_type);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AppService::Name_);
  message.set_method_name("RegisterPublisher");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void AppServiceProxy::RegisterSubscriber(
    SubscriberPtr in_subscriber, ConnectOptionsPtr in_opts) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::AppService::RegisterSubscriber");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAppService_RegisterSubscriber_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::AppService_RegisterSubscriber_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::SubscriberPtrDataView>(
      in_subscriber, &params->subscriber, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->subscriber),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid subscriber in AppService.RegisterSubscriber request");
  typename decltype(params->opts)::BaseType::BufferWriter
      opts_writer;
  mojo::internal::Serialize<::apps::mojom::ConnectOptionsDataView>(
      in_opts, buffer, &opts_writer, &serialization_context);
  params->opts.Set(
      opts_writer.is_null() ? nullptr : opts_writer.data());
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AppService::Name_);
  message.set_method_name("RegisterSubscriber");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void AppServiceProxy::LoadIcon(
    ::apps::mojom::AppType in_app_type, const std::string& in_app_id, ::apps::mojom::IconKeyPtr in_icon_key, ::apps::mojom::IconCompression in_icon_compression, int32_t in_size_hint_in_dip, bool in_allow_placeholder_icon, LoadIconCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::AppService::LoadIcon");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAppService_LoadIcon_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::AppService_LoadIcon_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::AppType>(
      in_app_type, &params->app_type);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in AppService.LoadIcon request");
  typename decltype(params->icon_key)::BaseType::BufferWriter
      icon_key_writer;
  mojo::internal::Serialize<::apps::mojom::IconKeyDataView>(
      in_icon_key, buffer, &icon_key_writer, &serialization_context);
  params->icon_key.Set(
      icon_key_writer.is_null() ? nullptr : icon_key_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->icon_key.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null icon_key in AppService.LoadIcon request");
  mojo::internal::Serialize<::apps::mojom::IconCompression>(
      in_icon_compression, &params->icon_compression);
  params->size_hint_in_dip = in_size_hint_in_dip;
  params->allow_placeholder_icon = in_allow_placeholder_icon;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AppService::Name_);
  message.set_method_name("LoadIcon");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new AppService_LoadIcon_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void AppServiceProxy::Launch(
    ::apps::mojom::AppType in_app_type, const std::string& in_app_id, int32_t in_event_flags, ::apps::mojom::LaunchSource in_launch_source, int64_t in_display_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::AppService::Launch");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAppService_Launch_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::AppService_Launch_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::AppType>(
      in_app_type, &params->app_type);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in AppService.Launch request");
  params->event_flags = in_event_flags;
  mojo::internal::Serialize<::apps::mojom::LaunchSource>(
      in_launch_source, &params->launch_source);
  params->display_id = in_display_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AppService::Name_);
  message.set_method_name("Launch");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void AppServiceProxy::SetPermission(
    ::apps::mojom::AppType in_app_type, const std::string& in_app_id, ::apps::mojom::PermissionPtr in_permission) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::AppService::SetPermission");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAppService_SetPermission_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::AppService_SetPermission_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::AppType>(
      in_app_type, &params->app_type);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in AppService.SetPermission request");
  typename decltype(params->permission)::BaseType::BufferWriter
      permission_writer;
  mojo::internal::Serialize<::apps::mojom::PermissionDataView>(
      in_permission, buffer, &permission_writer, &serialization_context);
  params->permission.Set(
      permission_writer.is_null() ? nullptr : permission_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->permission.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null permission in AppService.SetPermission request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AppService::Name_);
  message.set_method_name("SetPermission");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void AppServiceProxy::Uninstall(
    ::apps::mojom::AppType in_app_type, const std::string& in_app_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::AppService::Uninstall");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAppService_Uninstall_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::AppService_Uninstall_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::AppType>(
      in_app_type, &params->app_type);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in AppService.Uninstall request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AppService::Name_);
  message.set_method_name("Uninstall");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void AppServiceProxy::OpenNativeSettings(
    ::apps::mojom::AppType in_app_type, const std::string& in_app_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::AppService::OpenNativeSettings");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAppService_OpenNativeSettings_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::AppService_OpenNativeSettings_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::AppType>(
      in_app_type, &params->app_type);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in AppService.OpenNativeSettings request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AppService::Name_);
  message.set_method_name("OpenNativeSettings");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class AppService_LoadIcon_ProxyToResponder {
 public:
  static AppService::LoadIconCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<AppService_LoadIcon_ProxyToResponder> proxy(
        new AppService_LoadIcon_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&AppService_LoadIcon_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~AppService_LoadIcon_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  AppService_LoadIcon_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "AppService::LoadIconCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ::apps::mojom::IconValuePtr in_icon_value);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(AppService_LoadIcon_ProxyToResponder);
};

bool AppService_LoadIcon_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::AppService::LoadIconCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::AppService_LoadIcon_ResponseParams_Data* params =
      reinterpret_cast<
          internal::AppService_LoadIcon_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::apps::mojom::IconValuePtr p_icon_value{};
  AppService_LoadIcon_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadIconValue(&p_icon_value))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        AppService::Name_, 2, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_icon_value));
  return true;
}

void AppService_LoadIcon_ProxyToResponder::Run(
    ::apps::mojom::IconValuePtr in_icon_value) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kAppService_LoadIcon_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::AppService_LoadIcon_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->icon_value)::BaseType::BufferWriter
      icon_value_writer;
  mojo::internal::Serialize<::apps::mojom::IconValueDataView>(
      in_icon_value, buffer, &icon_value_writer, &serialization_context);
  params->icon_value.Set(
      icon_value_writer.is_null() ? nullptr : icon_value_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->icon_value.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null icon_value in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::AppService::LoadIconCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(AppService::Name_);
  message.set_method_name("LoadIcon");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool AppServiceStubDispatch::Accept(
    AppService* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kAppService_RegisterPublisher_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::AppService::RegisterPublisher",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::AppService::RegisterPublisher");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AppService_RegisterPublisher_Params_Data* params =
          reinterpret_cast<internal::AppService_RegisterPublisher_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      PublisherPtr p_publisher{};
      ::apps::mojom::AppType p_app_type{};
      AppService_RegisterPublisher_ParamsDataView input_data_view(params, &serialization_context);
      
      p_publisher =
          input_data_view.TakePublisher<decltype(p_publisher)>();
      if (!input_data_view.ReadAppType(&p_app_type))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            AppService::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->RegisterPublisher(
std::move(p_publisher), 
std::move(p_app_type));
      return true;
    }
    case internal::kAppService_RegisterSubscriber_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::AppService::RegisterSubscriber",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::AppService::RegisterSubscriber");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AppService_RegisterSubscriber_Params_Data* params =
          reinterpret_cast<internal::AppService_RegisterSubscriber_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      SubscriberPtr p_subscriber{};
      ConnectOptionsPtr p_opts{};
      AppService_RegisterSubscriber_ParamsDataView input_data_view(params, &serialization_context);
      
      p_subscriber =
          input_data_view.TakeSubscriber<decltype(p_subscriber)>();
      if (!input_data_view.ReadOpts(&p_opts))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            AppService::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->RegisterSubscriber(
std::move(p_subscriber), 
std::move(p_opts));
      return true;
    }
    case internal::kAppService_LoadIcon_Name: {
      break;
    }
    case internal::kAppService_Launch_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::AppService::Launch",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::AppService::Launch");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AppService_Launch_Params_Data* params =
          reinterpret_cast<internal::AppService_Launch_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::apps::mojom::AppType p_app_type{};
      std::string p_app_id{};
      int32_t p_event_flags{};
      ::apps::mojom::LaunchSource p_launch_source{};
      int64_t p_display_id{};
      AppService_Launch_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppType(&p_app_type))
        success = false;
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      p_event_flags = input_data_view.event_flags();
      if (!input_data_view.ReadLaunchSource(&p_launch_source))
        success = false;
      p_display_id = input_data_view.display_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            AppService::Name_, 3, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Launch(
std::move(p_app_type), 
std::move(p_app_id), 
std::move(p_event_flags), 
std::move(p_launch_source), 
std::move(p_display_id));
      return true;
    }
    case internal::kAppService_SetPermission_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::AppService::SetPermission",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::AppService::SetPermission");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AppService_SetPermission_Params_Data* params =
          reinterpret_cast<internal::AppService_SetPermission_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::apps::mojom::AppType p_app_type{};
      std::string p_app_id{};
      ::apps::mojom::PermissionPtr p_permission{};
      AppService_SetPermission_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppType(&p_app_type))
        success = false;
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!input_data_view.ReadPermission(&p_permission))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            AppService::Name_, 4, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetPermission(
std::move(p_app_type), 
std::move(p_app_id), 
std::move(p_permission));
      return true;
    }
    case internal::kAppService_Uninstall_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::AppService::Uninstall",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::AppService::Uninstall");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AppService_Uninstall_Params_Data* params =
          reinterpret_cast<internal::AppService_Uninstall_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::apps::mojom::AppType p_app_type{};
      std::string p_app_id{};
      AppService_Uninstall_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppType(&p_app_type))
        success = false;
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            AppService::Name_, 5, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Uninstall(
std::move(p_app_type), 
std::move(p_app_id));
      return true;
    }
    case internal::kAppService_OpenNativeSettings_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::AppService::OpenNativeSettings",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::AppService::OpenNativeSettings");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::AppService_OpenNativeSettings_Params_Data* params =
          reinterpret_cast<internal::AppService_OpenNativeSettings_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::apps::mojom::AppType p_app_type{};
      std::string p_app_id{};
      AppService_OpenNativeSettings_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppType(&p_app_type))
        success = false;
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            AppService::Name_, 6, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OpenNativeSettings(
std::move(p_app_type), 
std::move(p_app_id));
      return true;
    }
  }
  return false;
}

// static
bool AppServiceStubDispatch::AcceptWithResponder(
    AppService* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kAppService_RegisterPublisher_Name: {
      break;
    }
    case internal::kAppService_RegisterSubscriber_Name: {
      break;
    }
    case internal::kAppService_LoadIcon_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::AppService::LoadIcon",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::AppService::LoadIcon");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      internal::AppService_LoadIcon_Params_Data* params =
          reinterpret_cast<
              internal::AppService_LoadIcon_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::apps::mojom::AppType p_app_type{};
      std::string p_app_id{};
      ::apps::mojom::IconKeyPtr p_icon_key{};
      ::apps::mojom::IconCompression p_icon_compression{};
      int32_t p_size_hint_in_dip{};
      bool p_allow_placeholder_icon{};
      AppService_LoadIcon_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppType(&p_app_type))
        success = false;
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!input_data_view.ReadIconKey(&p_icon_key))
        success = false;
      if (!input_data_view.ReadIconCompression(&p_icon_compression))
        success = false;
      p_size_hint_in_dip = input_data_view.size_hint_in_dip();
      p_allow_placeholder_icon = input_data_view.allow_placeholder_icon();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            AppService::Name_, 2, false);
        return false;
      }
      AppService::LoadIconCallback callback =
          AppService_LoadIcon_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->LoadIcon(
std::move(p_app_type), 
std::move(p_app_id), 
std::move(p_icon_key), 
std::move(p_icon_compression), 
std::move(p_size_hint_in_dip), 
std::move(p_allow_placeholder_icon), std::move(callback));
      return true;
    }
    case internal::kAppService_Launch_Name: {
      break;
    }
    case internal::kAppService_SetPermission_Name: {
      break;
    }
    case internal::kAppService_Uninstall_Name: {
      break;
    }
    case internal::kAppService_OpenNativeSettings_Name: {
      break;
    }
  }
  return false;
}

bool AppServiceRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "AppService RequestValidator");

  switch (message->header()->name) {
    case internal::kAppService_RegisterPublisher_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AppService_RegisterPublisher_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAppService_RegisterSubscriber_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AppService_RegisterSubscriber_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAppService_LoadIcon_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AppService_LoadIcon_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAppService_Launch_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AppService_Launch_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAppService_SetPermission_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AppService_SetPermission_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAppService_Uninstall_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AppService_Uninstall_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kAppService_OpenNativeSettings_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::AppService_OpenNativeSettings_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool AppServiceResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "AppService ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kAppService_LoadIcon_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::AppService_LoadIcon_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
const char Publisher::Name_[] = "apps.mojom.Publisher";

class Publisher_LoadIcon_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  Publisher_LoadIcon_ForwardToCallback(
      Publisher::LoadIconCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  Publisher::LoadIconCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(Publisher_LoadIcon_ForwardToCallback);
};

PublisherProxy::PublisherProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PublisherProxy::Connect(
    SubscriberPtr in_subscriber, ConnectOptionsPtr in_opts) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::Publisher::Connect");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPublisher_Connect_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Publisher_Connect_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::SubscriberPtrDataView>(
      in_subscriber, &params->subscriber, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->subscriber),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid subscriber in Publisher.Connect request");
  typename decltype(params->opts)::BaseType::BufferWriter
      opts_writer;
  mojo::internal::Serialize<::apps::mojom::ConnectOptionsDataView>(
      in_opts, buffer, &opts_writer, &serialization_context);
  params->opts.Set(
      opts_writer.is_null() ? nullptr : opts_writer.data());
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Publisher::Name_);
  message.set_method_name("Connect");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PublisherProxy::LoadIcon(
    const std::string& in_app_id, ::apps::mojom::IconKeyPtr in_icon_key, ::apps::mojom::IconCompression in_icon_compression, int32_t in_size_hint_in_dip, bool in_allow_placeholder_icon, LoadIconCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::Publisher::LoadIcon");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPublisher_LoadIcon_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Publisher_LoadIcon_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in Publisher.LoadIcon request");
  typename decltype(params->icon_key)::BaseType::BufferWriter
      icon_key_writer;
  mojo::internal::Serialize<::apps::mojom::IconKeyDataView>(
      in_icon_key, buffer, &icon_key_writer, &serialization_context);
  params->icon_key.Set(
      icon_key_writer.is_null() ? nullptr : icon_key_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->icon_key.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null icon_key in Publisher.LoadIcon request");
  mojo::internal::Serialize<::apps::mojom::IconCompression>(
      in_icon_compression, &params->icon_compression);
  params->size_hint_in_dip = in_size_hint_in_dip;
  params->allow_placeholder_icon = in_allow_placeholder_icon;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Publisher::Name_);
  message.set_method_name("LoadIcon");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new Publisher_LoadIcon_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void PublisherProxy::Launch(
    const std::string& in_app_id, int32_t in_event_flags, ::apps::mojom::LaunchSource in_launch_source, int64_t in_display_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::Publisher::Launch");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPublisher_Launch_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Publisher_Launch_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in Publisher.Launch request");
  params->event_flags = in_event_flags;
  mojo::internal::Serialize<::apps::mojom::LaunchSource>(
      in_launch_source, &params->launch_source);
  params->display_id = in_display_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Publisher::Name_);
  message.set_method_name("Launch");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PublisherProxy::SetPermission(
    const std::string& in_app_id, ::apps::mojom::PermissionPtr in_permission) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::Publisher::SetPermission");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPublisher_SetPermission_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Publisher_SetPermission_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in Publisher.SetPermission request");
  typename decltype(params->permission)::BaseType::BufferWriter
      permission_writer;
  mojo::internal::Serialize<::apps::mojom::PermissionDataView>(
      in_permission, buffer, &permission_writer, &serialization_context);
  params->permission.Set(
      permission_writer.is_null() ? nullptr : permission_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->permission.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null permission in Publisher.SetPermission request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Publisher::Name_);
  message.set_method_name("SetPermission");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PublisherProxy::Uninstall(
    const std::string& in_app_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::Publisher::Uninstall");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPublisher_Uninstall_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Publisher_Uninstall_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in Publisher.Uninstall request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Publisher::Name_);
  message.set_method_name("Uninstall");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PublisherProxy::OpenNativeSettings(
    const std::string& in_app_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::Publisher::OpenNativeSettings");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPublisher_OpenNativeSettings_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Publisher_OpenNativeSettings_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->app_id)::BaseType::BufferWriter
      app_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_app_id, buffer, &app_id_writer, &serialization_context);
  params->app_id.Set(
      app_id_writer.is_null() ? nullptr : app_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->app_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null app_id in Publisher.OpenNativeSettings request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Publisher::Name_);
  message.set_method_name("OpenNativeSettings");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class Publisher_LoadIcon_ProxyToResponder {
 public:
  static Publisher::LoadIconCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<Publisher_LoadIcon_ProxyToResponder> proxy(
        new Publisher_LoadIcon_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&Publisher_LoadIcon_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~Publisher_LoadIcon_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  Publisher_LoadIcon_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "Publisher::LoadIconCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ::apps::mojom::IconValuePtr in_icon_value);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(Publisher_LoadIcon_ProxyToResponder);
};

bool Publisher_LoadIcon_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::Publisher::LoadIconCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::Publisher_LoadIcon_ResponseParams_Data* params =
      reinterpret_cast<
          internal::Publisher_LoadIcon_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::apps::mojom::IconValuePtr p_icon_value{};
  Publisher_LoadIcon_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadIconValue(&p_icon_value))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        Publisher::Name_, 1, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_icon_value));
  return true;
}

void Publisher_LoadIcon_ProxyToResponder::Run(
    ::apps::mojom::IconValuePtr in_icon_value) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPublisher_LoadIcon_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Publisher_LoadIcon_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->icon_value)::BaseType::BufferWriter
      icon_value_writer;
  mojo::internal::Serialize<::apps::mojom::IconValueDataView>(
      in_icon_value, buffer, &icon_value_writer, &serialization_context);
  params->icon_value.Set(
      icon_value_writer.is_null() ? nullptr : icon_value_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->icon_value.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null icon_value in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::LoadIconCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Publisher::Name_);
  message.set_method_name("LoadIcon");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool PublisherStubDispatch::Accept(
    Publisher* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kPublisher_Connect_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::Connect",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::Connect");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Publisher_Connect_Params_Data* params =
          reinterpret_cast<internal::Publisher_Connect_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      SubscriberPtr p_subscriber{};
      ConnectOptionsPtr p_opts{};
      Publisher_Connect_ParamsDataView input_data_view(params, &serialization_context);
      
      p_subscriber =
          input_data_view.TakeSubscriber<decltype(p_subscriber)>();
      if (!input_data_view.ReadOpts(&p_opts))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Publisher::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Connect(
std::move(p_subscriber), 
std::move(p_opts));
      return true;
    }
    case internal::kPublisher_LoadIcon_Name: {
      break;
    }
    case internal::kPublisher_Launch_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::Launch",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::Launch");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Publisher_Launch_Params_Data* params =
          reinterpret_cast<internal::Publisher_Launch_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_app_id{};
      int32_t p_event_flags{};
      ::apps::mojom::LaunchSource p_launch_source{};
      int64_t p_display_id{};
      Publisher_Launch_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      p_event_flags = input_data_view.event_flags();
      if (!input_data_view.ReadLaunchSource(&p_launch_source))
        success = false;
      p_display_id = input_data_view.display_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Publisher::Name_, 2, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Launch(
std::move(p_app_id), 
std::move(p_event_flags), 
std::move(p_launch_source), 
std::move(p_display_id));
      return true;
    }
    case internal::kPublisher_SetPermission_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::SetPermission",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::SetPermission");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Publisher_SetPermission_Params_Data* params =
          reinterpret_cast<internal::Publisher_SetPermission_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_app_id{};
      ::apps::mojom::PermissionPtr p_permission{};
      Publisher_SetPermission_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!input_data_view.ReadPermission(&p_permission))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Publisher::Name_, 3, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetPermission(
std::move(p_app_id), 
std::move(p_permission));
      return true;
    }
    case internal::kPublisher_Uninstall_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::Uninstall",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::Uninstall");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Publisher_Uninstall_Params_Data* params =
          reinterpret_cast<internal::Publisher_Uninstall_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_app_id{};
      Publisher_Uninstall_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Publisher::Name_, 4, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Uninstall(
std::move(p_app_id));
      return true;
    }
    case internal::kPublisher_OpenNativeSettings_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::OpenNativeSettings",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::OpenNativeSettings");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Publisher_OpenNativeSettings_Params_Data* params =
          reinterpret_cast<internal::Publisher_OpenNativeSettings_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_app_id{};
      Publisher_OpenNativeSettings_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Publisher::Name_, 5, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OpenNativeSettings(
std::move(p_app_id));
      return true;
    }
  }
  return false;
}

// static
bool PublisherStubDispatch::AcceptWithResponder(
    Publisher* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kPublisher_Connect_Name: {
      break;
    }
    case internal::kPublisher_LoadIcon_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::LoadIcon",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::Publisher::LoadIcon");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      internal::Publisher_LoadIcon_Params_Data* params =
          reinterpret_cast<
              internal::Publisher_LoadIcon_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_app_id{};
      ::apps::mojom::IconKeyPtr p_icon_key{};
      ::apps::mojom::IconCompression p_icon_compression{};
      int32_t p_size_hint_in_dip{};
      bool p_allow_placeholder_icon{};
      Publisher_LoadIcon_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAppId(&p_app_id))
        success = false;
      if (!input_data_view.ReadIconKey(&p_icon_key))
        success = false;
      if (!input_data_view.ReadIconCompression(&p_icon_compression))
        success = false;
      p_size_hint_in_dip = input_data_view.size_hint_in_dip();
      p_allow_placeholder_icon = input_data_view.allow_placeholder_icon();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Publisher::Name_, 1, false);
        return false;
      }
      Publisher::LoadIconCallback callback =
          Publisher_LoadIcon_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->LoadIcon(
std::move(p_app_id), 
std::move(p_icon_key), 
std::move(p_icon_compression), 
std::move(p_size_hint_in_dip), 
std::move(p_allow_placeholder_icon), std::move(callback));
      return true;
    }
    case internal::kPublisher_Launch_Name: {
      break;
    }
    case internal::kPublisher_SetPermission_Name: {
      break;
    }
    case internal::kPublisher_Uninstall_Name: {
      break;
    }
    case internal::kPublisher_OpenNativeSettings_Name: {
      break;
    }
  }
  return false;
}

bool PublisherRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "Publisher RequestValidator");

  switch (message->header()->name) {
    case internal::kPublisher_Connect_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Publisher_Connect_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kPublisher_LoadIcon_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Publisher_LoadIcon_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kPublisher_Launch_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Publisher_Launch_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kPublisher_SetPermission_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Publisher_SetPermission_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kPublisher_Uninstall_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Publisher_Uninstall_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kPublisher_OpenNativeSettings_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Publisher_OpenNativeSettings_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool PublisherResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "Publisher ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kPublisher_LoadIcon_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::Publisher_LoadIcon_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
const char Subscriber::Name_[] = "apps.mojom.Subscriber";

SubscriberProxy::SubscriberProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SubscriberProxy::OnApps(
    std::vector<::apps::mojom::AppPtr> in_deltas) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::Subscriber::OnApps");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSubscriber_OnApps_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Subscriber_OnApps_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->deltas)::BaseType::BufferWriter
      deltas_writer;
  const mojo::internal::ContainerValidateParams deltas_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::apps::mojom::AppDataView>>(
      in_deltas, buffer, &deltas_writer, &deltas_validate_params,
      &serialization_context);
  params->deltas.Set(
      deltas_writer.is_null() ? nullptr : deltas_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->deltas.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null deltas in Subscriber.OnApps request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Subscriber::Name_);
  message.set_method_name("OnApps");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void SubscriberProxy::Clone(
    SubscriberRequest in_request) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::Subscriber::Clone");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSubscriber_Clone_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::apps::mojom::internal::Subscriber_Clone_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::apps::mojom::SubscriberRequestDataView>(
      in_request, &params->request, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->request),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid request in Subscriber.Clone request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(Subscriber::Name_);
  message.set_method_name("Clone");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool SubscriberStubDispatch::Accept(
    Subscriber* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kSubscriber_OnApps_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::Subscriber::OnApps",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::Subscriber::OnApps");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Subscriber_OnApps_Params_Data* params =
          reinterpret_cast<internal::Subscriber_OnApps_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<::apps::mojom::AppPtr> p_deltas{};
      Subscriber_OnApps_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadDeltas(&p_deltas))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Subscriber::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnApps(
std::move(p_deltas));
      return true;
    }
    case internal::kSubscriber_Clone_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::Subscriber::Clone",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::Subscriber::Clone");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::Subscriber_Clone_Params_Data* params =
          reinterpret_cast<internal::Subscriber_Clone_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      SubscriberRequest p_request{};
      Subscriber_Clone_ParamsDataView input_data_view(params, &serialization_context);
      
      p_request =
          input_data_view.TakeRequest<decltype(p_request)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            Subscriber::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Clone(
std::move(p_request));
      return true;
    }
  }
  return false;
}

// static
bool SubscriberStubDispatch::AcceptWithResponder(
    Subscriber* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kSubscriber_OnApps_Name: {
      break;
    }
    case internal::kSubscriber_Clone_Name: {
      break;
    }
  }
  return false;
}

bool SubscriberRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "Subscriber RequestValidator");

  switch (message->header()->name) {
    case internal::kSubscriber_OnApps_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Subscriber_OnApps_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kSubscriber_Clone_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::Subscriber_Clone_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace apps

namespace mojo {


// static
bool StructTraits<::apps::mojom::ConnectOptions::DataView, ::apps::mojom::ConnectOptionsPtr>::Read(
    ::apps::mojom::ConnectOptions::DataView input,
    ::apps::mojom::ConnectOptionsPtr* output) {
  bool success = true;
  ::apps::mojom::ConnectOptionsPtr result(::apps::mojom::ConnectOptions::New());
  
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif