// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_TEST_UTILS_H_
#define CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_TEST_UTILS_H_

#include "chrome/services/printing/public/mojom/pdf_nup_converter.mojom.h"


namespace printing {
namespace mojom {


class  PdfNupConverterInterceptorForTesting : public PdfNupConverter {
  virtual PdfNupConverter* GetForwardingInterface() = 0;
  void NupPageConvert(uint32_t pages_per_sheet, const gfx::Size& page_size, const gfx::Rect& printable_area, std::vector<base::ReadOnlySharedMemoryRegion> pdf_page_regions, NupPageConvertCallback callback) override;
  void NupDocumentConvert(uint32_t pages_per_sheet, const gfx::Size& page_size, const gfx::Rect& printable_area, base::ReadOnlySharedMemoryRegion src_pdf_region, NupDocumentConvertCallback callback) override;
  void SetWebContentsURL(const GURL& url) override;
};
class  PdfNupConverterAsyncWaiter {
 public:
  explicit PdfNupConverterAsyncWaiter(PdfNupConverter* proxy);
  ~PdfNupConverterAsyncWaiter();
  void NupPageConvert(
      uint32_t pages_per_sheet, const gfx::Size& page_size, const gfx::Rect& printable_area, std::vector<base::ReadOnlySharedMemoryRegion> pdf_page_regions, PdfNupConverter::Status* out_status, base::ReadOnlySharedMemoryRegion* out_pdf_region);
  void NupDocumentConvert(
      uint32_t pages_per_sheet, const gfx::Size& page_size, const gfx::Rect& printable_area, base::ReadOnlySharedMemoryRegion src_pdf_region, PdfNupConverter::Status* out_status, base::ReadOnlySharedMemoryRegion* out_pdf_region);

 private:
  PdfNupConverter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PdfNupConverterAsyncWaiter);
};




}  // namespace mojom
}  // namespace printing

#endif  // CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_TEST_UTILS_H_