// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_TEST_DATA_WEBUI_WEB_UI_TEST_MOJOM_PARAMS_DATA_H_
#define CHROME_TEST_DATA_WEBUI_WEB_UI_TEST_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace web_ui_test {
namespace mojom {
namespace internal {
class  TestRunner_TestComplete_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TestRunner_TestComplete_Params_Data));
      new (data()) TestRunner_TestComplete_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TestRunner_TestComplete_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TestRunner_TestComplete_Params_Data>(index_);
    }
    TestRunner_TestComplete_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> failureMessage;

 private:
  TestRunner_TestComplete_Params_Data();
  ~TestRunner_TestComplete_Params_Data() = delete;
};
static_assert(sizeof(TestRunner_TestComplete_Params_Data) == 16,
              "Bad sizeof(TestRunner_TestComplete_Params_Data)");

}  // namespace internal
class TestRunner_TestComplete_ParamsDataView {
 public:
  TestRunner_TestComplete_ParamsDataView() {}

  TestRunner_TestComplete_ParamsDataView(
      internal::TestRunner_TestComplete_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFailureMessageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFailureMessage(UserType* output) {
    auto* pointer = data_->failureMessage.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::TestRunner_TestComplete_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void TestRunner_TestComplete_ParamsDataView::GetFailureMessageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->failureMessage.Get();
  *output = mojo::StringDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace web_ui_test

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_TEST_DATA_WEBUI_WEB_UI_TEST_MOJOM_PARAMS_DATA_H_