// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_DATA_REDUCTION_PROXY_CORE_COMMON_DATA_REDUCTION_PROXY_MOJOM_SHARED_INTERNAL_H_
#define COMPONENTS_DATA_REDUCTION_PROXY_CORE_COMMON_DATA_REDUCTION_PROXY_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "services/network/public/mojom/proxy_config.mojom-shared-internal.h"
#include "services/proxy_resolver/public/mojom/proxy_resolver.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace data_reduction_proxy {
namespace mojom {
namespace internal {
class DataReductionProxyServer_Data;
class DataReductionProxyThrottleConfig_Data;

#pragma pack(push, 1)
class  DataReductionProxyServer_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DataReductionProxyServer_Data));
      new (data()) DataReductionProxyServer_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DataReductionProxyServer_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DataReductionProxyServer_Data>(index_);
    }
    DataReductionProxyServer_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::proxy_resolver::mojom::internal::ProxyServer_Data> proxy_server;
  uint8_t is_core : 1;
  uint8_t padfinal_[7];

 private:
  DataReductionProxyServer_Data();
  ~DataReductionProxyServer_Data() = delete;
};
static_assert(sizeof(DataReductionProxyServer_Data) == 24,
              "Bad sizeof(DataReductionProxyServer_Data)");
// Used by DataReductionProxyServer::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct DataReductionProxyServer_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  DataReductionProxyServer_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~DataReductionProxyServer_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    DataReductionProxyServer_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    DataReductionProxyServer_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  DataReductionProxyThrottleConfig_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DataReductionProxyThrottleConfig_Data));
      new (data()) DataReductionProxyThrottleConfig_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DataReductionProxyThrottleConfig_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DataReductionProxyThrottleConfig_Data>(index_);
    }
    DataReductionProxyThrottleConfig_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::DataReductionProxyServer_Data>>> proxies_for_http;

 private:
  DataReductionProxyThrottleConfig_Data();
  ~DataReductionProxyThrottleConfig_Data() = delete;
};
static_assert(sizeof(DataReductionProxyThrottleConfig_Data) == 16,
              "Bad sizeof(DataReductionProxyThrottleConfig_Data)");
// Used by DataReductionProxyThrottleConfig::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct DataReductionProxyThrottleConfig_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  DataReductionProxyThrottleConfig_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~DataReductionProxyThrottleConfig_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    DataReductionProxyThrottleConfig_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    DataReductionProxyThrottleConfig_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace data_reduction_proxy

#endif  // COMPONENTS_DATA_REDUCTION_PROXY_CORE_COMMON_DATA_REDUCTION_PROXY_MOJOM_SHARED_INTERNAL_H_