// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_DOM_DISTILLER_CONTENT_COMMON_DISTILLABILITY_SERVICE_MOJOM_TEST_UTILS_H_
#define COMPONENTS_DOM_DISTILLER_CONTENT_COMMON_DISTILLABILITY_SERVICE_MOJOM_TEST_UTILS_H_

#include "components/dom_distiller/content/common/distillability_service.mojom.h"


namespace dom_distiller {
namespace mojom {


class  DistillabilityServiceInterceptorForTesting : public DistillabilityService {
  virtual DistillabilityService* GetForwardingInterface() = 0;
  void NotifyIsDistillable(bool page_is_distillable, bool is_last_update, bool is_mobile_friendly) override;
};
class  DistillabilityServiceAsyncWaiter {
 public:
  explicit DistillabilityServiceAsyncWaiter(DistillabilityService* proxy);
  ~DistillabilityServiceAsyncWaiter();

 private:
  DistillabilityService* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DistillabilityServiceAsyncWaiter);
};




}  // namespace mojom
}  // namespace dom_distiller

#endif  // COMPONENTS_DOM_DISTILLER_CONTENT_COMMON_DISTILLABILITY_SERVICE_MOJOM_TEST_UTILS_H_