// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_MIRRORING_MOJOM_RESOURCE_PROVIDER_MOJOM_TEST_UTILS_H_
#define COMPONENTS_MIRRORING_MOJOM_RESOURCE_PROVIDER_MOJOM_TEST_UTILS_H_

#include "components/mirroring/mojom/resource_provider.mojom.h"


namespace mirroring {
namespace mojom {


class  AudioStreamCreatorClientInterceptorForTesting : public AudioStreamCreatorClient {
  virtual AudioStreamCreatorClient* GetForwardingInterface() = 0;
  void StreamCreated(::media::mojom::AudioInputStreamPtr stream, ::media::mojom::AudioInputStreamClientRequest client_request, ::media::mojom::ReadOnlyAudioDataPipePtr data_pipe, bool initially_muted) override;
};
class  AudioStreamCreatorClientAsyncWaiter {
 public:
  explicit AudioStreamCreatorClientAsyncWaiter(AudioStreamCreatorClient* proxy);
  ~AudioStreamCreatorClientAsyncWaiter();

 private:
  AudioStreamCreatorClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AudioStreamCreatorClientAsyncWaiter);
};


class  ResourceProviderInterceptorForTesting : public ResourceProvider {
  virtual ResourceProvider* GetForwardingInterface() = 0;
  void GetVideoCaptureHost(::media::mojom::VideoCaptureHostRequest request) override;
  void GetNetworkContext(::network::mojom::NetworkContextRequest request) override;
  void CreateAudioStream(AudioStreamCreatorClientPtr client, const media::AudioParameters& param, uint32_t shared_memory_count) override;
  void ConnectToRemotingSource(::media::mojom::RemoterPtr remoter, ::media::mojom::RemotingSourceRequest request) override;
};
class  ResourceProviderAsyncWaiter {
 public:
  explicit ResourceProviderAsyncWaiter(ResourceProvider* proxy);
  ~ResourceProviderAsyncWaiter();

 private:
  ResourceProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ResourceProviderAsyncWaiter);
};




}  // namespace mojom
}  // namespace mirroring

#endif  // COMPONENTS_MIRRORING_MOJOM_RESOURCE_PROVIDER_MOJOM_TEST_UTILS_H_