// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_MIRRORING_MOJOM_SESSION_OBSERVER_MOJOM_TEST_UTILS_H_
#define COMPONENTS_MIRRORING_MOJOM_SESSION_OBSERVER_MOJOM_TEST_UTILS_H_

#include "components/mirroring/mojom/session_observer.mojom.h"


namespace mirroring {
namespace mojom {


class  SessionObserverInterceptorForTesting : public SessionObserver {
  virtual SessionObserver* GetForwardingInterface() = 0;
  void OnError(SessionError error) override;
  void DidStart() override;
  void DidStop() override;
};
class  SessionObserverAsyncWaiter {
 public:
  explicit SessionObserverAsyncWaiter(SessionObserver* proxy);
  ~SessionObserverAsyncWaiter();

 private:
  SessionObserver* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(SessionObserverAsyncWaiter);
};




}  // namespace mojom
}  // namespace mirroring

#endif  // COMPONENTS_MIRRORING_MOJOM_SESSION_OBSERVER_MOJOM_TEST_UTILS_H_