// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_RAPPOR_PUBLIC_INTERFACES_RAPPOR_RECORDER_MOJOM_PARAMS_DATA_H_
#define COMPONENTS_RAPPOR_PUBLIC_INTERFACES_RAPPOR_RECORDER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace rappor {
namespace mojom {
namespace internal {
class  RapporRecorder_RecordRappor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RapporRecorder_RecordRappor_Params_Data));
      new (data()) RapporRecorder_RecordRappor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RapporRecorder_RecordRappor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RapporRecorder_RecordRappor_Params_Data>(index_);
    }
    RapporRecorder_RecordRappor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> metric;
  mojo::internal::Pointer<mojo::internal::String_Data> sample;

 private:
  RapporRecorder_RecordRappor_Params_Data();
  ~RapporRecorder_RecordRappor_Params_Data() = delete;
};
static_assert(sizeof(RapporRecorder_RecordRappor_Params_Data) == 24,
              "Bad sizeof(RapporRecorder_RecordRappor_Params_Data)");
class  RapporRecorder_RecordRapporURL_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RapporRecorder_RecordRapporURL_Params_Data));
      new (data()) RapporRecorder_RecordRapporURL_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RapporRecorder_RecordRapporURL_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RapporRecorder_RecordRapporURL_Params_Data>(index_);
    }
    RapporRecorder_RecordRapporURL_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> metric;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  RapporRecorder_RecordRapporURL_Params_Data();
  ~RapporRecorder_RecordRapporURL_Params_Data() = delete;
};
static_assert(sizeof(RapporRecorder_RecordRapporURL_Params_Data) == 24,
              "Bad sizeof(RapporRecorder_RecordRapporURL_Params_Data)");

}  // namespace internal
class RapporRecorder_RecordRappor_ParamsDataView {
 public:
  RapporRecorder_RecordRappor_ParamsDataView() {}

  RapporRecorder_RecordRappor_ParamsDataView(
      internal::RapporRecorder_RecordRappor_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMetricDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMetric(UserType* output) {
    auto* pointer = data_->metric.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetSampleDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSample(UserType* output) {
    auto* pointer = data_->sample.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::RapporRecorder_RecordRappor_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class RapporRecorder_RecordRapporURL_ParamsDataView {
 public:
  RapporRecorder_RecordRapporURL_ParamsDataView() {}

  RapporRecorder_RecordRapporURL_ParamsDataView(
      internal::RapporRecorder_RecordRapporURL_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMetricDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMetric(UserType* output) {
    auto* pointer = data_->metric.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::RapporRecorder_RecordRapporURL_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void RapporRecorder_RecordRappor_ParamsDataView::GetMetricDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->metric.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void RapporRecorder_RecordRappor_ParamsDataView::GetSampleDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->sample.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void RapporRecorder_RecordRapporURL_ParamsDataView::GetMetricDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->metric.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void RapporRecorder_RecordRapporURL_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace rappor

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // COMPONENTS_RAPPOR_PUBLIC_INTERFACES_RAPPOR_RECORDER_MOJOM_PARAMS_DATA_H_