// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_PARAMS_DATA_H_
#define COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace printing {
namespace mojom {
namespace internal {
class  PdfCompositor_NotifyUnavailableSubframe_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_NotifyUnavailableSubframe_Params_Data));
      new (data()) PdfCompositor_NotifyUnavailableSubframe_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_NotifyUnavailableSubframe_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_NotifyUnavailableSubframe_Params_Data>(index_);
    }
    PdfCompositor_NotifyUnavailableSubframe_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t frame_guid;

 private:
  PdfCompositor_NotifyUnavailableSubframe_Params_Data();
  ~PdfCompositor_NotifyUnavailableSubframe_Params_Data() = delete;
};
static_assert(sizeof(PdfCompositor_NotifyUnavailableSubframe_Params_Data) == 16,
              "Bad sizeof(PdfCompositor_NotifyUnavailableSubframe_Params_Data)");
class  PdfCompositor_AddSubframeContent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_AddSubframeContent_Params_Data));
      new (data()) PdfCompositor_AddSubframeContent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_AddSubframeContent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_AddSubframeContent_Params_Data>(index_);
    }
    PdfCompositor_AddSubframeContent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t frame_guid;
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data> serialized_content;
  mojo::internal::Pointer<mojo::internal::Map_Data<uint32_t, uint64_t>> subframe_content_info;

 private:
  PdfCompositor_AddSubframeContent_Params_Data();
  ~PdfCompositor_AddSubframeContent_Params_Data() = delete;
};
static_assert(sizeof(PdfCompositor_AddSubframeContent_Params_Data) == 32,
              "Bad sizeof(PdfCompositor_AddSubframeContent_Params_Data)");
class  PdfCompositor_CompositePageToPdf_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_CompositePageToPdf_Params_Data));
      new (data()) PdfCompositor_CompositePageToPdf_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_CompositePageToPdf_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_CompositePageToPdf_Params_Data>(index_);
    }
    PdfCompositor_CompositePageToPdf_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t frame_guid;
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data> sk_region;
  mojo::internal::Pointer<mojo::internal::Map_Data<uint32_t, uint64_t>> subframe_content_info;

 private:
  PdfCompositor_CompositePageToPdf_Params_Data();
  ~PdfCompositor_CompositePageToPdf_Params_Data() = delete;
};
static_assert(sizeof(PdfCompositor_CompositePageToPdf_Params_Data) == 32,
              "Bad sizeof(PdfCompositor_CompositePageToPdf_Params_Data)");
class  PdfCompositor_CompositePageToPdf_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_CompositePageToPdf_ResponseParams_Data));
      new (data()) PdfCompositor_CompositePageToPdf_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_CompositePageToPdf_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_CompositePageToPdf_ResponseParams_Data>(index_);
    }
    PdfCompositor_CompositePageToPdf_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data> pdf_region;

 private:
  PdfCompositor_CompositePageToPdf_ResponseParams_Data();
  ~PdfCompositor_CompositePageToPdf_ResponseParams_Data() = delete;
};
static_assert(sizeof(PdfCompositor_CompositePageToPdf_ResponseParams_Data) == 24,
              "Bad sizeof(PdfCompositor_CompositePageToPdf_ResponseParams_Data)");
class  PdfCompositor_CompositeDocumentToPdf_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_CompositeDocumentToPdf_Params_Data));
      new (data()) PdfCompositor_CompositeDocumentToPdf_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_CompositeDocumentToPdf_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_CompositeDocumentToPdf_Params_Data>(index_);
    }
    PdfCompositor_CompositeDocumentToPdf_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t frame_guid;
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data> sk_region;
  mojo::internal::Pointer<mojo::internal::Map_Data<uint32_t, uint64_t>> subframe_content_info;

 private:
  PdfCompositor_CompositeDocumentToPdf_Params_Data();
  ~PdfCompositor_CompositeDocumentToPdf_Params_Data() = delete;
};
static_assert(sizeof(PdfCompositor_CompositeDocumentToPdf_Params_Data) == 32,
              "Bad sizeof(PdfCompositor_CompositeDocumentToPdf_Params_Data)");
class  PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data));
      new (data()) PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data>(index_);
    }
    PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::ReadOnlySharedMemoryRegion_Data> pdf_region;

 private:
  PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data();
  ~PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data() = delete;
};
static_assert(sizeof(PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data) == 24,
              "Bad sizeof(PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data)");
class  PdfCompositor_SetWebContentsURL_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_SetWebContentsURL_Params_Data));
      new (data()) PdfCompositor_SetWebContentsURL_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_SetWebContentsURL_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_SetWebContentsURL_Params_Data>(index_);
    }
    PdfCompositor_SetWebContentsURL_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  PdfCompositor_SetWebContentsURL_Params_Data();
  ~PdfCompositor_SetWebContentsURL_Params_Data() = delete;
};
static_assert(sizeof(PdfCompositor_SetWebContentsURL_Params_Data) == 16,
              "Bad sizeof(PdfCompositor_SetWebContentsURL_Params_Data)");
class  PdfCompositor_SetUserAgent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_SetUserAgent_Params_Data));
      new (data()) PdfCompositor_SetUserAgent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_SetUserAgent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_SetUserAgent_Params_Data>(index_);
    }
    PdfCompositor_SetUserAgent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> user_agent;

 private:
  PdfCompositor_SetUserAgent_Params_Data();
  ~PdfCompositor_SetUserAgent_Params_Data() = delete;
};
static_assert(sizeof(PdfCompositor_SetUserAgent_Params_Data) == 16,
              "Bad sizeof(PdfCompositor_SetUserAgent_Params_Data)");

}  // namespace internal
class PdfCompositor_NotifyUnavailableSubframe_ParamsDataView {
 public:
  PdfCompositor_NotifyUnavailableSubframe_ParamsDataView() {}

  PdfCompositor_NotifyUnavailableSubframe_ParamsDataView(
      internal::PdfCompositor_NotifyUnavailableSubframe_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint64_t frame_guid() const {
    return data_->frame_guid;
  }
 private:
  internal::PdfCompositor_NotifyUnavailableSubframe_Params_Data* data_ = nullptr;
};

class PdfCompositor_AddSubframeContent_ParamsDataView {
 public:
  PdfCompositor_AddSubframeContent_ParamsDataView() {}

  PdfCompositor_AddSubframeContent_ParamsDataView(
      internal::PdfCompositor_AddSubframeContent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint64_t frame_guid() const {
    return data_->frame_guid;
  }
  inline void GetSerializedContentDataView(
      ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSerializedContent(UserType* output) {
    auto* pointer = data_->serialized_content.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
        pointer, output, context_);
  }
  inline void GetSubframeContentInfoDataView(
      mojo::MapDataView<uint32_t, uint64_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSubframeContentInfo(UserType* output) {
    auto* pointer = data_->subframe_content_info.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<uint32_t, uint64_t>>(
        pointer, output, context_);
  }
 private:
  internal::PdfCompositor_AddSubframeContent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PdfCompositor_CompositePageToPdf_ParamsDataView {
 public:
  PdfCompositor_CompositePageToPdf_ParamsDataView() {}

  PdfCompositor_CompositePageToPdf_ParamsDataView(
      internal::PdfCompositor_CompositePageToPdf_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint64_t frame_guid() const {
    return data_->frame_guid;
  }
  inline void GetSkRegionDataView(
      ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSkRegion(UserType* output) {
    auto* pointer = data_->sk_region.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
        pointer, output, context_);
  }
  inline void GetSubframeContentInfoDataView(
      mojo::MapDataView<uint32_t, uint64_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSubframeContentInfo(UserType* output) {
    auto* pointer = data_->subframe_content_info.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<uint32_t, uint64_t>>(
        pointer, output, context_);
  }
 private:
  internal::PdfCompositor_CompositePageToPdf_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PdfCompositor_CompositePageToPdf_ResponseParamsDataView {
 public:
  PdfCompositor_CompositePageToPdf_ResponseParamsDataView() {}

  PdfCompositor_CompositePageToPdf_ResponseParamsDataView(
      internal::PdfCompositor_CompositePageToPdf_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::printing::mojom::PdfCompositor_Status>(
        data_value, output);
  }

  PdfCompositor_Status status() const {
    return static_cast<PdfCompositor_Status>(data_->status);
  }
  inline void GetPdfRegionDataView(
      ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPdfRegion(UserType* output) {
    auto* pointer = data_->pdf_region.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
        pointer, output, context_);
  }
 private:
  internal::PdfCompositor_CompositePageToPdf_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PdfCompositor_CompositeDocumentToPdf_ParamsDataView {
 public:
  PdfCompositor_CompositeDocumentToPdf_ParamsDataView() {}

  PdfCompositor_CompositeDocumentToPdf_ParamsDataView(
      internal::PdfCompositor_CompositeDocumentToPdf_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint64_t frame_guid() const {
    return data_->frame_guid;
  }
  inline void GetSkRegionDataView(
      ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSkRegion(UserType* output) {
    auto* pointer = data_->sk_region.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
        pointer, output, context_);
  }
  inline void GetSubframeContentInfoDataView(
      mojo::MapDataView<uint32_t, uint64_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSubframeContentInfo(UserType* output) {
    auto* pointer = data_->subframe_content_info.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<uint32_t, uint64_t>>(
        pointer, output, context_);
  }
 private:
  internal::PdfCompositor_CompositeDocumentToPdf_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PdfCompositor_CompositeDocumentToPdf_ResponseParamsDataView {
 public:
  PdfCompositor_CompositeDocumentToPdf_ResponseParamsDataView() {}

  PdfCompositor_CompositeDocumentToPdf_ResponseParamsDataView(
      internal::PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::printing::mojom::PdfCompositor_Status>(
        data_value, output);
  }

  PdfCompositor_Status status() const {
    return static_cast<PdfCompositor_Status>(data_->status);
  }
  inline void GetPdfRegionDataView(
      ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPdfRegion(UserType* output) {
    auto* pointer = data_->pdf_region.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
        pointer, output, context_);
  }
 private:
  internal::PdfCompositor_CompositeDocumentToPdf_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PdfCompositor_SetWebContentsURL_ParamsDataView {
 public:
  PdfCompositor_SetWebContentsURL_ParamsDataView() {}

  PdfCompositor_SetWebContentsURL_ParamsDataView(
      internal::PdfCompositor_SetWebContentsURL_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::PdfCompositor_SetWebContentsURL_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PdfCompositor_SetUserAgent_ParamsDataView {
 public:
  PdfCompositor_SetUserAgent_ParamsDataView() {}

  PdfCompositor_SetUserAgent_ParamsDataView(
      internal::PdfCompositor_SetUserAgent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUserAgentDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUserAgent(UserType* output) {
    auto* pointer = data_->user_agent.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::PdfCompositor_SetUserAgent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void PdfCompositor_AddSubframeContent_ParamsDataView::GetSerializedContentDataView(
    ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output) {
  auto pointer = data_->serialized_content.Get();
  *output = ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView(pointer, context_);
}
inline void PdfCompositor_AddSubframeContent_ParamsDataView::GetSubframeContentInfoDataView(
    mojo::MapDataView<uint32_t, uint64_t>* output) {
  auto pointer = data_->subframe_content_info.Get();
  *output = mojo::MapDataView<uint32_t, uint64_t>(pointer, context_);
}


inline void PdfCompositor_CompositePageToPdf_ParamsDataView::GetSkRegionDataView(
    ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output) {
  auto pointer = data_->sk_region.Get();
  *output = ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView(pointer, context_);
}
inline void PdfCompositor_CompositePageToPdf_ParamsDataView::GetSubframeContentInfoDataView(
    mojo::MapDataView<uint32_t, uint64_t>* output) {
  auto pointer = data_->subframe_content_info.Get();
  *output = mojo::MapDataView<uint32_t, uint64_t>(pointer, context_);
}


inline void PdfCompositor_CompositePageToPdf_ResponseParamsDataView::GetPdfRegionDataView(
    ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output) {
  auto pointer = data_->pdf_region.Get();
  *output = ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView(pointer, context_);
}


inline void PdfCompositor_CompositeDocumentToPdf_ParamsDataView::GetSkRegionDataView(
    ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output) {
  auto pointer = data_->sk_region.Get();
  *output = ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView(pointer, context_);
}
inline void PdfCompositor_CompositeDocumentToPdf_ParamsDataView::GetSubframeContentInfoDataView(
    mojo::MapDataView<uint32_t, uint64_t>* output) {
  auto pointer = data_->subframe_content_info.Get();
  *output = mojo::MapDataView<uint32_t, uint64_t>(pointer, context_);
}


inline void PdfCompositor_CompositeDocumentToPdf_ResponseParamsDataView::GetPdfRegionDataView(
    ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView* output) {
  auto pointer = data_->pdf_region.Get();
  *output = ::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView(pointer, context_);
}


inline void PdfCompositor_SetWebContentsURL_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void PdfCompositor_SetUserAgent_ParamsDataView::GetUserAgentDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->user_agent.Get();
  *output = mojo::StringDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace printing

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_PARAMS_DATA_H_