// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_H_
#define COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "components/services/pdf_compositor/public/interfaces/pdf_compositor.mojom-shared-internal.h"
#include "mojo/public/mojom/base/shared_memory.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace printing {
namespace mojom {


}  // namespace mojom
}  // namespace printing

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace printing {
namespace mojom {


enum class PdfCompositor_Status : int32_t {
  
  SUCCESS = 0,
  
  HANDLE_MAP_ERROR = 1,
  
  CONTENT_FORMAT_ERROR = 2,
  
  COMPOSTING_FAILURE = 3,
  kMinValue = 0,
  kMaxValue = 3,
};

 std::ostream& operator<<(std::ostream& os, PdfCompositor_Status value);
inline bool IsKnownEnumValue(PdfCompositor_Status value) {
  return internal::PdfCompositor_Status_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class PdfCompositorInterfaceBase {};

using PdfCompositorPtrDataView =
    mojo::InterfacePtrDataView<PdfCompositorInterfaceBase>;
using PdfCompositorRequestDataView =
    mojo::InterfaceRequestDataView<PdfCompositorInterfaceBase>;
using PdfCompositorAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PdfCompositorInterfaceBase>;
using PdfCompositorAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PdfCompositorInterfaceBase>;


}  // namespace mojom
}  // namespace printing

namespace std {

template <>
struct hash<::printing::mojom::PdfCompositor_Status>
    : public mojo::internal::EnumHashImpl<::printing::mojom::PdfCompositor_Status> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::printing::mojom::PdfCompositor_Status, ::printing::mojom::PdfCompositor_Status> {
  static ::printing::mojom::PdfCompositor_Status ToMojom(::printing::mojom::PdfCompositor_Status input) { return input; }
  static bool FromMojom(::printing::mojom::PdfCompositor_Status input, ::printing::mojom::PdfCompositor_Status* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::printing::mojom::PdfCompositor_Status, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::printing::mojom::PdfCompositor_Status, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::printing::mojom::PdfCompositor_Status>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace printing {
namespace mojom {


}  // namespace mojom
}  // namespace printing

#endif  // COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_H_