// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_TEST_UTILS_H_
#define COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_TEST_UTILS_H_

#include "components/services/pdf_compositor/public/interfaces/pdf_compositor.mojom.h"


namespace printing {
namespace mojom {


class  PdfCompositorInterceptorForTesting : public PdfCompositor {
  virtual PdfCompositor* GetForwardingInterface() = 0;
  void NotifyUnavailableSubframe(uint64_t frame_guid) override;
  void AddSubframeContent(uint64_t frame_guid, base::ReadOnlySharedMemoryRegion serialized_content, const base::flat_map<uint32_t, uint64_t>& subframe_content_info) override;
  void CompositePageToPdf(uint64_t frame_guid, base::ReadOnlySharedMemoryRegion sk_region, const base::flat_map<uint32_t, uint64_t>& subframe_content_info, CompositePageToPdfCallback callback) override;
  void CompositeDocumentToPdf(uint64_t frame_guid, base::ReadOnlySharedMemoryRegion sk_region, const base::flat_map<uint32_t, uint64_t>& subframe_content_info, CompositeDocumentToPdfCallback callback) override;
  void SetWebContentsURL(const GURL& url) override;
  void SetUserAgent(const std::string& user_agent) override;
};
class  PdfCompositorAsyncWaiter {
 public:
  explicit PdfCompositorAsyncWaiter(PdfCompositor* proxy);
  ~PdfCompositorAsyncWaiter();
  void CompositePageToPdf(
      uint64_t frame_guid, base::ReadOnlySharedMemoryRegion sk_region, const base::flat_map<uint32_t, uint64_t>& subframe_content_info, PdfCompositor::Status* out_status, base::ReadOnlySharedMemoryRegion* out_pdf_region);
  void CompositeDocumentToPdf(
      uint64_t frame_guid, base::ReadOnlySharedMemoryRegion sk_region, const base::flat_map<uint32_t, uint64_t>& subframe_content_info, PdfCompositor::Status* out_status, base::ReadOnlySharedMemoryRegion* out_pdf_region);

 private:
  PdfCompositor* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PdfCompositorAsyncWaiter);
};




}  // namespace mojom
}  // namespace printing

#endif  // COMPONENTS_SERVICES_PDF_COMPOSITOR_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_TEST_UTILS_H_