// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_TRANSLATE_CONTENT_COMMON_TRANSLATE_MOJOM_TEST_UTILS_H_
#define COMPONENTS_TRANSLATE_CONTENT_COMMON_TRANSLATE_MOJOM_TEST_UTILS_H_

#include "components/translate/content/common/translate.mojom.h"


namespace translate {
namespace mojom {


class  PageInterceptorForTesting : public Page {
  virtual Page* GetForwardingInterface() = 0;
  void Translate(const std::string& translate_script, ::network::mojom::URLLoaderFactoryPtr loader_factory_for_translate_script, const std::string& source_lang, const std::string& target_lang, TranslateCallback callback) override;
  void RevertTranslation() override;
};
class  PageAsyncWaiter {
 public:
  explicit PageAsyncWaiter(Page* proxy);
  ~PageAsyncWaiter();
  void Translate(
      const std::string& translate_script, ::network::mojom::URLLoaderFactoryPtr loader_factory_for_translate_script, const std::string& source_lang, const std::string& target_lang, bool* out_cancelled, std::string* out_original_lang, std::string* out_translated_lang, translate::TranslateErrors::Type* out_error);

 private:
  Page* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PageAsyncWaiter);
};


class  ContentTranslateDriverInterceptorForTesting : public ContentTranslateDriver {
  virtual ContentTranslateDriver* GetForwardingInterface() = 0;
  void RegisterPage(PagePtr page, const translate::LanguageDetectionDetails& details, bool page_needs_translation) override;
};
class  ContentTranslateDriverAsyncWaiter {
 public:
  explicit ContentTranslateDriverAsyncWaiter(ContentTranslateDriver* proxy);
  ~ContentTranslateDriverAsyncWaiter();

 private:
  ContentTranslateDriver* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ContentTranslateDriverAsyncWaiter);
};




}  // namespace mojom
}  // namespace translate

#endif  // COMPONENTS_TRANSLATE_CONTENT_COMMON_TRANSLATE_MOJOM_TEST_UTILS_H_