// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_ASSOCIATED_INTERFACES_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_ASSOCIATED_INTERFACES_MOJOM_TEST_UTILS_H_

#include "content/common/associated_interfaces.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT RouteProviderInterceptorForTesting : public RouteProvider {
  virtual RouteProvider* GetForwardingInterface() = 0;
  void GetRoute(int32_t routing_id, ::blink::mojom::AssociatedInterfaceProviderAssociatedRequest request) override;
};
class CONTENT_EXPORT RouteProviderAsyncWaiter {
 public:
  explicit RouteProviderAsyncWaiter(RouteProvider* proxy);
  ~RouteProviderAsyncWaiter();

 private:
  RouteProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RouteProviderAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_ASSOCIATED_INTERFACES_MOJOM_TEST_UTILS_H_