// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_CHILD_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_CHILD_MOJOM_TEST_UTILS_H_

#include "content/common/child.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT ChildInterceptorForTesting : public Child {
  virtual Child* GetForwardingInterface() = 0;
  void CrashHungProcess() override;
};
class CONTENT_EXPORT ChildAsyncWaiter {
 public:
  explicit ChildAsyncWaiter(Child* proxy);
  ~ChildAsyncWaiter();

 private:
  Child* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ChildAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_CHILD_MOJOM_TEST_UTILS_H_