// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_CHILD_CONTROL_MOJOM_PARAMS_DATA_H_
#define CONTENT_COMMON_CHILD_CONTROL_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace content {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) ChildControl_ProcessShutdown_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ChildControl_ProcessShutdown_Params_Data));
      new (data()) ChildControl_ProcessShutdown_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ChildControl_ProcessShutdown_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ChildControl_ProcessShutdown_Params_Data>(index_);
    }
    ChildControl_ProcessShutdown_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ChildControl_ProcessShutdown_Params_Data();
  ~ChildControl_ProcessShutdown_Params_Data() = delete;
};
static_assert(sizeof(ChildControl_ProcessShutdown_Params_Data) == 8,
              "Bad sizeof(ChildControl_ProcessShutdown_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) ChildControl_RunService_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ChildControl_RunService_Params_Data));
      new (data()) ChildControl_RunService_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ChildControl_RunService_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ChildControl_RunService_Params_Data>(index_);
    }
    ChildControl_RunService_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> service_name;
  mojo::internal::Handle_Data receiver;
  uint8_t padfinal_[4];

 private:
  ChildControl_RunService_Params_Data();
  ~ChildControl_RunService_Params_Data() = delete;
};
static_assert(sizeof(ChildControl_RunService_Params_Data) == 24,
              "Bad sizeof(ChildControl_RunService_Params_Data)");

}  // namespace internal
class ChildControl_ProcessShutdown_ParamsDataView {
 public:
  ChildControl_ProcessShutdown_ParamsDataView() {}

  ChildControl_ProcessShutdown_ParamsDataView(
      internal::ChildControl_ProcessShutdown_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ChildControl_ProcessShutdown_Params_Data* data_ = nullptr;
};

class ChildControl_RunService_ParamsDataView {
 public:
  ChildControl_RunService_ParamsDataView() {}

  ChildControl_RunService_ParamsDataView(
      internal::ChildControl_RunService_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServiceNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServiceName(UserType* output) {
    auto* pointer = data_->service_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeReceiver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfaceRequestDataView<::service_manager::mojom::ServiceInterfaceBase>>(
            &data_->receiver, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ChildControl_RunService_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void ChildControl_RunService_ParamsDataView::GetServiceNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->service_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CONTENT_COMMON_CHILD_CONTROL_MOJOM_PARAMS_DATA_H_