// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_CHILD_CONTROL_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_CHILD_CONTROL_MOJOM_TEST_UTILS_H_

#include "content/common/child_control.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT ChildControlInterceptorForTesting : public ChildControl {
  virtual ChildControl* GetForwardingInterface() = 0;
  void ProcessShutdown() override;
  void RunService(const std::string& service_name, mojo::PendingReceiver<::service_manager::mojom::Service> receiver) override;
};
class CONTENT_EXPORT ChildControlAsyncWaiter {
 public:
  explicit ChildControlAsyncWaiter(ChildControl* proxy);
  ~ChildControlAsyncWaiter();

 private:
  ChildControl* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ChildControlAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_CHILD_CONTROL_MOJOM_TEST_UTILS_H_