// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FIELD_TRIAL_RECORDER_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_FIELD_TRIAL_RECORDER_MOJOM_TEST_UTILS_H_

#include "content/common/field_trial_recorder.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT FieldTrialRecorderInterceptorForTesting : public FieldTrialRecorder {
  virtual FieldTrialRecorder* GetForwardingInterface() = 0;
  void FieldTrialActivated(const std::string& trial_name) override;
};
class CONTENT_EXPORT FieldTrialRecorderAsyncWaiter {
 public:
  explicit FieldTrialRecorderAsyncWaiter(FieldTrialRecorder* proxy);
  ~FieldTrialRecorderAsyncWaiter();

 private:
  FieldTrialRecorder* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FieldTrialRecorderAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_FIELD_TRIAL_RECORDER_MOJOM_TEST_UTILS_H_