// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FRAME_MESSAGES_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_FRAME_MESSAGES_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/service_manager/public/mojom/interface_provider.mojom-shared-internal.h"
#include "third_party/blink/public/mojom/frame/document_interface_broker.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {
using DidCommitProvisionalLoadParams_Data = mojo::native::internal::NativeStruct_Data;
class DidCommitProvisionalLoadInterfaceParams_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) DidCommitProvisionalLoadInterfaceParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DidCommitProvisionalLoadInterfaceParams_Data));
      new (data()) DidCommitProvisionalLoadInterfaceParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DidCommitProvisionalLoadInterfaceParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DidCommitProvisionalLoadInterfaceParams_Data>(index_);
    }
    DidCommitProvisionalLoadInterfaceParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data interface_provider_request;
  mojo::internal::Handle_Data document_interface_broker_content_request;
  mojo::internal::Handle_Data document_interface_broker_blink_request;
  uint8_t padfinal_[4];

 private:
  DidCommitProvisionalLoadInterfaceParams_Data();
  ~DidCommitProvisionalLoadInterfaceParams_Data() = delete;
};
static_assert(sizeof(DidCommitProvisionalLoadInterfaceParams_Data) == 24,
              "Bad sizeof(DidCommitProvisionalLoadInterfaceParams_Data)");
// Used by DidCommitProvisionalLoadInterfaceParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct DidCommitProvisionalLoadInterfaceParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  DidCommitProvisionalLoadInterfaceParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~DidCommitProvisionalLoadInterfaceParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    DidCommitProvisionalLoadInterfaceParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    DidCommitProvisionalLoadInterfaceParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_FRAME_MESSAGES_MOJOM_SHARED_INTERNAL_H_