// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/frame_messages.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "content/common/frame_messages.mojom-params-data.h"
#include "content/common/frame_messages.mojom-shared-message-ids.h"

#include "content/common/frame_messages.mojom-import-headers.h"


#ifndef CONTENT_COMMON_FRAME_MESSAGES_MOJOM_JUMBO_H_
#define CONTENT_COMMON_FRAME_MESSAGES_MOJOM_JUMBO_H_
#endif
namespace content {
namespace mojom {
DidCommitProvisionalLoadInterfaceParams::DidCommitProvisionalLoadInterfaceParams()
    : interface_provider_request(),
      document_interface_broker_content_request(),
      document_interface_broker_blink_request() {}

DidCommitProvisionalLoadInterfaceParams::DidCommitProvisionalLoadInterfaceParams(
    ::service_manager::mojom::InterfaceProviderRequest interface_provider_request_in,
    ::blink::mojom::DocumentInterfaceBrokerRequest document_interface_broker_content_request_in,
    ::blink::mojom::DocumentInterfaceBrokerRequest document_interface_broker_blink_request_in)
    : interface_provider_request(std::move(interface_provider_request_in)),
      document_interface_broker_content_request(std::move(document_interface_broker_content_request_in)),
      document_interface_broker_blink_request(std::move(document_interface_broker_blink_request_in)) {}

DidCommitProvisionalLoadInterfaceParams::~DidCommitProvisionalLoadInterfaceParams() = default;

bool DidCommitProvisionalLoadInterfaceParams::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace content

namespace mojo {


// static
bool StructTraits<::content::mojom::DidCommitProvisionalLoadInterfaceParams::DataView, ::content::mojom::DidCommitProvisionalLoadInterfaceParamsPtr>::Read(
    ::content::mojom::DidCommitProvisionalLoadInterfaceParams::DataView input,
    ::content::mojom::DidCommitProvisionalLoadInterfaceParamsPtr* output) {
  bool success = true;
  ::content::mojom::DidCommitProvisionalLoadInterfaceParamsPtr result(::content::mojom::DidCommitProvisionalLoadInterfaceParams::New());
  
      result->interface_provider_request =
          input.TakeInterfaceProviderRequest<decltype(result->interface_provider_request)>();
      result->document_interface_broker_content_request =
          input.TakeDocumentInterfaceBrokerContentRequest<decltype(result->document_interface_broker_content_request)>();
      result->document_interface_broker_blink_request =
          input.TakeDocumentInterfaceBrokerBlinkRequest<decltype(result->document_interface_broker_blink_request)>();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif