// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_NAVIGATION_CLIENT_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_NAVIGATION_CLIENT_MOJOM_TEST_UTILS_H_

#include "content/common/navigation_client.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT NavigationClientInterceptorForTesting : public NavigationClient {
  virtual NavigationClient* GetForwardingInterface() = 0;
  void CommitNavigation(const network::ResourceResponseHead& head, const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, ::network::mojom::URLLoaderClientEndpointsPtr url_loader_client_endpoints, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, base::Optional<std::vector<::content::mojom::TransferrableURLLoaderPtr>> subresource_overrides, ::blink::mojom::ControllerServiceWorkerInfoPtr controller_service_worker_info, ::blink::mojom::ServiceWorkerProviderInfoForWindowPtr provider_info, ::network::mojom::URLLoaderFactoryPtr prefetch_loader_factory, const base::UnguessableToken& devtools_navigation_token, CommitNavigationCallback callback) override;
  void CommitFailedNavigation(const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, bool has_stale_copy_in_cache, int32_t error_code, const base::Optional<std::string>& error_page_content, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, CommitFailedNavigationCallback callback) override;
};
class CONTENT_EXPORT NavigationClientAsyncWaiter {
 public:
  explicit NavigationClientAsyncWaiter(NavigationClient* proxy);
  ~NavigationClientAsyncWaiter();
  void CommitNavigation(
      const network::ResourceResponseHead& head, const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, ::network::mojom::URLLoaderClientEndpointsPtr url_loader_client_endpoints, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, base::Optional<std::vector<::content::mojom::TransferrableURLLoaderPtr>> subresource_overrides, ::blink::mojom::ControllerServiceWorkerInfoPtr controller_service_worker_info, ::blink::mojom::ServiceWorkerProviderInfoForWindowPtr provider_info, ::network::mojom::URLLoaderFactoryPtr prefetch_loader_factory, const base::UnguessableToken& devtools_navigation_token, std::unique_ptr<::FrameHostMsg_DidCommitProvisionalLoad_Params>* out_params, ::content::mojom::DidCommitProvisionalLoadInterfaceParamsPtr* out_interface_params);
  void CommitFailedNavigation(
      const content::CommonNavigationParams& common_params, const content::CommitNavigationParams& request_params, bool has_stale_copy_in_cache, int32_t error_code, const base::Optional<std::string>& error_page_content, std::unique_ptr<blink::URLLoaderFactoryBundleInfo> subresource_loader_factories, std::unique_ptr<::FrameHostMsg_DidCommitProvisionalLoad_Params>* out_params, ::content::mojom::DidCommitProvisionalLoadInterfaceParamsPtr* out_interface_params);

 private:
  NavigationClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(NavigationClientAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_NAVIGATION_CLIENT_MOJOM_TEST_UTILS_H_