// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "content/public/common/resource_usage_reporter.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef CONTENT_PUBLIC_COMMON_RESOURCE_USAGE_REPORTER_MOJOM_JUMBO_H_
#define CONTENT_PUBLIC_COMMON_RESOURCE_USAGE_REPORTER_MOJOM_JUMBO_H_
#endif


namespace content {
namespace mojom {


void ResourceUsageReporterInterceptorForTesting::GetUsageData(GetUsageDataCallback callback) {
  GetForwardingInterface()->GetUsageData(std::move(callback));
}
ResourceUsageReporterAsyncWaiter::ResourceUsageReporterAsyncWaiter(
    ResourceUsageReporter* proxy) : proxy_(proxy) {}

ResourceUsageReporterAsyncWaiter::~ResourceUsageReporterAsyncWaiter() = default;

void ResourceUsageReporterAsyncWaiter::GetUsageData(
    ResourceUsageDataPtr* out_data) {
  base::RunLoop loop;
  proxy_->GetUsageData(
      base::BindOnce(
          [](base::RunLoop* loop,
             ResourceUsageDataPtr* out_data
,
             ResourceUsageDataPtr data) {*out_data = std::move(data);
            loop->Quit();
          },
          &loop,
          out_data));
  loop.Run();
}





}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif