// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_BLUETOOTH_PUBLIC_MOJOM_DEVICE_MOJOM_PARAMS_DATA_H_
#define DEVICE_BLUETOOTH_PUBLIC_MOJOM_DEVICE_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace bluetooth {
namespace mojom {
namespace internal {
class  Device_Disconnect_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_Disconnect_Params_Data));
      new (data()) Device_Disconnect_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_Disconnect_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_Disconnect_Params_Data>(index_);
    }
    Device_Disconnect_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Device_Disconnect_Params_Data();
  ~Device_Disconnect_Params_Data() = delete;
};
static_assert(sizeof(Device_Disconnect_Params_Data) == 8,
              "Bad sizeof(Device_Disconnect_Params_Data)");
class  Device_GetInfo_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_GetInfo_Params_Data));
      new (data()) Device_GetInfo_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_GetInfo_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_GetInfo_Params_Data>(index_);
    }
    Device_GetInfo_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Device_GetInfo_Params_Data();
  ~Device_GetInfo_Params_Data() = delete;
};
static_assert(sizeof(Device_GetInfo_Params_Data) == 8,
              "Bad sizeof(Device_GetInfo_Params_Data)");
class  Device_GetInfo_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_GetInfo_ResponseParams_Data));
      new (data()) Device_GetInfo_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_GetInfo_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_GetInfo_ResponseParams_Data>(index_);
    }
    Device_GetInfo_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::DeviceInfo_Data> info;

 private:
  Device_GetInfo_ResponseParams_Data();
  ~Device_GetInfo_ResponseParams_Data() = delete;
};
static_assert(sizeof(Device_GetInfo_ResponseParams_Data) == 16,
              "Bad sizeof(Device_GetInfo_ResponseParams_Data)");
class  Device_GetServices_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_GetServices_Params_Data));
      new (data()) Device_GetServices_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_GetServices_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_GetServices_Params_Data>(index_);
    }
    Device_GetServices_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Device_GetServices_Params_Data();
  ~Device_GetServices_Params_Data() = delete;
};
static_assert(sizeof(Device_GetServices_Params_Data) == 8,
              "Bad sizeof(Device_GetServices_Params_Data)");
class  Device_GetServices_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_GetServices_ResponseParams_Data));
      new (data()) Device_GetServices_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_GetServices_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_GetServices_ResponseParams_Data>(index_);
    }
    Device_GetServices_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::ServiceInfo_Data>>> services;

 private:
  Device_GetServices_ResponseParams_Data();
  ~Device_GetServices_ResponseParams_Data() = delete;
};
static_assert(sizeof(Device_GetServices_ResponseParams_Data) == 16,
              "Bad sizeof(Device_GetServices_ResponseParams_Data)");
class  Device_GetCharacteristics_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_GetCharacteristics_Params_Data));
      new (data()) Device_GetCharacteristics_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_GetCharacteristics_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_GetCharacteristics_Params_Data>(index_);
    }
    Device_GetCharacteristics_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> service_id;

 private:
  Device_GetCharacteristics_Params_Data();
  ~Device_GetCharacteristics_Params_Data() = delete;
};
static_assert(sizeof(Device_GetCharacteristics_Params_Data) == 16,
              "Bad sizeof(Device_GetCharacteristics_Params_Data)");
class  Device_GetCharacteristics_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_GetCharacteristics_ResponseParams_Data));
      new (data()) Device_GetCharacteristics_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_GetCharacteristics_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_GetCharacteristics_ResponseParams_Data>(index_);
    }
    Device_GetCharacteristics_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::CharacteristicInfo_Data>>> characteristics;

 private:
  Device_GetCharacteristics_ResponseParams_Data();
  ~Device_GetCharacteristics_ResponseParams_Data() = delete;
};
static_assert(sizeof(Device_GetCharacteristics_ResponseParams_Data) == 16,
              "Bad sizeof(Device_GetCharacteristics_ResponseParams_Data)");
class  Device_ReadValueForCharacteristic_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_ReadValueForCharacteristic_Params_Data));
      new (data()) Device_ReadValueForCharacteristic_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_ReadValueForCharacteristic_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_ReadValueForCharacteristic_Params_Data>(index_);
    }
    Device_ReadValueForCharacteristic_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> service_id;
  mojo::internal::Pointer<mojo::internal::String_Data> characteristic_id;

 private:
  Device_ReadValueForCharacteristic_Params_Data();
  ~Device_ReadValueForCharacteristic_Params_Data() = delete;
};
static_assert(sizeof(Device_ReadValueForCharacteristic_Params_Data) == 24,
              "Bad sizeof(Device_ReadValueForCharacteristic_Params_Data)");
class  Device_ReadValueForCharacteristic_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_ReadValueForCharacteristic_ResponseParams_Data));
      new (data()) Device_ReadValueForCharacteristic_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_ReadValueForCharacteristic_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_ReadValueForCharacteristic_ResponseParams_Data>(index_);
    }
    Device_ReadValueForCharacteristic_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;

 private:
  Device_ReadValueForCharacteristic_ResponseParams_Data();
  ~Device_ReadValueForCharacteristic_ResponseParams_Data() = delete;
};
static_assert(sizeof(Device_ReadValueForCharacteristic_ResponseParams_Data) == 24,
              "Bad sizeof(Device_ReadValueForCharacteristic_ResponseParams_Data)");
class  Device_WriteValueForCharacteristic_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_WriteValueForCharacteristic_Params_Data));
      new (data()) Device_WriteValueForCharacteristic_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_WriteValueForCharacteristic_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_WriteValueForCharacteristic_Params_Data>(index_);
    }
    Device_WriteValueForCharacteristic_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> service_id;
  mojo::internal::Pointer<mojo::internal::String_Data> characteristic_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;

 private:
  Device_WriteValueForCharacteristic_Params_Data();
  ~Device_WriteValueForCharacteristic_Params_Data() = delete;
};
static_assert(sizeof(Device_WriteValueForCharacteristic_Params_Data) == 32,
              "Bad sizeof(Device_WriteValueForCharacteristic_Params_Data)");
class  Device_WriteValueForCharacteristic_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_WriteValueForCharacteristic_ResponseParams_Data));
      new (data()) Device_WriteValueForCharacteristic_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_WriteValueForCharacteristic_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_WriteValueForCharacteristic_ResponseParams_Data>(index_);
    }
    Device_WriteValueForCharacteristic_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  Device_WriteValueForCharacteristic_ResponseParams_Data();
  ~Device_WriteValueForCharacteristic_ResponseParams_Data() = delete;
};
static_assert(sizeof(Device_WriteValueForCharacteristic_ResponseParams_Data) == 16,
              "Bad sizeof(Device_WriteValueForCharacteristic_ResponseParams_Data)");
class  Device_GetDescriptors_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_GetDescriptors_Params_Data));
      new (data()) Device_GetDescriptors_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_GetDescriptors_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_GetDescriptors_Params_Data>(index_);
    }
    Device_GetDescriptors_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> service_id;
  mojo::internal::Pointer<mojo::internal::String_Data> characteristic_id;

 private:
  Device_GetDescriptors_Params_Data();
  ~Device_GetDescriptors_Params_Data() = delete;
};
static_assert(sizeof(Device_GetDescriptors_Params_Data) == 24,
              "Bad sizeof(Device_GetDescriptors_Params_Data)");
class  Device_GetDescriptors_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_GetDescriptors_ResponseParams_Data));
      new (data()) Device_GetDescriptors_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_GetDescriptors_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_GetDescriptors_ResponseParams_Data>(index_);
    }
    Device_GetDescriptors_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::DescriptorInfo_Data>>> descriptors;

 private:
  Device_GetDescriptors_ResponseParams_Data();
  ~Device_GetDescriptors_ResponseParams_Data() = delete;
};
static_assert(sizeof(Device_GetDescriptors_ResponseParams_Data) == 16,
              "Bad sizeof(Device_GetDescriptors_ResponseParams_Data)");
class  Device_ReadValueForDescriptor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_ReadValueForDescriptor_Params_Data));
      new (data()) Device_ReadValueForDescriptor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_ReadValueForDescriptor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_ReadValueForDescriptor_Params_Data>(index_);
    }
    Device_ReadValueForDescriptor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> service_id;
  mojo::internal::Pointer<mojo::internal::String_Data> characteristic_id;
  mojo::internal::Pointer<mojo::internal::String_Data> descriptor_id;

 private:
  Device_ReadValueForDescriptor_Params_Data();
  ~Device_ReadValueForDescriptor_Params_Data() = delete;
};
static_assert(sizeof(Device_ReadValueForDescriptor_Params_Data) == 32,
              "Bad sizeof(Device_ReadValueForDescriptor_Params_Data)");
class  Device_ReadValueForDescriptor_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_ReadValueForDescriptor_ResponseParams_Data));
      new (data()) Device_ReadValueForDescriptor_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_ReadValueForDescriptor_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_ReadValueForDescriptor_ResponseParams_Data>(index_);
    }
    Device_ReadValueForDescriptor_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;

 private:
  Device_ReadValueForDescriptor_ResponseParams_Data();
  ~Device_ReadValueForDescriptor_ResponseParams_Data() = delete;
};
static_assert(sizeof(Device_ReadValueForDescriptor_ResponseParams_Data) == 24,
              "Bad sizeof(Device_ReadValueForDescriptor_ResponseParams_Data)");
class  Device_WriteValueForDescriptor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_WriteValueForDescriptor_Params_Data));
      new (data()) Device_WriteValueForDescriptor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_WriteValueForDescriptor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_WriteValueForDescriptor_Params_Data>(index_);
    }
    Device_WriteValueForDescriptor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> service_id;
  mojo::internal::Pointer<mojo::internal::String_Data> characteristic_id;
  mojo::internal::Pointer<mojo::internal::String_Data> descriptor_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;

 private:
  Device_WriteValueForDescriptor_Params_Data();
  ~Device_WriteValueForDescriptor_Params_Data() = delete;
};
static_assert(sizeof(Device_WriteValueForDescriptor_Params_Data) == 40,
              "Bad sizeof(Device_WriteValueForDescriptor_Params_Data)");
class  Device_WriteValueForDescriptor_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Device_WriteValueForDescriptor_ResponseParams_Data));
      new (data()) Device_WriteValueForDescriptor_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Device_WriteValueForDescriptor_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Device_WriteValueForDescriptor_ResponseParams_Data>(index_);
    }
    Device_WriteValueForDescriptor_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  Device_WriteValueForDescriptor_ResponseParams_Data();
  ~Device_WriteValueForDescriptor_ResponseParams_Data() = delete;
};
static_assert(sizeof(Device_WriteValueForDescriptor_ResponseParams_Data) == 16,
              "Bad sizeof(Device_WriteValueForDescriptor_ResponseParams_Data)");

}  // namespace internal
class Device_Disconnect_ParamsDataView {
 public:
  Device_Disconnect_ParamsDataView() {}

  Device_Disconnect_ParamsDataView(
      internal::Device_Disconnect_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::Device_Disconnect_Params_Data* data_ = nullptr;
};

class Device_GetInfo_ParamsDataView {
 public:
  Device_GetInfo_ParamsDataView() {}

  Device_GetInfo_ParamsDataView(
      internal::Device_GetInfo_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::Device_GetInfo_Params_Data* data_ = nullptr;
};

class Device_GetInfo_ResponseParamsDataView {
 public:
  Device_GetInfo_ResponseParamsDataView() {}

  Device_GetInfo_ResponseParamsDataView(
      internal::Device_GetInfo_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetInfoDataView(
      DeviceInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInfo(UserType* output) {
    auto* pointer = data_->info.Get();
    return mojo::internal::Deserialize<::bluetooth::mojom::DeviceInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::Device_GetInfo_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_GetServices_ParamsDataView {
 public:
  Device_GetServices_ParamsDataView() {}

  Device_GetServices_ParamsDataView(
      internal::Device_GetServices_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::Device_GetServices_Params_Data* data_ = nullptr;
};

class Device_GetServices_ResponseParamsDataView {
 public:
  Device_GetServices_ResponseParamsDataView() {}

  Device_GetServices_ResponseParamsDataView(
      internal::Device_GetServices_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServicesDataView(
      mojo::ArrayDataView<ServiceInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServices(UserType* output) {
    auto* pointer = data_->services.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::bluetooth::mojom::ServiceInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::Device_GetServices_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_GetCharacteristics_ParamsDataView {
 public:
  Device_GetCharacteristics_ParamsDataView() {}

  Device_GetCharacteristics_ParamsDataView(
      internal::Device_GetCharacteristics_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServiceIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServiceId(UserType* output) {
    auto* pointer = data_->service_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::Device_GetCharacteristics_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_GetCharacteristics_ResponseParamsDataView {
 public:
  Device_GetCharacteristics_ResponseParamsDataView() {}

  Device_GetCharacteristics_ResponseParamsDataView(
      internal::Device_GetCharacteristics_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCharacteristicsDataView(
      mojo::ArrayDataView<CharacteristicInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCharacteristics(UserType* output) {
    auto* pointer = data_->characteristics.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::bluetooth::mojom::CharacteristicInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::Device_GetCharacteristics_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_ReadValueForCharacteristic_ParamsDataView {
 public:
  Device_ReadValueForCharacteristic_ParamsDataView() {}

  Device_ReadValueForCharacteristic_ParamsDataView(
      internal::Device_ReadValueForCharacteristic_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServiceIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServiceId(UserType* output) {
    auto* pointer = data_->service_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetCharacteristicIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCharacteristicId(UserType* output) {
    auto* pointer = data_->characteristic_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::Device_ReadValueForCharacteristic_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_ReadValueForCharacteristic_ResponseParamsDataView {
 public:
  Device_ReadValueForCharacteristic_ResponseParamsDataView() {}

  Device_ReadValueForCharacteristic_ResponseParamsDataView(
      internal::Device_ReadValueForCharacteristic_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) const {
    auto data_value = data_->result;
    return mojo::internal::Deserialize<::bluetooth::mojom::GattResult>(
        data_value, output);
  }

  GattResult result() const {
    return static_cast<GattResult>(data_->result);
  }
  inline void GetValueDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::Device_ReadValueForCharacteristic_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_WriteValueForCharacteristic_ParamsDataView {
 public:
  Device_WriteValueForCharacteristic_ParamsDataView() {}

  Device_WriteValueForCharacteristic_ParamsDataView(
      internal::Device_WriteValueForCharacteristic_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServiceIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServiceId(UserType* output) {
    auto* pointer = data_->service_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetCharacteristicIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCharacteristicId(UserType* output) {
    auto* pointer = data_->characteristic_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::Device_WriteValueForCharacteristic_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_WriteValueForCharacteristic_ResponseParamsDataView {
 public:
  Device_WriteValueForCharacteristic_ResponseParamsDataView() {}

  Device_WriteValueForCharacteristic_ResponseParamsDataView(
      internal::Device_WriteValueForCharacteristic_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) const {
    auto data_value = data_->result;
    return mojo::internal::Deserialize<::bluetooth::mojom::GattResult>(
        data_value, output);
  }

  GattResult result() const {
    return static_cast<GattResult>(data_->result);
  }
 private:
  internal::Device_WriteValueForCharacteristic_ResponseParams_Data* data_ = nullptr;
};

class Device_GetDescriptors_ParamsDataView {
 public:
  Device_GetDescriptors_ParamsDataView() {}

  Device_GetDescriptors_ParamsDataView(
      internal::Device_GetDescriptors_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServiceIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServiceId(UserType* output) {
    auto* pointer = data_->service_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetCharacteristicIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCharacteristicId(UserType* output) {
    auto* pointer = data_->characteristic_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::Device_GetDescriptors_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_GetDescriptors_ResponseParamsDataView {
 public:
  Device_GetDescriptors_ResponseParamsDataView() {}

  Device_GetDescriptors_ResponseParamsDataView(
      internal::Device_GetDescriptors_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDescriptorsDataView(
      mojo::ArrayDataView<DescriptorInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDescriptors(UserType* output) {
    auto* pointer = data_->descriptors.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::bluetooth::mojom::DescriptorInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::Device_GetDescriptors_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_ReadValueForDescriptor_ParamsDataView {
 public:
  Device_ReadValueForDescriptor_ParamsDataView() {}

  Device_ReadValueForDescriptor_ParamsDataView(
      internal::Device_ReadValueForDescriptor_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServiceIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServiceId(UserType* output) {
    auto* pointer = data_->service_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetCharacteristicIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCharacteristicId(UserType* output) {
    auto* pointer = data_->characteristic_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDescriptorIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDescriptorId(UserType* output) {
    auto* pointer = data_->descriptor_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::Device_ReadValueForDescriptor_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_ReadValueForDescriptor_ResponseParamsDataView {
 public:
  Device_ReadValueForDescriptor_ResponseParamsDataView() {}

  Device_ReadValueForDescriptor_ResponseParamsDataView(
      internal::Device_ReadValueForDescriptor_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) const {
    auto data_value = data_->result;
    return mojo::internal::Deserialize<::bluetooth::mojom::GattResult>(
        data_value, output);
  }

  GattResult result() const {
    return static_cast<GattResult>(data_->result);
  }
  inline void GetValueDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::Device_ReadValueForDescriptor_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_WriteValueForDescriptor_ParamsDataView {
 public:
  Device_WriteValueForDescriptor_ParamsDataView() {}

  Device_WriteValueForDescriptor_ParamsDataView(
      internal::Device_WriteValueForDescriptor_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetServiceIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadServiceId(UserType* output) {
    auto* pointer = data_->service_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetCharacteristicIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCharacteristicId(UserType* output) {
    auto* pointer = data_->characteristic_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetDescriptorIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDescriptorId(UserType* output) {
    auto* pointer = data_->descriptor_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetValueDataView(
      mojo::ArrayDataView<uint8_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint8_t>>(
        pointer, output, context_);
  }
 private:
  internal::Device_WriteValueForDescriptor_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Device_WriteValueForDescriptor_ResponseParamsDataView {
 public:
  Device_WriteValueForDescriptor_ResponseParamsDataView() {}

  Device_WriteValueForDescriptor_ResponseParamsDataView(
      internal::Device_WriteValueForDescriptor_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) const {
    auto data_value = data_->result;
    return mojo::internal::Deserialize<::bluetooth::mojom::GattResult>(
        data_value, output);
  }

  GattResult result() const {
    return static_cast<GattResult>(data_->result);
  }
 private:
  internal::Device_WriteValueForDescriptor_ResponseParams_Data* data_ = nullptr;
};






inline void Device_GetInfo_ResponseParamsDataView::GetInfoDataView(
    DeviceInfoDataView* output) {
  auto pointer = data_->info.Get();
  *output = DeviceInfoDataView(pointer, context_);
}




inline void Device_GetServices_ResponseParamsDataView::GetServicesDataView(
    mojo::ArrayDataView<ServiceInfoDataView>* output) {
  auto pointer = data_->services.Get();
  *output = mojo::ArrayDataView<ServiceInfoDataView>(pointer, context_);
}


inline void Device_GetCharacteristics_ParamsDataView::GetServiceIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->service_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void Device_GetCharacteristics_ResponseParamsDataView::GetCharacteristicsDataView(
    mojo::ArrayDataView<CharacteristicInfoDataView>* output) {
  auto pointer = data_->characteristics.Get();
  *output = mojo::ArrayDataView<CharacteristicInfoDataView>(pointer, context_);
}


inline void Device_ReadValueForCharacteristic_ParamsDataView::GetServiceIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->service_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_ReadValueForCharacteristic_ParamsDataView::GetCharacteristicIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->characteristic_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void Device_ReadValueForCharacteristic_ResponseParamsDataView::GetValueDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->value.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void Device_WriteValueForCharacteristic_ParamsDataView::GetServiceIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->service_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_WriteValueForCharacteristic_ParamsDataView::GetCharacteristicIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->characteristic_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_WriteValueForCharacteristic_ParamsDataView::GetValueDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->value.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}




inline void Device_GetDescriptors_ParamsDataView::GetServiceIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->service_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_GetDescriptors_ParamsDataView::GetCharacteristicIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->characteristic_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void Device_GetDescriptors_ResponseParamsDataView::GetDescriptorsDataView(
    mojo::ArrayDataView<DescriptorInfoDataView>* output) {
  auto pointer = data_->descriptors.Get();
  *output = mojo::ArrayDataView<DescriptorInfoDataView>(pointer, context_);
}


inline void Device_ReadValueForDescriptor_ParamsDataView::GetServiceIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->service_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_ReadValueForDescriptor_ParamsDataView::GetCharacteristicIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->characteristic_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_ReadValueForDescriptor_ParamsDataView::GetDescriptorIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->descriptor_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void Device_ReadValueForDescriptor_ResponseParamsDataView::GetValueDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->value.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}


inline void Device_WriteValueForDescriptor_ParamsDataView::GetServiceIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->service_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_WriteValueForDescriptor_ParamsDataView::GetCharacteristicIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->characteristic_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_WriteValueForDescriptor_ParamsDataView::GetDescriptorIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->descriptor_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void Device_WriteValueForDescriptor_ParamsDataView::GetValueDataView(
    mojo::ArrayDataView<uint8_t>* output) {
  auto pointer = data_->value.Get();
  *output = mojo::ArrayDataView<uint8_t>(pointer, context_);
}



}  // namespace mojom
}  // namespace bluetooth

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // DEVICE_BLUETOOTH_PUBLIC_MOJOM_DEVICE_MOJOM_PARAMS_DATA_H_