// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef EXTENSIONS_COMMON_MOJO_APP_WINDOW_MOJOM_TEST_UTILS_H_
#define EXTENSIONS_COMMON_MOJO_APP_WINDOW_MOJOM_TEST_UTILS_H_

#include "extensions/common/mojo/app_window.mojom.h"


namespace extensions {
namespace mojom {


class  AppWindowInterceptorForTesting : public AppWindow {
  virtual AppWindow* GetForwardingInterface() = 0;
  void SetVisuallyDeemphasized(bool deemphasized) override;
};
class  AppWindowAsyncWaiter {
 public:
  explicit AppWindowAsyncWaiter(AppWindow* proxy);
  ~AppWindowAsyncWaiter();

 private:
  AppWindow* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AppWindowAsyncWaiter);
};




}  // namespace mojom
}  // namespace extensions

#endif  // EXTENSIONS_COMMON_MOJO_APP_WINDOW_MOJOM_TEST_UTILS_H_