// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_TEST_UTILS_H_
#define EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_TEST_UTILS_H_

#include "extensions/common/mojo/guest_view.mojom.h"


namespace extensions {
namespace mojom {


class  GuestViewInterceptorForTesting : public GuestView {
  virtual GuestView* GetForwardingInterface() = 0;
  void CreateEmbeddedMimeHandlerViewGuest(int32_t render_frame_id, int32_t tab_id, const GURL& original_url, int32_t element_instance_id, const gfx::Size& element_size, ::content::mojom::TransferrableURLLoaderPtr transferrable_url_loader) override;
  void CreateMimeHandlerViewGuest(int32_t render_frame_id, const std::string& view_id, int32_t element_instance_id, const gfx::Size& element_size, ::extensions::mime_handler::BeforeUnloadControlPtr before_unload_control) override;
  void ReadyToCreateMimeHandlerView(int32_t routing_id, bool success) override;
};
class  GuestViewAsyncWaiter {
 public:
  explicit GuestViewAsyncWaiter(GuestView* proxy);
  ~GuestViewAsyncWaiter();

 private:
  GuestView* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(GuestViewAsyncWaiter);
};


class  MimeHandlerViewContainerManagerInterceptorForTesting : public MimeHandlerViewContainerManager {
  virtual MimeHandlerViewContainerManager* GetForwardingInterface() = 0;
  void SetInternalId(const std::string& token_id) override;
  void LoadEmptyPage(const GURL& resource_url) override;
  void CreateBeforeUnloadControl(CreateBeforeUnloadControlCallback callback) override;
  void DestroyFrameContainer(int32_t element_instance_id) override;
  void DidLoad(int32_t mime_handler_view_guest_element_instance_id, const GURL& resource_url) override;
};
class  MimeHandlerViewContainerManagerAsyncWaiter {
 public:
  explicit MimeHandlerViewContainerManagerAsyncWaiter(MimeHandlerViewContainerManager* proxy);
  ~MimeHandlerViewContainerManagerAsyncWaiter();
  void CreateBeforeUnloadControl(
      ::extensions::mime_handler::BeforeUnloadControlPtr* out_before_unload_control);

 private:
  MimeHandlerViewContainerManager* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MimeHandlerViewContainerManagerAsyncWaiter);
};




}  // namespace mojom
}  // namespace extensions

#endif  // EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_TEST_UTILS_H_