// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "extensions/common/mojo/guest_view.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "extensions/common/mojo/guest_view.mojom-params-data.h"
#include "extensions/common/mojo/guest_view.mojom-shared-message-ids.h"

#include "extensions/common/mojo/guest_view.mojom-import-headers.h"


#ifndef EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_JUMBO_H_
#define EXTENSIONS_COMMON_MOJO_GUEST_VIEW_MOJOM_JUMBO_H_
#include "services/network/public/cpp/network_ipc_param_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif
namespace extensions {
namespace mojom {
const char GuestView::Name_[] = "extensions.mojom.GuestView";

GuestViewProxy::GuestViewProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void GuestViewProxy::CreateEmbeddedMimeHandlerViewGuest(
    int32_t in_render_frame_id, int32_t in_tab_id, const GURL& in_original_url, int32_t in_element_instance_id, const gfx::Size& in_element_size, ::content::mojom::TransferrableURLLoaderPtr in_transferrable_url_loader) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::GuestView::CreateEmbeddedMimeHandlerViewGuest");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kGuestView_CreateEmbeddedMimeHandlerViewGuest_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::GuestView_CreateEmbeddedMimeHandlerViewGuest_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->render_frame_id = in_render_frame_id;
  params->tab_id = in_tab_id;
  typename decltype(params->original_url)::BaseType::BufferWriter
      original_url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_original_url, buffer, &original_url_writer, &serialization_context);
  params->original_url.Set(
      original_url_writer.is_null() ? nullptr : original_url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->original_url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null original_url in GuestView.CreateEmbeddedMimeHandlerViewGuest request");
  params->element_instance_id = in_element_instance_id;
  typename decltype(params->element_size)::BaseType::BufferWriter
      element_size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_element_size, buffer, &element_size_writer, &serialization_context);
  params->element_size.Set(
      element_size_writer.is_null() ? nullptr : element_size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->element_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null element_size in GuestView.CreateEmbeddedMimeHandlerViewGuest request");
  typename decltype(params->transferrable_url_loader)::BaseType::BufferWriter
      transferrable_url_loader_writer;
  mojo::internal::Serialize<::content::mojom::TransferrableURLLoaderDataView>(
      in_transferrable_url_loader, buffer, &transferrable_url_loader_writer, &serialization_context);
  params->transferrable_url_loader.Set(
      transferrable_url_loader_writer.is_null() ? nullptr : transferrable_url_loader_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->transferrable_url_loader.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null transferrable_url_loader in GuestView.CreateEmbeddedMimeHandlerViewGuest request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(GuestView::Name_);
  message.set_method_name("CreateEmbeddedMimeHandlerViewGuest");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void GuestViewProxy::CreateMimeHandlerViewGuest(
    int32_t in_render_frame_id, const std::string& in_view_id, int32_t in_element_instance_id, const gfx::Size& in_element_size, ::extensions::mime_handler::BeforeUnloadControlPtr in_before_unload_control) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::GuestView::CreateMimeHandlerViewGuest");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kGuestView_CreateMimeHandlerViewGuest_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::GuestView_CreateMimeHandlerViewGuest_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->render_frame_id = in_render_frame_id;
  typename decltype(params->view_id)::BaseType::BufferWriter
      view_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_view_id, buffer, &view_id_writer, &serialization_context);
  params->view_id.Set(
      view_id_writer.is_null() ? nullptr : view_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->view_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null view_id in GuestView.CreateMimeHandlerViewGuest request");
  params->element_instance_id = in_element_instance_id;
  typename decltype(params->element_size)::BaseType::BufferWriter
      element_size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_element_size, buffer, &element_size_writer, &serialization_context);
  params->element_size.Set(
      element_size_writer.is_null() ? nullptr : element_size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->element_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null element_size in GuestView.CreateMimeHandlerViewGuest request");
  mojo::internal::Serialize<::extensions::mime_handler::BeforeUnloadControlPtrDataView>(
      in_before_unload_control, &params->before_unload_control, &serialization_context);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(GuestView::Name_);
  message.set_method_name("CreateMimeHandlerViewGuest");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void GuestViewProxy::ReadyToCreateMimeHandlerView(
    int32_t in_routing_id, bool in_success) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::GuestView::ReadyToCreateMimeHandlerView");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kGuestView_ReadyToCreateMimeHandlerView_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::GuestView_ReadyToCreateMimeHandlerView_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->routing_id = in_routing_id;
  params->success = in_success;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(GuestView::Name_);
  message.set_method_name("ReadyToCreateMimeHandlerView");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool GuestViewStubDispatch::Accept(
    GuestView* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kGuestView_CreateEmbeddedMimeHandlerViewGuest_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::GuestView::CreateEmbeddedMimeHandlerViewGuest",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::GuestView::CreateEmbeddedMimeHandlerViewGuest");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::GuestView_CreateEmbeddedMimeHandlerViewGuest_Params_Data* params =
          reinterpret_cast<internal::GuestView_CreateEmbeddedMimeHandlerViewGuest_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_render_frame_id{};
      int32_t p_tab_id{};
      GURL p_original_url{};
      int32_t p_element_instance_id{};
      gfx::Size p_element_size{};
      ::content::mojom::TransferrableURLLoaderPtr p_transferrable_url_loader{};
      GuestView_CreateEmbeddedMimeHandlerViewGuest_ParamsDataView input_data_view(params, &serialization_context);
      
      p_render_frame_id = input_data_view.render_frame_id();
      p_tab_id = input_data_view.tab_id();
      if (!input_data_view.ReadOriginalUrl(&p_original_url))
        success = false;
      p_element_instance_id = input_data_view.element_instance_id();
      if (!input_data_view.ReadElementSize(&p_element_size))
        success = false;
      if (!input_data_view.ReadTransferrableUrlLoader(&p_transferrable_url_loader))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            GuestView::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateEmbeddedMimeHandlerViewGuest(
std::move(p_render_frame_id), 
std::move(p_tab_id), 
std::move(p_original_url), 
std::move(p_element_instance_id), 
std::move(p_element_size), 
std::move(p_transferrable_url_loader));
      return true;
    }
    case internal::kGuestView_CreateMimeHandlerViewGuest_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::GuestView::CreateMimeHandlerViewGuest",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::GuestView::CreateMimeHandlerViewGuest");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::GuestView_CreateMimeHandlerViewGuest_Params_Data* params =
          reinterpret_cast<internal::GuestView_CreateMimeHandlerViewGuest_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_render_frame_id{};
      std::string p_view_id{};
      int32_t p_element_instance_id{};
      gfx::Size p_element_size{};
      ::extensions::mime_handler::BeforeUnloadControlPtr p_before_unload_control{};
      GuestView_CreateMimeHandlerViewGuest_ParamsDataView input_data_view(params, &serialization_context);
      
      p_render_frame_id = input_data_view.render_frame_id();
      if (!input_data_view.ReadViewId(&p_view_id))
        success = false;
      p_element_instance_id = input_data_view.element_instance_id();
      if (!input_data_view.ReadElementSize(&p_element_size))
        success = false;
      p_before_unload_control =
          input_data_view.TakeBeforeUnloadControl<decltype(p_before_unload_control)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            GuestView::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateMimeHandlerViewGuest(
std::move(p_render_frame_id), 
std::move(p_view_id), 
std::move(p_element_instance_id), 
std::move(p_element_size), 
std::move(p_before_unload_control));
      return true;
    }
    case internal::kGuestView_ReadyToCreateMimeHandlerView_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::GuestView::ReadyToCreateMimeHandlerView",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::GuestView::ReadyToCreateMimeHandlerView");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::GuestView_ReadyToCreateMimeHandlerView_Params_Data* params =
          reinterpret_cast<internal::GuestView_ReadyToCreateMimeHandlerView_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_routing_id{};
      bool p_success{};
      GuestView_ReadyToCreateMimeHandlerView_ParamsDataView input_data_view(params, &serialization_context);
      
      p_routing_id = input_data_view.routing_id();
      p_success = input_data_view.success();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            GuestView::Name_, 2, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->ReadyToCreateMimeHandlerView(
std::move(p_routing_id), 
std::move(p_success));
      return true;
    }
  }
  return false;
}

// static
bool GuestViewStubDispatch::AcceptWithResponder(
    GuestView* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kGuestView_CreateEmbeddedMimeHandlerViewGuest_Name: {
      break;
    }
    case internal::kGuestView_CreateMimeHandlerViewGuest_Name: {
      break;
    }
    case internal::kGuestView_ReadyToCreateMimeHandlerView_Name: {
      break;
    }
  }
  return false;
}

bool GuestViewRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "GuestView RequestValidator");

  switch (message->header()->name) {
    case internal::kGuestView_CreateEmbeddedMimeHandlerViewGuest_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::GuestView_CreateEmbeddedMimeHandlerViewGuest_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kGuestView_CreateMimeHandlerViewGuest_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::GuestView_CreateMimeHandlerViewGuest_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kGuestView_ReadyToCreateMimeHandlerView_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::GuestView_ReadyToCreateMimeHandlerView_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

const char MimeHandlerViewContainerManager::Name_[] = "extensions.mojom.MimeHandlerViewContainerManager";

class MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ForwardToCallback(
      MimeHandlerViewContainerManager::CreateBeforeUnloadControlCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  MimeHandlerViewContainerManager::CreateBeforeUnloadControlCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ForwardToCallback);
};

MimeHandlerViewContainerManagerProxy::MimeHandlerViewContainerManagerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void MimeHandlerViewContainerManagerProxy::SetInternalId(
    const std::string& in_token_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::SetInternalId");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMimeHandlerViewContainerManager_SetInternalId_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::MimeHandlerViewContainerManager_SetInternalId_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->token_id)::BaseType::BufferWriter
      token_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_token_id, buffer, &token_id_writer, &serialization_context);
  params->token_id.Set(
      token_id_writer.is_null() ? nullptr : token_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->token_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null token_id in MimeHandlerViewContainerManager.SetInternalId request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MimeHandlerViewContainerManager::Name_);
  message.set_method_name("SetInternalId");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void MimeHandlerViewContainerManagerProxy::LoadEmptyPage(
    const GURL& in_resource_url) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::LoadEmptyPage");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMimeHandlerViewContainerManager_LoadEmptyPage_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::MimeHandlerViewContainerManager_LoadEmptyPage_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->resource_url)::BaseType::BufferWriter
      resource_url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_resource_url, buffer, &resource_url_writer, &serialization_context);
  params->resource_url.Set(
      resource_url_writer.is_null() ? nullptr : resource_url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->resource_url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null resource_url in MimeHandlerViewContainerManager.LoadEmptyPage request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MimeHandlerViewContainerManager::Name_);
  message.set_method_name("LoadEmptyPage");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void MimeHandlerViewContainerManagerProxy::CreateBeforeUnloadControl(
    CreateBeforeUnloadControlCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::CreateBeforeUnloadControl");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMimeHandlerViewContainerManager_CreateBeforeUnloadControl_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::MimeHandlerViewContainerManager_CreateBeforeUnloadControl_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MimeHandlerViewContainerManager::Name_);
  message.set_method_name("CreateBeforeUnloadControl");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void MimeHandlerViewContainerManagerProxy::DestroyFrameContainer(
    int32_t in_element_instance_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::DestroyFrameContainer");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMimeHandlerViewContainerManager_DestroyFrameContainer_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::MimeHandlerViewContainerManager_DestroyFrameContainer_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->element_instance_id = in_element_instance_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MimeHandlerViewContainerManager::Name_);
  message.set_method_name("DestroyFrameContainer");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void MimeHandlerViewContainerManagerProxy::DidLoad(
    int32_t in_mime_handler_view_guest_element_instance_id, const GURL& in_resource_url) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::DidLoad");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMimeHandlerViewContainerManager_DidLoad_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::MimeHandlerViewContainerManager_DidLoad_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->mime_handler_view_guest_element_instance_id = in_mime_handler_view_guest_element_instance_id;
  typename decltype(params->resource_url)::BaseType::BufferWriter
      resource_url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_resource_url, buffer, &resource_url_writer, &serialization_context);
  params->resource_url.Set(
      resource_url_writer.is_null() ? nullptr : resource_url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->resource_url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null resource_url in MimeHandlerViewContainerManager.DidLoad request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MimeHandlerViewContainerManager::Name_);
  message.set_method_name("DidLoad");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder {
 public:
  static MimeHandlerViewContainerManager::CreateBeforeUnloadControlCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder> proxy(
        new MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "MimeHandlerViewContainerManager::CreateBeforeUnloadControlCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ::extensions::mime_handler::BeforeUnloadControlPtr in_before_unload_control);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder);
};

bool MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::CreateBeforeUnloadControlCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ResponseParams_Data* params =
      reinterpret_cast<
          internal::MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::extensions::mime_handler::BeforeUnloadControlPtr p_before_unload_control{};
  MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_before_unload_control =
      input_data_view.TakeBeforeUnloadControl<decltype(p_before_unload_control)>();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        MimeHandlerViewContainerManager::Name_, 2, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_before_unload_control));
  return true;
}

void MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder::Run(
    ::extensions::mime_handler::BeforeUnloadControlPtr in_before_unload_control) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kMimeHandlerViewContainerManager_CreateBeforeUnloadControl_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::extensions::mojom::internal::MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::extensions::mime_handler::BeforeUnloadControlPtrDataView>(
      in_before_unload_control, &params->before_unload_control, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->before_unload_control),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid before_unload_control in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::CreateBeforeUnloadControlCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(MimeHandlerViewContainerManager::Name_);
  message.set_method_name("CreateBeforeUnloadControl");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool MimeHandlerViewContainerManagerStubDispatch::Accept(
    MimeHandlerViewContainerManager* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kMimeHandlerViewContainerManager_SetInternalId_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::SetInternalId",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::SetInternalId");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::MimeHandlerViewContainerManager_SetInternalId_Params_Data* params =
          reinterpret_cast<internal::MimeHandlerViewContainerManager_SetInternalId_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_token_id{};
      MimeHandlerViewContainerManager_SetInternalId_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTokenId(&p_token_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MimeHandlerViewContainerManager::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetInternalId(
std::move(p_token_id));
      return true;
    }
    case internal::kMimeHandlerViewContainerManager_LoadEmptyPage_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::LoadEmptyPage",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::LoadEmptyPage");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::MimeHandlerViewContainerManager_LoadEmptyPage_Params_Data* params =
          reinterpret_cast<internal::MimeHandlerViewContainerManager_LoadEmptyPage_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      GURL p_resource_url{};
      MimeHandlerViewContainerManager_LoadEmptyPage_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadResourceUrl(&p_resource_url))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MimeHandlerViewContainerManager::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->LoadEmptyPage(
std::move(p_resource_url));
      return true;
    }
    case internal::kMimeHandlerViewContainerManager_CreateBeforeUnloadControl_Name: {
      break;
    }
    case internal::kMimeHandlerViewContainerManager_DestroyFrameContainer_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::DestroyFrameContainer",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::DestroyFrameContainer");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::MimeHandlerViewContainerManager_DestroyFrameContainer_Params_Data* params =
          reinterpret_cast<internal::MimeHandlerViewContainerManager_DestroyFrameContainer_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_element_instance_id{};
      MimeHandlerViewContainerManager_DestroyFrameContainer_ParamsDataView input_data_view(params, &serialization_context);
      
      p_element_instance_id = input_data_view.element_instance_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MimeHandlerViewContainerManager::Name_, 3, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->DestroyFrameContainer(
std::move(p_element_instance_id));
      return true;
    }
    case internal::kMimeHandlerViewContainerManager_DidLoad_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::DidLoad",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::DidLoad");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::MimeHandlerViewContainerManager_DidLoad_Params_Data* params =
          reinterpret_cast<internal::MimeHandlerViewContainerManager_DidLoad_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_mime_handler_view_guest_element_instance_id{};
      GURL p_resource_url{};
      MimeHandlerViewContainerManager_DidLoad_ParamsDataView input_data_view(params, &serialization_context);
      
      p_mime_handler_view_guest_element_instance_id = input_data_view.mime_handler_view_guest_element_instance_id();
      if (!input_data_view.ReadResourceUrl(&p_resource_url))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MimeHandlerViewContainerManager::Name_, 4, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->DidLoad(
std::move(p_mime_handler_view_guest_element_instance_id), 
std::move(p_resource_url));
      return true;
    }
  }
  return false;
}

// static
bool MimeHandlerViewContainerManagerStubDispatch::AcceptWithResponder(
    MimeHandlerViewContainerManager* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kMimeHandlerViewContainerManager_SetInternalId_Name: {
      break;
    }
    case internal::kMimeHandlerViewContainerManager_LoadEmptyPage_Name: {
      break;
    }
    case internal::kMimeHandlerViewContainerManager_CreateBeforeUnloadControl_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::CreateBeforeUnloadControl",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::MimeHandlerViewContainerManager::CreateBeforeUnloadControl");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      internal::MimeHandlerViewContainerManager_CreateBeforeUnloadControl_Params_Data* params =
          reinterpret_cast<
              internal::MimeHandlerViewContainerManager_CreateBeforeUnloadControl_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            MimeHandlerViewContainerManager::Name_, 2, false);
        return false;
      }
      MimeHandlerViewContainerManager::CreateBeforeUnloadControlCallback callback =
          MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->CreateBeforeUnloadControl(std::move(callback));
      return true;
    }
    case internal::kMimeHandlerViewContainerManager_DestroyFrameContainer_Name: {
      break;
    }
    case internal::kMimeHandlerViewContainerManager_DidLoad_Name: {
      break;
    }
  }
  return false;
}

bool MimeHandlerViewContainerManagerRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "MimeHandlerViewContainerManager RequestValidator");

  switch (message->header()->name) {
    case internal::kMimeHandlerViewContainerManager_SetInternalId_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::MimeHandlerViewContainerManager_SetInternalId_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kMimeHandlerViewContainerManager_LoadEmptyPage_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::MimeHandlerViewContainerManager_LoadEmptyPage_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kMimeHandlerViewContainerManager_CreateBeforeUnloadControl_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::MimeHandlerViewContainerManager_CreateBeforeUnloadControl_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kMimeHandlerViewContainerManager_DestroyFrameContainer_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::MimeHandlerViewContainerManager_DestroyFrameContainer_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kMimeHandlerViewContainerManager_DidLoad_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::MimeHandlerViewContainerManager_DidLoad_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool MimeHandlerViewContainerManagerResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "MimeHandlerViewContainerManager ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kMimeHandlerViewContainerManager_CreateBeforeUnloadControl_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::MimeHandlerViewContainerManager_CreateBeforeUnloadControl_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace extensions

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif