// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_AUDIO_PUBLIC_MOJOM_DEVICE_NOTIFICATIONS_MOJOM_TEST_UTILS_H_
#define SERVICES_AUDIO_PUBLIC_MOJOM_DEVICE_NOTIFICATIONS_MOJOM_TEST_UTILS_H_

#include "services/audio/public/mojom/device_notifications.mojom.h"


namespace audio {
namespace mojom {


class  DeviceListenerInterceptorForTesting : public DeviceListener {
  virtual DeviceListener* GetForwardingInterface() = 0;
  void DevicesChanged() override;
};
class  DeviceListenerAsyncWaiter {
 public:
  explicit DeviceListenerAsyncWaiter(DeviceListener* proxy);
  ~DeviceListenerAsyncWaiter();

 private:
  DeviceListener* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DeviceListenerAsyncWaiter);
};


class  DeviceNotifierInterceptorForTesting : public DeviceNotifier {
  virtual DeviceNotifier* GetForwardingInterface() = 0;
  void RegisterListener(mojo::PendingRemote<DeviceListener> listener) override;
};
class  DeviceNotifierAsyncWaiter {
 public:
  explicit DeviceNotifierAsyncWaiter(DeviceNotifier* proxy);
  ~DeviceNotifierAsyncWaiter();

 private:
  DeviceNotifier* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(DeviceNotifierAsyncWaiter);
};




}  // namespace mojom
}  // namespace audio

#endif  // SERVICES_AUDIO_PUBLIC_MOJOM_DEVICE_NOTIFICATIONS_MOJOM_TEST_UTILS_H_