// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_AUDIO_PUBLIC_MOJOM_TESTING_API_MOJOM_TEST_UTILS_H_
#define SERVICES_AUDIO_PUBLIC_MOJOM_TESTING_API_MOJOM_TEST_UTILS_H_

#include "services/audio/public/mojom/testing_api.mojom.h"


namespace audio {
namespace mojom {


class  TestingApiInterceptorForTesting : public TestingApi {
  virtual TestingApi* GetForwardingInterface() = 0;
  void Crash() override;
};
class  TestingApiAsyncWaiter {
 public:
  explicit TestingApiAsyncWaiter(TestingApi* proxy);
  ~TestingApiAsyncWaiter();

 private:
  TestingApi* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(TestingApiAsyncWaiter);
};




}  // namespace mojom
}  // namespace audio

#endif  // SERVICES_AUDIO_PUBLIC_MOJOM_TESTING_API_MOJOM_TEST_UTILS_H_