// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_FACTORY_MOJOM_TEST_UTILS_H_
#define SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_FACTORY_MOJOM_TEST_UTILS_H_

#include "services/content/public/mojom/navigable_contents_factory.mojom.h"
#include "base/component_export.h"


namespace content {
namespace mojom {


class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM) NavigableContentsFactoryInterceptorForTesting : public NavigableContentsFactory {
  virtual NavigableContentsFactory* GetForwardingInterface() = 0;
  void CreateContents(NavigableContentsParamsPtr params, mojo::PendingReceiver<::content::mojom::NavigableContents> receiver, mojo::PendingRemote<::content::mojom::NavigableContentsClient> client) override;
};
class COMPONENT_EXPORT(CONTENT_SERVICE_MOJOM) NavigableContentsFactoryAsyncWaiter {
 public:
  explicit NavigableContentsFactoryAsyncWaiter(NavigableContentsFactory* proxy);
  ~NavigableContentsFactoryAsyncWaiter();

 private:
  NavigableContentsFactory* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(NavigableContentsFactoryAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // SERVICES_CONTENT_PUBLIC_MOJOM_NAVIGABLE_CONTENTS_FACTORY_MOJOM_TEST_UTILS_H_