// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_IDENTITY_PUBLIC_MOJOM_CORE_ACCOUNT_INFO_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_IDENTITY_PUBLIC_MOJOM_CORE_ACCOUNT_INFO_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/identity/public/mojom/core_account_id.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace identity {
namespace mojom {
namespace internal {
class CoreAccountInfo_Data;

#pragma pack(push, 1)
class  CoreAccountInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CoreAccountInfo_Data));
      new (data()) CoreAccountInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CoreAccountInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CoreAccountInfo_Data>(index_);
    }
    CoreAccountInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::identity::mojom::internal::CoreAccountId_Data> account_id;
  mojo::internal::Pointer<mojo::internal::String_Data> gaia;
  mojo::internal::Pointer<mojo::internal::String_Data> email;

 private:
  CoreAccountInfo_Data();
  ~CoreAccountInfo_Data() = delete;
};
static_assert(sizeof(CoreAccountInfo_Data) == 32,
              "Bad sizeof(CoreAccountInfo_Data)");
// Used by CoreAccountInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct CoreAccountInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  CoreAccountInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~CoreAccountInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    CoreAccountInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    CoreAccountInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace identity

#endif  // SERVICES_IDENTITY_PUBLIC_MOJOM_CORE_ACCOUNT_INFO_MOJOM_SHARED_INTERNAL_H_