// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/identity/public/mojom/core_account_info.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/identity/public/mojom/core_account_info.mojom-params-data.h"
#include "services/identity/public/mojom/core_account_info.mojom-shared-message-ids.h"

#include "services/identity/public/mojom/core_account_info.mojom-import-headers.h"


#ifndef SERVICES_IDENTITY_PUBLIC_MOJOM_CORE_ACCOUNT_INFO_MOJOM_JUMBO_H_
#define SERVICES_IDENTITY_PUBLIC_MOJOM_CORE_ACCOUNT_INFO_MOJOM_JUMBO_H_
#include "services/identity/public/cpp/core_account_id_mojom_traits.h"
#endif
namespace identity {
namespace mojom {
CoreAccountInfo::CoreAccountInfo()
    : account_id(),
      gaia(),
      email() {}

CoreAccountInfo::CoreAccountInfo(
    const ::CoreAccountId& account_id_in,
    const std::string& gaia_in,
    const std::string& email_in)
    : account_id(std::move(account_id_in)),
      gaia(std::move(gaia_in)),
      email(std::move(email_in)) {}

CoreAccountInfo::~CoreAccountInfo() = default;

bool CoreAccountInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace identity

namespace mojo {


// static
bool StructTraits<::identity::mojom::CoreAccountInfo::DataView, ::identity::mojom::CoreAccountInfoPtr>::Read(
    ::identity::mojom::CoreAccountInfo::DataView input,
    ::identity::mojom::CoreAccountInfoPtr* output) {
  bool success = true;
  ::identity::mojom::CoreAccountInfoPtr result(::identity::mojom::CoreAccountInfo::New());
  
      if (!input.ReadAccountId(&result->account_id))
        success = false;
      if (!input.ReadGaia(&result->gaia))
        success = false;
      if (!input.ReadEmail(&result->email))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif