// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_PARAMS_DATA_H_
#define SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace identity {
namespace mojom {
namespace internal {
class  IdentityAccessor_GetPrimaryAccountInfo_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdentityAccessor_GetPrimaryAccountInfo_Params_Data));
      new (data()) IdentityAccessor_GetPrimaryAccountInfo_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdentityAccessor_GetPrimaryAccountInfo_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdentityAccessor_GetPrimaryAccountInfo_Params_Data>(index_);
    }
    IdentityAccessor_GetPrimaryAccountInfo_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  IdentityAccessor_GetPrimaryAccountInfo_Params_Data();
  ~IdentityAccessor_GetPrimaryAccountInfo_Params_Data() = delete;
};
static_assert(sizeof(IdentityAccessor_GetPrimaryAccountInfo_Params_Data) == 8,
              "Bad sizeof(IdentityAccessor_GetPrimaryAccountInfo_Params_Data)");
class  IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data));
      new (data()) IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data>(index_);
    }
    IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::identity::mojom::internal::CoreAccountInfo_Data> account_info;
  mojo::internal::Pointer<::identity::mojom::internal::AccountState_Data> account_state;

 private:
  IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data();
  ~IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data() = delete;
};
static_assert(sizeof(IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data) == 24,
              "Bad sizeof(IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data)");
class  IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data));
      new (data()) IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data>(index_);
    }
    IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data();
  ~IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data() = delete;
};
static_assert(sizeof(IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data) == 8,
              "Bad sizeof(IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data)");
class  IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data));
      new (data()) IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data>(index_);
    }
    IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::identity::mojom::internal::CoreAccountInfo_Data> account_info;
  mojo::internal::Pointer<::identity::mojom::internal::AccountState_Data> account_state;

 private:
  IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data();
  ~IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data() = delete;
};
static_assert(sizeof(IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data) == 24,
              "Bad sizeof(IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data)");
class  IdentityAccessor_GetAccessToken_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdentityAccessor_GetAccessToken_Params_Data));
      new (data()) IdentityAccessor_GetAccessToken_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdentityAccessor_GetAccessToken_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdentityAccessor_GetAccessToken_Params_Data>(index_);
    }
    IdentityAccessor_GetAccessToken_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::identity::mojom::internal::CoreAccountId_Data> account_id;
  mojo::internal::Pointer<::identity::mojom::internal::ScopeSet_Data> scopes;
  mojo::internal::Pointer<mojo::internal::String_Data> consumer_id;

 private:
  IdentityAccessor_GetAccessToken_Params_Data();
  ~IdentityAccessor_GetAccessToken_Params_Data() = delete;
};
static_assert(sizeof(IdentityAccessor_GetAccessToken_Params_Data) == 32,
              "Bad sizeof(IdentityAccessor_GetAccessToken_Params_Data)");
class  IdentityAccessor_GetAccessToken_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(IdentityAccessor_GetAccessToken_ResponseParams_Data));
      new (data()) IdentityAccessor_GetAccessToken_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    IdentityAccessor_GetAccessToken_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<IdentityAccessor_GetAccessToken_ResponseParams_Data>(index_);
    }
    IdentityAccessor_GetAccessToken_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> token;
  mojo::internal::Pointer<::mojo_base::mojom::internal::Time_Data> expiration_time;
  mojo::internal::Pointer<::identity::mojom::internal::GoogleServiceAuthError_Data> error;

 private:
  IdentityAccessor_GetAccessToken_ResponseParams_Data();
  ~IdentityAccessor_GetAccessToken_ResponseParams_Data() = delete;
};
static_assert(sizeof(IdentityAccessor_GetAccessToken_ResponseParams_Data) == 32,
              "Bad sizeof(IdentityAccessor_GetAccessToken_ResponseParams_Data)");

}  // namespace internal
class IdentityAccessor_GetPrimaryAccountInfo_ParamsDataView {
 public:
  IdentityAccessor_GetPrimaryAccountInfo_ParamsDataView() {}

  IdentityAccessor_GetPrimaryAccountInfo_ParamsDataView(
      internal::IdentityAccessor_GetPrimaryAccountInfo_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IdentityAccessor_GetPrimaryAccountInfo_Params_Data* data_ = nullptr;
};

class IdentityAccessor_GetPrimaryAccountInfo_ResponseParamsDataView {
 public:
  IdentityAccessor_GetPrimaryAccountInfo_ResponseParamsDataView() {}

  IdentityAccessor_GetPrimaryAccountInfo_ResponseParamsDataView(
      internal::IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAccountInfoDataView(
      ::identity::mojom::CoreAccountInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAccountInfo(UserType* output) {
    auto* pointer = data_->account_info.Get();
    return mojo::internal::Deserialize<::identity::mojom::CoreAccountInfoDataView>(
        pointer, output, context_);
  }
  inline void GetAccountStateDataView(
      ::identity::mojom::AccountStateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAccountState(UserType* output) {
    auto* pointer = data_->account_state.Get();
    return mojo::internal::Deserialize<::identity::mojom::AccountStateDataView>(
        pointer, output, context_);
  }
 private:
  internal::IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IdentityAccessor_GetPrimaryAccountWhenAvailable_ParamsDataView {
 public:
  IdentityAccessor_GetPrimaryAccountWhenAvailable_ParamsDataView() {}

  IdentityAccessor_GetPrimaryAccountWhenAvailable_ParamsDataView(
      internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data* data_ = nullptr;
};

class IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParamsDataView {
 public:
  IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParamsDataView() {}

  IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParamsDataView(
      internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAccountInfoDataView(
      ::identity::mojom::CoreAccountInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAccountInfo(UserType* output) {
    auto* pointer = data_->account_info.Get();
    return mojo::internal::Deserialize<::identity::mojom::CoreAccountInfoDataView>(
        pointer, output, context_);
  }
  inline void GetAccountStateDataView(
      ::identity::mojom::AccountStateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAccountState(UserType* output) {
    auto* pointer = data_->account_state.Get();
    return mojo::internal::Deserialize<::identity::mojom::AccountStateDataView>(
        pointer, output, context_);
  }
 private:
  internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IdentityAccessor_GetAccessToken_ParamsDataView {
 public:
  IdentityAccessor_GetAccessToken_ParamsDataView() {}

  IdentityAccessor_GetAccessToken_ParamsDataView(
      internal::IdentityAccessor_GetAccessToken_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAccountIdDataView(
      ::identity::mojom::CoreAccountIdDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAccountId(UserType* output) {
    auto* pointer = data_->account_id.Get();
    return mojo::internal::Deserialize<::identity::mojom::CoreAccountIdDataView>(
        pointer, output, context_);
  }
  inline void GetScopesDataView(
      ::identity::mojom::ScopeSetDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadScopes(UserType* output) {
    auto* pointer = data_->scopes.Get();
    return mojo::internal::Deserialize<::identity::mojom::ScopeSetDataView>(
        pointer, output, context_);
  }
  inline void GetConsumerIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConsumerId(UserType* output) {
    auto* pointer = data_->consumer_id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::IdentityAccessor_GetAccessToken_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class IdentityAccessor_GetAccessToken_ResponseParamsDataView {
 public:
  IdentityAccessor_GetAccessToken_ResponseParamsDataView() {}

  IdentityAccessor_GetAccessToken_ResponseParamsDataView(
      internal::IdentityAccessor_GetAccessToken_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTokenDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadToken(UserType* output) {
    auto* pointer = data_->token.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetExpirationTimeDataView(
      ::mojo_base::mojom::TimeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadExpirationTime(UserType* output) {
    auto* pointer = data_->expiration_time.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDataView>(
        pointer, output, context_);
  }
  inline void GetErrorDataView(
      ::identity::mojom::GoogleServiceAuthErrorDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadError(UserType* output) {
    auto* pointer = data_->error.Get();
    return mojo::internal::Deserialize<::identity::mojom::GoogleServiceAuthErrorDataView>(
        pointer, output, context_);
  }
 private:
  internal::IdentityAccessor_GetAccessToken_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void IdentityAccessor_GetPrimaryAccountInfo_ResponseParamsDataView::GetAccountInfoDataView(
    ::identity::mojom::CoreAccountInfoDataView* output) {
  auto pointer = data_->account_info.Get();
  *output = ::identity::mojom::CoreAccountInfoDataView(pointer, context_);
}
inline void IdentityAccessor_GetPrimaryAccountInfo_ResponseParamsDataView::GetAccountStateDataView(
    ::identity::mojom::AccountStateDataView* output) {
  auto pointer = data_->account_state.Get();
  *output = ::identity::mojom::AccountStateDataView(pointer, context_);
}




inline void IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParamsDataView::GetAccountInfoDataView(
    ::identity::mojom::CoreAccountInfoDataView* output) {
  auto pointer = data_->account_info.Get();
  *output = ::identity::mojom::CoreAccountInfoDataView(pointer, context_);
}
inline void IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParamsDataView::GetAccountStateDataView(
    ::identity::mojom::AccountStateDataView* output) {
  auto pointer = data_->account_state.Get();
  *output = ::identity::mojom::AccountStateDataView(pointer, context_);
}


inline void IdentityAccessor_GetAccessToken_ParamsDataView::GetAccountIdDataView(
    ::identity::mojom::CoreAccountIdDataView* output) {
  auto pointer = data_->account_id.Get();
  *output = ::identity::mojom::CoreAccountIdDataView(pointer, context_);
}
inline void IdentityAccessor_GetAccessToken_ParamsDataView::GetScopesDataView(
    ::identity::mojom::ScopeSetDataView* output) {
  auto pointer = data_->scopes.Get();
  *output = ::identity::mojom::ScopeSetDataView(pointer, context_);
}
inline void IdentityAccessor_GetAccessToken_ParamsDataView::GetConsumerIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->consumer_id.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void IdentityAccessor_GetAccessToken_ResponseParamsDataView::GetTokenDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->token.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void IdentityAccessor_GetAccessToken_ResponseParamsDataView::GetExpirationTimeDataView(
    ::mojo_base::mojom::TimeDataView* output) {
  auto pointer = data_->expiration_time.Get();
  *output = ::mojo_base::mojom::TimeDataView(pointer, context_);
}
inline void IdentityAccessor_GetAccessToken_ResponseParamsDataView::GetErrorDataView(
    ::identity::mojom::GoogleServiceAuthErrorDataView* output) {
  auto pointer = data_->error.Get();
  *output = ::identity::mojom::GoogleServiceAuthErrorDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace identity

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_PARAMS_DATA_H_