// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/identity/public/mojom/identity_accessor.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "services/identity/public/mojom/account.mojom.h"
#include "services/identity/public/mojom/core_account_id.mojom.h"
#include "services/identity/public/mojom/core_account_info.mojom.h"
#include "services/identity/public/mojom/account_state.mojom.h"
#include "services/identity/public/mojom/google_service_auth_error.mojom.h"
#include "services/identity/public/mojom/scope_set.mojom.h"


#ifndef SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_JUMBO_H_
#define SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "services/identity/public/cpp/account_state_mojom_traits.h"
#include "services/identity/public/cpp/core_account_id_mojom_traits.h"
#include "services/identity/public/cpp/core_account_info_mojom_traits.h"
#include "services/identity/public/cpp/google_service_auth_error_mojom_traits.h"
#include "services/identity/public/cpp/scope_set_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace identity {
namespace mojom {


void IdentityAccessorInterceptorForTesting::GetPrimaryAccountInfo(GetPrimaryAccountInfoCallback callback) {
  GetForwardingInterface()->GetPrimaryAccountInfo(std::move(callback));
}
void IdentityAccessorInterceptorForTesting::GetPrimaryAccountWhenAvailable(GetPrimaryAccountWhenAvailableCallback callback) {
  GetForwardingInterface()->GetPrimaryAccountWhenAvailable(std::move(callback));
}
void IdentityAccessorInterceptorForTesting::GetAccessToken(const ::CoreAccountId& account_id, const ::identity::ScopeSet& scopes, const std::string& consumer_id, GetAccessTokenCallback callback) {
  GetForwardingInterface()->GetAccessToken(std::move(account_id), std::move(scopes), std::move(consumer_id), std::move(callback));
}
IdentityAccessorAsyncWaiter::IdentityAccessorAsyncWaiter(
    IdentityAccessor* proxy) : proxy_(proxy) {}

IdentityAccessorAsyncWaiter::~IdentityAccessorAsyncWaiter() = default;

void IdentityAccessorAsyncWaiter::GetPrimaryAccountInfo(
    base::Optional<::CoreAccountInfo>* out_account_info, identity::AccountState* out_account_state) {
  base::RunLoop loop;
  proxy_->GetPrimaryAccountInfo(
      base::BindOnce(
          [](base::RunLoop* loop,
             base::Optional<::CoreAccountInfo>* out_account_info
,
             identity::AccountState* out_account_state
,
             const base::Optional<::CoreAccountInfo>& account_info,
             const identity::AccountState& account_state) {*out_account_info = std::move(account_info);*out_account_state = std::move(account_state);
            loop->Quit();
          },
          &loop,
          out_account_info,
          out_account_state));
  loop.Run();
}
void IdentityAccessorAsyncWaiter::GetPrimaryAccountWhenAvailable(
    ::CoreAccountInfo* out_account_info, identity::AccountState* out_account_state) {
  base::RunLoop loop;
  proxy_->GetPrimaryAccountWhenAvailable(
      base::BindOnce(
          [](base::RunLoop* loop,
             ::CoreAccountInfo* out_account_info
,
             identity::AccountState* out_account_state
,
             const ::CoreAccountInfo& account_info,
             const identity::AccountState& account_state) {*out_account_info = std::move(account_info);*out_account_state = std::move(account_state);
            loop->Quit();
          },
          &loop,
          out_account_info,
          out_account_state));
  loop.Run();
}
void IdentityAccessorAsyncWaiter::GetAccessToken(
    const ::CoreAccountId& account_id, const ::identity::ScopeSet& scopes, const std::string& consumer_id, base::Optional<std::string>* out_token, base::Time* out_expiration_time, ::GoogleServiceAuthError* out_error) {
  base::RunLoop loop;
  proxy_->GetAccessToken(std::move(account_id),std::move(scopes),std::move(consumer_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             base::Optional<std::string>* out_token
,
             base::Time* out_expiration_time
,
             ::GoogleServiceAuthError* out_error
,
             const base::Optional<std::string>& token,
             base::Time expiration_time,
             const ::GoogleServiceAuthError& error) {*out_token = std::move(token);*out_expiration_time = std::move(expiration_time);*out_error = std::move(error);
            loop->Quit();
          },
          &loop,
          out_token,
          out_expiration_time,
          out_error));
  loop.Run();
}





}  // namespace mojom
}  // namespace identity

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif