// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/network/public/mojom/origin_policy_manager.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/network/public/mojom/origin_policy_manager.mojom-params-data.h"
#include "services/network/public/mojom/origin_policy_manager.mojom-shared-message-ids.h"

#include "services/network/public/mojom/origin_policy_manager.mojom-blink-import-headers.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_ORIGIN_POLICY_MANAGER_MOJOM_BLINK_JUMBO_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_ORIGIN_POLICY_MANAGER_MOJOM_BLINK_JUMBO_H_
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "third_party/blink/renderer/platform/mojo/kurl_struct_traits.h"
#include "third_party/blink/renderer/platform/mojo/security_origin_struct_traits.h"
#endif
namespace network {
namespace mojom {
namespace blink {
OriginPolicyContents::OriginPolicyContents()
    : raw_policy() {}

OriginPolicyContents::OriginPolicyContents(
    const WTF::String& raw_policy_in)
    : raw_policy(std::move(raw_policy_in)) {}

OriginPolicyContents::~OriginPolicyContents() = default;
size_t OriginPolicyContents::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->raw_policy);
  return seed;
}

bool OriginPolicyContents::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
OriginPolicy::OriginPolicy()
    : state(),
      policy_url(),
      contents() {}

OriginPolicy::OriginPolicy(
    OriginPolicyState state_in,
    const ::blink::KURL& policy_url_in,
    OriginPolicyContentsPtr contents_in)
    : state(std::move(state_in)),
      policy_url(std::move(policy_url_in)),
      contents(std::move(contents_in)) {}

OriginPolicy::~OriginPolicy() = default;

bool OriginPolicy::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char OriginPolicyManager::Name_[] = "network.mojom.OriginPolicyManager";

class OriginPolicyManager_RetrieveOriginPolicy_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  OriginPolicyManager_RetrieveOriginPolicy_ForwardToCallback(
      OriginPolicyManager::RetrieveOriginPolicyCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  OriginPolicyManager::RetrieveOriginPolicyCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(OriginPolicyManager_RetrieveOriginPolicy_ForwardToCallback);
};

OriginPolicyManagerProxy::OriginPolicyManagerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OriginPolicyManagerProxy::RetrieveOriginPolicy(
    const scoped_refptr<const ::blink::SecurityOrigin>& in_origin, const WTF::String& in_header_value, RetrieveOriginPolicyCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::OriginPolicyManager::RetrieveOriginPolicy");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kOriginPolicyManager_RetrieveOriginPolicy_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::OriginPolicyManager_RetrieveOriginPolicy_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->origin)::BaseType::BufferWriter
      origin_writer;
  mojo::internal::Serialize<::url::mojom::OriginDataView>(
      in_origin, buffer, &origin_writer, &serialization_context);
  params->origin.Set(
      origin_writer.is_null() ? nullptr : origin_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->origin.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null origin in OriginPolicyManager.RetrieveOriginPolicy request");
  typename decltype(params->header_value)::BaseType::BufferWriter
      header_value_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_header_value, buffer, &header_value_writer, &serialization_context);
  params->header_value.Set(
      header_value_writer.is_null() ? nullptr : header_value_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->header_value.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null header_value in OriginPolicyManager.RetrieveOriginPolicy request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(OriginPolicyManager::Name_);
  message.set_method_name("RetrieveOriginPolicy");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new OriginPolicyManager_RetrieveOriginPolicy_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder {
 public:
  static OriginPolicyManager::RetrieveOriginPolicyCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder> proxy(
        new OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "OriginPolicyManager::RetrieveOriginPolicyCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      OriginPolicyPtr in_origin_policy);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder);
};

bool OriginPolicyManager_RetrieveOriginPolicy_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::OriginPolicyManager::RetrieveOriginPolicyCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::OriginPolicyManager_RetrieveOriginPolicy_ResponseParams_Data* params =
      reinterpret_cast<
          internal::OriginPolicyManager_RetrieveOriginPolicy_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  OriginPolicyPtr p_origin_policy{};
  OriginPolicyManager_RetrieveOriginPolicy_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadOriginPolicy(&p_origin_policy))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        OriginPolicyManager::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_origin_policy));
  return true;
}

void OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder::Run(
    OriginPolicyPtr in_origin_policy) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kOriginPolicyManager_RetrieveOriginPolicy_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::OriginPolicyManager_RetrieveOriginPolicy_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->origin_policy)::BaseType::BufferWriter
      origin_policy_writer;
  mojo::internal::Serialize<::network::mojom::OriginPolicyDataView>(
      in_origin_policy, buffer, &origin_policy_writer, &serialization_context);
  params->origin_policy.Set(
      origin_policy_writer.is_null() ? nullptr : origin_policy_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->origin_policy.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null origin_policy in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::OriginPolicyManager::RetrieveOriginPolicyCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(OriginPolicyManager::Name_);
  message.set_method_name("RetrieveOriginPolicy");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool OriginPolicyManagerStubDispatch::Accept(
    OriginPolicyManager* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOriginPolicyManager_RetrieveOriginPolicy_Name: {
      break;
    }
  }
  return false;
}

// static
bool OriginPolicyManagerStubDispatch::AcceptWithResponder(
    OriginPolicyManager* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kOriginPolicyManager_RetrieveOriginPolicy_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::OriginPolicyManager::RetrieveOriginPolicy",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::OriginPolicyManager::RetrieveOriginPolicy");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      internal::OriginPolicyManager_RetrieveOriginPolicy_Params_Data* params =
          reinterpret_cast<
              internal::OriginPolicyManager_RetrieveOriginPolicy_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      scoped_refptr<const ::blink::SecurityOrigin> p_origin{};
      WTF::String p_header_value{};
      OriginPolicyManager_RetrieveOriginPolicy_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadOrigin(&p_origin))
        success = false;
      if (!input_data_view.ReadHeaderValue(&p_header_value))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            OriginPolicyManager::Name_, 0, false);
        return false;
      }
      OriginPolicyManager::RetrieveOriginPolicyCallback callback =
          OriginPolicyManager_RetrieveOriginPolicy_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->RetrieveOriginPolicy(
std::move(p_origin), 
std::move(p_header_value), std::move(callback));
      return true;
    }
  }
  return false;
}

bool OriginPolicyManagerRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OriginPolicyManager RequestValidator");

  switch (message->header()->name) {
    case internal::kOriginPolicyManager_RetrieveOriginPolicy_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OriginPolicyManager_RetrieveOriginPolicy_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool OriginPolicyManagerResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OriginPolicyManager ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kOriginPolicyManager_RetrieveOriginPolicy_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::OriginPolicyManager_RetrieveOriginPolicy_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace blink
}  // namespace mojom
}  // namespace network

namespace mojo {


// static
bool StructTraits<::network::mojom::blink::OriginPolicyContents::DataView, ::network::mojom::blink::OriginPolicyContentsPtr>::Read(
    ::network::mojom::blink::OriginPolicyContents::DataView input,
    ::network::mojom::blink::OriginPolicyContentsPtr* output) {
  bool success = true;
  ::network::mojom::blink::OriginPolicyContentsPtr result(::network::mojom::blink::OriginPolicyContents::New());
  
      if (!input.ReadRawPolicy(&result->raw_policy))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::network::mojom::blink::OriginPolicy::DataView, ::network::mojom::blink::OriginPolicyPtr>::Read(
    ::network::mojom::blink::OriginPolicy::DataView input,
    ::network::mojom::blink::OriginPolicyPtr* output) {
  bool success = true;
  ::network::mojom::blink::OriginPolicyPtr result(::network::mojom::blink::OriginPolicy::New());
  
      if (!input.ReadState(&result->state))
        success = false;
      if (!input.ReadPolicyUrl(&result->policy_url))
        success = false;
      if (!input.ReadContents(&result->contents))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif