// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_PARAMS_DATA_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace video_capture {
namespace mojom {
namespace internal {
class  DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data));
      new (data()) DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data>(index_);
    }
    DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data();
  ~DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data) == 16,
              "Bad sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data)");
class  DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data));
      new (data()) DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data>(index_);
    }
    DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data();
  ~DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data) == 16,
              "Bad sizeof(DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data)");
class  DeviceFactoryProvider_ShutdownServiceAsap_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_ShutdownServiceAsap_Params_Data));
      new (data()) DeviceFactoryProvider_ShutdownServiceAsap_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_ShutdownServiceAsap_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_ShutdownServiceAsap_Params_Data>(index_);
    }
    DeviceFactoryProvider_ShutdownServiceAsap_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DeviceFactoryProvider_ShutdownServiceAsap_Params_Data();
  ~DeviceFactoryProvider_ShutdownServiceAsap_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_ShutdownServiceAsap_Params_Data) == 8,
              "Bad sizeof(DeviceFactoryProvider_ShutdownServiceAsap_Params_Data)");
class  DeviceFactoryProvider_SetRetryCount_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_SetRetryCount_Params_Data));
      new (data()) DeviceFactoryProvider_SetRetryCount_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_SetRetryCount_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_SetRetryCount_Params_Data>(index_);
    }
    DeviceFactoryProvider_SetRetryCount_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t count;
  uint8_t padfinal_[4];

 private:
  DeviceFactoryProvider_SetRetryCount_Params_Data();
  ~DeviceFactoryProvider_SetRetryCount_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_SetRetryCount_Params_Data) == 16,
              "Bad sizeof(DeviceFactoryProvider_SetRetryCount_Params_Data)");

}  // namespace internal
class DeviceFactoryProvider_ConnectToDeviceFactory_ParamsDataView {
 public:
  DeviceFactoryProvider_ConnectToDeviceFactory_ParamsDataView() {}

  DeviceFactoryProvider_ConnectToDeviceFactory_ParamsDataView(
      internal::DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::DeviceFactoryRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DeviceFactoryProvider_ConnectToVideoSourceProvider_ParamsDataView {
 public:
  DeviceFactoryProvider_ConnectToVideoSourceProvider_ParamsDataView() {}

  DeviceFactoryProvider_ConnectToVideoSourceProvider_ParamsDataView(
      internal::DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::VideoSourceProviderRequestDataView>(
            &data_->request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::DeviceFactoryProvider_ConnectToVideoSourceProvider_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DeviceFactoryProvider_ShutdownServiceAsap_ParamsDataView {
 public:
  DeviceFactoryProvider_ShutdownServiceAsap_ParamsDataView() {}

  DeviceFactoryProvider_ShutdownServiceAsap_ParamsDataView(
      internal::DeviceFactoryProvider_ShutdownServiceAsap_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DeviceFactoryProvider_ShutdownServiceAsap_Params_Data* data_ = nullptr;
};

class DeviceFactoryProvider_SetRetryCount_ParamsDataView {
 public:
  DeviceFactoryProvider_SetRetryCount_ParamsDataView() {}

  DeviceFactoryProvider_SetRetryCount_ParamsDataView(
      internal::DeviceFactoryProvider_SetRetryCount_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t count() const {
    return data_->count;
  }
 private:
  internal::DeviceFactoryProvider_SetRetryCount_Params_Data* data_ = nullptr;
};









}  // namespace mojom
}  // namespace video_capture

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_DEVICE_FACTORY_PROVIDER_MOJOM_PARAMS_DATA_H_