// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_RECEIVER_MOJOM_PARAMS_DATA_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_RECEIVER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace video_capture {
namespace mojom {
namespace internal {
class  Receiver_OnNewBuffer_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnNewBuffer_Params_Data));
      new (data()) Receiver_OnNewBuffer_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnNewBuffer_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnNewBuffer_Params_Data>(index_);
    }
    Receiver_OnNewBuffer_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t buffer_id;
  uint8_t pad0_[4];
  ::media::mojom::internal::VideoBufferHandle_Data buffer_handle;

 private:
  Receiver_OnNewBuffer_Params_Data();
  ~Receiver_OnNewBuffer_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnNewBuffer_Params_Data) == 32,
              "Bad sizeof(Receiver_OnNewBuffer_Params_Data)");
class  Receiver_OnFrameReadyInBuffer_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnFrameReadyInBuffer_Params_Data));
      new (data()) Receiver_OnFrameReadyInBuffer_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnFrameReadyInBuffer_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnFrameReadyInBuffer_Params_Data>(index_);
    }
    Receiver_OnFrameReadyInBuffer_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t buffer_id;
  int32_t frame_feedback_id;
  mojo::internal::Interface_Data access_permission;
  mojo::internal::Pointer<::media::mojom::internal::VideoFrameInfo_Data> frame_info;

 private:
  Receiver_OnFrameReadyInBuffer_Params_Data();
  ~Receiver_OnFrameReadyInBuffer_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnFrameReadyInBuffer_Params_Data) == 32,
              "Bad sizeof(Receiver_OnFrameReadyInBuffer_Params_Data)");
class  Receiver_OnBufferRetired_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnBufferRetired_Params_Data));
      new (data()) Receiver_OnBufferRetired_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnBufferRetired_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnBufferRetired_Params_Data>(index_);
    }
    Receiver_OnBufferRetired_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t buffer_id;
  uint8_t padfinal_[4];

 private:
  Receiver_OnBufferRetired_Params_Data();
  ~Receiver_OnBufferRetired_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnBufferRetired_Params_Data) == 16,
              "Bad sizeof(Receiver_OnBufferRetired_Params_Data)");
class  Receiver_OnError_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnError_Params_Data));
      new (data()) Receiver_OnError_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnError_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnError_Params_Data>(index_);
    }
    Receiver_OnError_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t padfinal_[4];

 private:
  Receiver_OnError_Params_Data();
  ~Receiver_OnError_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnError_Params_Data) == 16,
              "Bad sizeof(Receiver_OnError_Params_Data)");
class  Receiver_OnFrameDropped_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnFrameDropped_Params_Data));
      new (data()) Receiver_OnFrameDropped_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnFrameDropped_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnFrameDropped_Params_Data>(index_);
    }
    Receiver_OnFrameDropped_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t reason;
  uint8_t padfinal_[4];

 private:
  Receiver_OnFrameDropped_Params_Data();
  ~Receiver_OnFrameDropped_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnFrameDropped_Params_Data) == 16,
              "Bad sizeof(Receiver_OnFrameDropped_Params_Data)");
class  Receiver_OnLog_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnLog_Params_Data));
      new (data()) Receiver_OnLog_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnLog_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnLog_Params_Data>(index_);
    }
    Receiver_OnLog_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> message;

 private:
  Receiver_OnLog_Params_Data();
  ~Receiver_OnLog_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnLog_Params_Data) == 16,
              "Bad sizeof(Receiver_OnLog_Params_Data)");
class  Receiver_OnStarted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnStarted_Params_Data));
      new (data()) Receiver_OnStarted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnStarted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnStarted_Params_Data>(index_);
    }
    Receiver_OnStarted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Receiver_OnStarted_Params_Data();
  ~Receiver_OnStarted_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnStarted_Params_Data) == 8,
              "Bad sizeof(Receiver_OnStarted_Params_Data)");
class  Receiver_OnStartedUsingGpuDecode_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnStartedUsingGpuDecode_Params_Data));
      new (data()) Receiver_OnStartedUsingGpuDecode_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnStartedUsingGpuDecode_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnStartedUsingGpuDecode_Params_Data>(index_);
    }
    Receiver_OnStartedUsingGpuDecode_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Receiver_OnStartedUsingGpuDecode_Params_Data();
  ~Receiver_OnStartedUsingGpuDecode_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnStartedUsingGpuDecode_Params_Data) == 8,
              "Bad sizeof(Receiver_OnStartedUsingGpuDecode_Params_Data)");
class  Receiver_OnStopped_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Receiver_OnStopped_Params_Data));
      new (data()) Receiver_OnStopped_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Receiver_OnStopped_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Receiver_OnStopped_Params_Data>(index_);
    }
    Receiver_OnStopped_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Receiver_OnStopped_Params_Data();
  ~Receiver_OnStopped_Params_Data() = delete;
};
static_assert(sizeof(Receiver_OnStopped_Params_Data) == 8,
              "Bad sizeof(Receiver_OnStopped_Params_Data)");

}  // namespace internal
class Receiver_OnNewBuffer_ParamsDataView {
 public:
  Receiver_OnNewBuffer_ParamsDataView() {}

  Receiver_OnNewBuffer_ParamsDataView(
      internal::Receiver_OnNewBuffer_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t buffer_id() const {
    return data_->buffer_id;
  }
  inline void GetBufferHandleDataView(
      ::media::mojom::VideoBufferHandleDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBufferHandle(UserType* output) {
    auto* pointer = !data_->buffer_handle.is_null() ? &data_->buffer_handle : nullptr;
    return mojo::internal::Deserialize<::media::mojom::VideoBufferHandleDataView>(
        pointer, output, context_);
  }
 private:
  internal::Receiver_OnNewBuffer_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Receiver_OnFrameReadyInBuffer_ParamsDataView {
 public:
  Receiver_OnFrameReadyInBuffer_ParamsDataView() {}

  Receiver_OnFrameReadyInBuffer_ParamsDataView(
      internal::Receiver_OnFrameReadyInBuffer_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t buffer_id() const {
    return data_->buffer_id;
  }
  int32_t frame_feedback_id() const {
    return data_->frame_feedback_id;
  }
  template <typename UserType>
  UserType TakeAccessPermission() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::video_capture::mojom::ScopedAccessPermissionPtrDataView>(
            &data_->access_permission, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetFrameInfoDataView(
      ::media::mojom::VideoFrameInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrameInfo(UserType* output) {
    auto* pointer = data_->frame_info.Get();
    return mojo::internal::Deserialize<::media::mojom::VideoFrameInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::Receiver_OnFrameReadyInBuffer_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Receiver_OnBufferRetired_ParamsDataView {
 public:
  Receiver_OnBufferRetired_ParamsDataView() {}

  Receiver_OnBufferRetired_ParamsDataView(
      internal::Receiver_OnBufferRetired_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t buffer_id() const {
    return data_->buffer_id;
  }
 private:
  internal::Receiver_OnBufferRetired_Params_Data* data_ = nullptr;
};

class Receiver_OnError_ParamsDataView {
 public:
  Receiver_OnError_ParamsDataView() {}

  Receiver_OnError_ParamsDataView(
      internal::Receiver_OnError_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadError(UserType* output) const {
    auto data_value = data_->error;
    return mojo::internal::Deserialize<::media::mojom::VideoCaptureError>(
        data_value, output);
  }

  ::media::mojom::VideoCaptureError error() const {
    return static_cast<::media::mojom::VideoCaptureError>(data_->error);
  }
 private:
  internal::Receiver_OnError_Params_Data* data_ = nullptr;
};

class Receiver_OnFrameDropped_ParamsDataView {
 public:
  Receiver_OnFrameDropped_ParamsDataView() {}

  Receiver_OnFrameDropped_ParamsDataView(
      internal::Receiver_OnFrameDropped_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReason(UserType* output) const {
    auto data_value = data_->reason;
    return mojo::internal::Deserialize<::media::mojom::VideoCaptureFrameDropReason>(
        data_value, output);
  }

  ::media::mojom::VideoCaptureFrameDropReason reason() const {
    return static_cast<::media::mojom::VideoCaptureFrameDropReason>(data_->reason);
  }
 private:
  internal::Receiver_OnFrameDropped_Params_Data* data_ = nullptr;
};

class Receiver_OnLog_ParamsDataView {
 public:
  Receiver_OnLog_ParamsDataView() {}

  Receiver_OnLog_ParamsDataView(
      internal::Receiver_OnLog_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetMessageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::Receiver_OnLog_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class Receiver_OnStarted_ParamsDataView {
 public:
  Receiver_OnStarted_ParamsDataView() {}

  Receiver_OnStarted_ParamsDataView(
      internal::Receiver_OnStarted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::Receiver_OnStarted_Params_Data* data_ = nullptr;
};

class Receiver_OnStartedUsingGpuDecode_ParamsDataView {
 public:
  Receiver_OnStartedUsingGpuDecode_ParamsDataView() {}

  Receiver_OnStartedUsingGpuDecode_ParamsDataView(
      internal::Receiver_OnStartedUsingGpuDecode_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::Receiver_OnStartedUsingGpuDecode_Params_Data* data_ = nullptr;
};

class Receiver_OnStopped_ParamsDataView {
 public:
  Receiver_OnStopped_ParamsDataView() {}

  Receiver_OnStopped_ParamsDataView(
      internal::Receiver_OnStopped_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::Receiver_OnStopped_Params_Data* data_ = nullptr;
};


inline void Receiver_OnNewBuffer_ParamsDataView::GetBufferHandleDataView(
    ::media::mojom::VideoBufferHandleDataView* output) {
  auto pointer = &data_->buffer_handle;
  *output = ::media::mojom::VideoBufferHandleDataView(pointer, context_);
}


inline void Receiver_OnFrameReadyInBuffer_ParamsDataView::GetFrameInfoDataView(
    ::media::mojom::VideoFrameInfoDataView* output) {
  auto pointer = data_->frame_info.Get();
  *output = ::media::mojom::VideoFrameInfoDataView(pointer, context_);
}








inline void Receiver_OnLog_ParamsDataView::GetMessageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->message.Get();
  *output = mojo::StringDataView(pointer, context_);
}







}  // namespace mojom
}  // namespace video_capture

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_RECEIVER_MOJOM_PARAMS_DATA_H_