// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_SCOPED_ACCESS_PERMISSION_MOJOM_TEST_UTILS_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_SCOPED_ACCESS_PERMISSION_MOJOM_TEST_UTILS_H_

#include "services/video_capture/public/mojom/scoped_access_permission.mojom.h"


namespace video_capture {
namespace mojom {


class  ScopedAccessPermissionInterceptorForTesting : public ScopedAccessPermission {
  virtual ScopedAccessPermission* GetForwardingInterface() = 0;
};
class  ScopedAccessPermissionAsyncWaiter {
 public:
  explicit ScopedAccessPermissionAsyncWaiter(ScopedAccessPermission* proxy);
  ~ScopedAccessPermissionAsyncWaiter();

 private:
  ScopedAccessPermission* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ScopedAccessPermissionAsyncWaiter);
};




}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_SCOPED_ACCESS_PERMISSION_MOJOM_TEST_UTILS_H_