// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_VSYNC_PARAMETER_OBSERVER_MOJOM_TEST_UTILS_H_
#define SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_VSYNC_PARAMETER_OBSERVER_MOJOM_TEST_UTILS_H_

#include "services/viz/privileged/interfaces/compositing/vsync_parameter_observer.mojom.h"


namespace viz {
namespace mojom {


class  VSyncParameterObserverInterceptorForTesting : public VSyncParameterObserver {
  virtual VSyncParameterObserver* GetForwardingInterface() = 0;
  void OnUpdateVSyncParameters(base::TimeTicks timebase, base::TimeDelta interval) override;
};
class  VSyncParameterObserverAsyncWaiter {
 public:
  explicit VSyncParameterObserverAsyncWaiter(VSyncParameterObserver* proxy);
  ~VSyncParameterObserverAsyncWaiter();

 private:
  VSyncParameterObserver* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VSyncParameterObserverAsyncWaiter);
};




}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_VSYNC_PARAMETER_OBSERVER_MOJOM_TEST_UTILS_H_