// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/viz/privileged/interfaces/compositing/vsync_parameter_observer.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/viz/privileged/interfaces/compositing/vsync_parameter_observer.mojom-params-data.h"
#include "services/viz/privileged/interfaces/compositing/vsync_parameter_observer.mojom-shared-message-ids.h"

#include "services/viz/privileged/interfaces/compositing/vsync_parameter_observer.mojom-import-headers.h"


#ifndef SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_VSYNC_PARAMETER_OBSERVER_MOJOM_JUMBO_H_
#define SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_VSYNC_PARAMETER_OBSERVER_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#endif
namespace viz {
namespace mojom {
const char VSyncParameterObserver::Name_[] = "viz.mojom.VSyncParameterObserver";

VSyncParameterObserverProxy::VSyncParameterObserverProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void VSyncParameterObserverProxy::OnUpdateVSyncParameters(
    base::TimeTicks in_timebase, base::TimeDelta in_interval) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::VSyncParameterObserver::OnUpdateVSyncParameters");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kVSyncParameterObserver_OnUpdateVSyncParameters_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::viz::mojom::internal::VSyncParameterObserver_OnUpdateVSyncParameters_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->timebase)::BaseType::BufferWriter
      timebase_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
      in_timebase, buffer, &timebase_writer, &serialization_context);
  params->timebase.Set(
      timebase_writer.is_null() ? nullptr : timebase_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->timebase.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null timebase in VSyncParameterObserver.OnUpdateVSyncParameters request");
  typename decltype(params->interval)::BaseType::BufferWriter
      interval_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
      in_interval, buffer, &interval_writer, &serialization_context);
  params->interval.Set(
      interval_writer.is_null() ? nullptr : interval_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->interval.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null interval in VSyncParameterObserver.OnUpdateVSyncParameters request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(VSyncParameterObserver::Name_);
  message.set_method_name("OnUpdateVSyncParameters");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool VSyncParameterObserverStubDispatch::Accept(
    VSyncParameterObserver* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kVSyncParameterObserver_OnUpdateVSyncParameters_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)<class 'jinja2::utils::Namespace'>::VSyncParameterObserver::OnUpdateVSyncParameters",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)<class 'jinja2::utils::Namespace'>::VSyncParameterObserver::OnUpdateVSyncParameters");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::VSyncParameterObserver_OnUpdateVSyncParameters_Params_Data* params =
          reinterpret_cast<internal::VSyncParameterObserver_OnUpdateVSyncParameters_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      base::TimeTicks p_timebase{};
      base::TimeDelta p_interval{};
      VSyncParameterObserver_OnUpdateVSyncParameters_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadTimebase(&p_timebase))
        success = false;
      if (!input_data_view.ReadInterval(&p_interval))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            VSyncParameterObserver::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnUpdateVSyncParameters(
std::move(p_timebase), 
std::move(p_interval));
      return true;
    }
  }
  return false;
}

// static
bool VSyncParameterObserverStubDispatch::AcceptWithResponder(
    VSyncParameterObserver* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kVSyncParameterObserver_OnUpdateVSyncParameters_Name: {
      break;
    }
  }
  return false;
}

bool VSyncParameterObserverRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "VSyncParameterObserver RequestValidator");

  switch (message->header()->name) {
    case internal::kVSyncParameterObserver_OnUpdateVSyncParameters_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::VSyncParameterObserver_OnUpdateVSyncParameters_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace viz

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif