// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WS_PUBLIC_MOJOM_INPUT_DEVICES_INPUT_DEVICE_SERVER_MOJOM_PARAMS_DATA_H_
#define SERVICES_WS_PUBLIC_MOJOM_INPUT_DEVICES_INPUT_DEVICE_SERVER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace ws {
namespace mojom {
namespace internal {
class  InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data));
      new (data()) InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data>(index_);
    }
    InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::InputDevice_Data>>> devices;

 private:
  InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data();
  ~InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data() = delete;
};
static_assert(sizeof(InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data) == 16,
              "Bad sizeof(InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data)");
class  InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data));
      new (data()) InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data>(index_);
    }
    InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::TouchscreenDevice_Data>>> devices;
  uint8_t touchscreen_target_display_ids_changed : 1;
  uint8_t padfinal_[7];

 private:
  InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data();
  ~InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data() = delete;
};
static_assert(sizeof(InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data) == 24,
              "Bad sizeof(InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data)");
class  InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data));
      new (data()) InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data>(index_);
    }
    InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::InputDevice_Data>>> devices;

 private:
  InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data();
  ~InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data() = delete;
};
static_assert(sizeof(InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data) == 16,
              "Bad sizeof(InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data)");
class  InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data));
      new (data()) InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data>(index_);
    }
    InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::InputDevice_Data>>> devices;

 private:
  InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data();
  ~InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data() = delete;
};
static_assert(sizeof(InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data) == 16,
              "Bad sizeof(InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data)");
class  InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data));
      new (data()) InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data>(index_);
    }
    InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::InputDevice_Data>>> devices;

 private:
  InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data();
  ~InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data() = delete;
};
static_assert(sizeof(InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data) == 16,
              "Bad sizeof(InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data)");
class  InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data));
      new (data()) InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data>(index_);
    }
    InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::InputDevice_Data>>> keyboard_devices;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::TouchscreenDevice_Data>>> touchscreen_devices;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::InputDevice_Data>>> mouse_devices;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::InputDevice_Data>>> touchpad_devices;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::InputDevice_Data>>> uncategorized_devices;
  uint8_t are_touchscreen_target_displays_valid : 1;
  uint8_t padfinal_[7];

 private:
  InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data();
  ~InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data() = delete;
};
static_assert(sizeof(InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data) == 56,
              "Bad sizeof(InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data)");
class  InputDeviceObserverMojo_OnStylusStateChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InputDeviceObserverMojo_OnStylusStateChanged_Params_Data));
      new (data()) InputDeviceObserverMojo_OnStylusStateChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InputDeviceObserverMojo_OnStylusStateChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InputDeviceObserverMojo_OnStylusStateChanged_Params_Data>(index_);
    }
    InputDeviceObserverMojo_OnStylusStateChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  InputDeviceObserverMojo_OnStylusStateChanged_Params_Data();
  ~InputDeviceObserverMojo_OnStylusStateChanged_Params_Data() = delete;
};
static_assert(sizeof(InputDeviceObserverMojo_OnStylusStateChanged_Params_Data) == 16,
              "Bad sizeof(InputDeviceObserverMojo_OnStylusStateChanged_Params_Data)");
class  InputDeviceServer_AddObserver_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InputDeviceServer_AddObserver_Params_Data));
      new (data()) InputDeviceServer_AddObserver_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InputDeviceServer_AddObserver_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InputDeviceServer_AddObserver_Params_Data>(index_);
    }
    InputDeviceServer_AddObserver_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data observer;

 private:
  InputDeviceServer_AddObserver_Params_Data();
  ~InputDeviceServer_AddObserver_Params_Data() = delete;
};
static_assert(sizeof(InputDeviceServer_AddObserver_Params_Data) == 16,
              "Bad sizeof(InputDeviceServer_AddObserver_Params_Data)");

}  // namespace internal
class InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_ParamsDataView {
 public:
  InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_ParamsDataView() {}

  InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_ParamsDataView(
      internal::InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDevices(UserType* output) {
    auto* pointer = data_->devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>>(
        pointer, output, context_);
  }
 private:
  internal::InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_ParamsDataView {
 public:
  InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_ParamsDataView() {}

  InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_ParamsDataView(
      internal::InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::TouchscreenDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDevices(UserType* output) {
    auto* pointer = data_->devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::TouchscreenDeviceDataView>>(
        pointer, output, context_);
  }
  bool touchscreen_target_display_ids_changed() const {
    return data_->touchscreen_target_display_ids_changed;
  }
 private:
  internal::InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_ParamsDataView {
 public:
  InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_ParamsDataView() {}

  InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_ParamsDataView(
      internal::InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDevices(UserType* output) {
    auto* pointer = data_->devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>>(
        pointer, output, context_);
  }
 private:
  internal::InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_ParamsDataView {
 public:
  InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_ParamsDataView() {}

  InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_ParamsDataView(
      internal::InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDevices(UserType* output) {
    auto* pointer = data_->devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>>(
        pointer, output, context_);
  }
 private:
  internal::InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_ParamsDataView {
 public:
  InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_ParamsDataView() {}

  InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_ParamsDataView(
      internal::InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDevices(UserType* output) {
    auto* pointer = data_->devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>>(
        pointer, output, context_);
  }
 private:
  internal::InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InputDeviceObserverMojo_OnDeviceListsComplete_ParamsDataView {
 public:
  InputDeviceObserverMojo_OnDeviceListsComplete_ParamsDataView() {}

  InputDeviceObserverMojo_OnDeviceListsComplete_ParamsDataView(
      internal::InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeyboardDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyboardDevices(UserType* output) {
    auto* pointer = data_->keyboard_devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>>(
        pointer, output, context_);
  }
  inline void GetTouchscreenDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::TouchscreenDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTouchscreenDevices(UserType* output) {
    auto* pointer = data_->touchscreen_devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::TouchscreenDeviceDataView>>(
        pointer, output, context_);
  }
  inline void GetMouseDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMouseDevices(UserType* output) {
    auto* pointer = data_->mouse_devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>>(
        pointer, output, context_);
  }
  inline void GetTouchpadDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTouchpadDevices(UserType* output) {
    auto* pointer = data_->touchpad_devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>>(
        pointer, output, context_);
  }
  inline void GetUncategorizedDevicesDataView(
      mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUncategorizedDevices(UserType* output) {
    auto* pointer = data_->uncategorized_devices.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>>(
        pointer, output, context_);
  }
  bool are_touchscreen_target_displays_valid() const {
    return data_->are_touchscreen_target_displays_valid;
  }
 private:
  internal::InputDeviceObserverMojo_OnDeviceListsComplete_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InputDeviceObserverMojo_OnStylusStateChanged_ParamsDataView {
 public:
  InputDeviceObserverMojo_OnStylusStateChanged_ParamsDataView() {}

  InputDeviceObserverMojo_OnStylusStateChanged_ParamsDataView(
      internal::InputDeviceObserverMojo_OnStylusStateChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::ui::mojom::StylusState>(
        data_value, output);
  }

  ::ui::mojom::StylusState state() const {
    return static_cast<::ui::mojom::StylusState>(data_->state);
  }
 private:
  internal::InputDeviceObserverMojo_OnStylusStateChanged_Params_Data* data_ = nullptr;
};

class InputDeviceServer_AddObserver_ParamsDataView {
 public:
  InputDeviceServer_AddObserver_ParamsDataView() {}

  InputDeviceServer_AddObserver_ParamsDataView(
      internal::InputDeviceServer_AddObserver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeObserver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::ws::mojom::InputDeviceObserverMojoPtrDataView>(
            &data_->observer, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::InputDeviceServer_AddObserver_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void InputDeviceObserverMojo_OnKeyboardDeviceConfigurationChanged_ParamsDataView::GetDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output) {
  auto pointer = data_->devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>(pointer, context_);
}


inline void InputDeviceObserverMojo_OnTouchscreenDeviceConfigurationChanged_ParamsDataView::GetDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::TouchscreenDeviceDataView>* output) {
  auto pointer = data_->devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::TouchscreenDeviceDataView>(pointer, context_);
}


inline void InputDeviceObserverMojo_OnMouseDeviceConfigurationChanged_ParamsDataView::GetDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output) {
  auto pointer = data_->devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>(pointer, context_);
}


inline void InputDeviceObserverMojo_OnTouchpadDeviceConfigurationChanged_ParamsDataView::GetDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output) {
  auto pointer = data_->devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>(pointer, context_);
}


inline void InputDeviceObserverMojo_OnUncategorizedDeviceConfigurationChanged_ParamsDataView::GetDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output) {
  auto pointer = data_->devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>(pointer, context_);
}


inline void InputDeviceObserverMojo_OnDeviceListsComplete_ParamsDataView::GetKeyboardDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output) {
  auto pointer = data_->keyboard_devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>(pointer, context_);
}
inline void InputDeviceObserverMojo_OnDeviceListsComplete_ParamsDataView::GetTouchscreenDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::TouchscreenDeviceDataView>* output) {
  auto pointer = data_->touchscreen_devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::TouchscreenDeviceDataView>(pointer, context_);
}
inline void InputDeviceObserverMojo_OnDeviceListsComplete_ParamsDataView::GetMouseDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output) {
  auto pointer = data_->mouse_devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>(pointer, context_);
}
inline void InputDeviceObserverMojo_OnDeviceListsComplete_ParamsDataView::GetTouchpadDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output) {
  auto pointer = data_->touchpad_devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>(pointer, context_);
}
inline void InputDeviceObserverMojo_OnDeviceListsComplete_ParamsDataView::GetUncategorizedDevicesDataView(
    mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>* output) {
  auto pointer = data_->uncategorized_devices.Get();
  *output = mojo::ArrayDataView<::ui::mojom::InputDeviceDataView>(pointer, context_);
}





}  // namespace mojom
}  // namespace ws

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_WS_PUBLIC_MOJOM_INPUT_DEVICES_INPUT_DEVICE_SERVER_MOJOM_PARAMS_DATA_H_