// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/ws/public/mojom/input_devices/input_device_server.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "ui/events/devices/mojo/input_devices.mojom.h"


#ifndef SERVICES_WS_PUBLIC_MOJOM_INPUT_DEVICES_INPUT_DEVICE_SERVER_MOJOM_JUMBO_H_
#define SERVICES_WS_PUBLIC_MOJOM_INPUT_DEVICES_INPUT_DEVICE_SERVER_MOJOM_JUMBO_H_
#include "ui/events/devices/mojo/input_device_struct_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#endif


namespace ws {
namespace mojom {


void InputDeviceObserverMojoInterceptorForTesting::OnKeyboardDeviceConfigurationChanged(const std::vector<ui::InputDevice>& devices) {
  GetForwardingInterface()->OnKeyboardDeviceConfigurationChanged(std::move(devices));
}
void InputDeviceObserverMojoInterceptorForTesting::OnTouchscreenDeviceConfigurationChanged(const std::vector<ui::TouchscreenDevice>& devices, bool touchscreen_target_display_ids_changed) {
  GetForwardingInterface()->OnTouchscreenDeviceConfigurationChanged(std::move(devices), std::move(touchscreen_target_display_ids_changed));
}
void InputDeviceObserverMojoInterceptorForTesting::OnMouseDeviceConfigurationChanged(const std::vector<ui::InputDevice>& devices) {
  GetForwardingInterface()->OnMouseDeviceConfigurationChanged(std::move(devices));
}
void InputDeviceObserverMojoInterceptorForTesting::OnTouchpadDeviceConfigurationChanged(const std::vector<ui::InputDevice>& devices) {
  GetForwardingInterface()->OnTouchpadDeviceConfigurationChanged(std::move(devices));
}
void InputDeviceObserverMojoInterceptorForTesting::OnUncategorizedDeviceConfigurationChanged(const std::vector<ui::InputDevice>& devices) {
  GetForwardingInterface()->OnUncategorizedDeviceConfigurationChanged(std::move(devices));
}
void InputDeviceObserverMojoInterceptorForTesting::OnDeviceListsComplete(const std::vector<ui::InputDevice>& keyboard_devices, const std::vector<ui::TouchscreenDevice>& touchscreen_devices, const std::vector<ui::InputDevice>& mouse_devices, const std::vector<ui::InputDevice>& touchpad_devices, const std::vector<ui::InputDevice>& uncategorized_devices, bool are_touchscreen_target_displays_valid) {
  GetForwardingInterface()->OnDeviceListsComplete(std::move(keyboard_devices), std::move(touchscreen_devices), std::move(mouse_devices), std::move(touchpad_devices), std::move(uncategorized_devices), std::move(are_touchscreen_target_displays_valid));
}
void InputDeviceObserverMojoInterceptorForTesting::OnStylusStateChanged(ui::StylusState state) {
  GetForwardingInterface()->OnStylusStateChanged(std::move(state));
}
InputDeviceObserverMojoAsyncWaiter::InputDeviceObserverMojoAsyncWaiter(
    InputDeviceObserverMojo* proxy) : proxy_(proxy) {}

InputDeviceObserverMojoAsyncWaiter::~InputDeviceObserverMojoAsyncWaiter() = default;




void InputDeviceServerInterceptorForTesting::AddObserver(InputDeviceObserverMojoPtr observer) {
  GetForwardingInterface()->AddObserver(std::move(observer));
}
InputDeviceServerAsyncWaiter::InputDeviceServerAsyncWaiter(
    InputDeviceServer* proxy) : proxy_(proxy) {}

InputDeviceServerAsyncWaiter::~InputDeviceServerAsyncWaiter() = default;






}  // namespace mojom
}  // namespace ws

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif