// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_WS_PUBLIC_MOJOM_INPUT_DEVICES_INPUT_DEVICE_SERVER_MOJOM_TEST_UTILS_H_
#define SERVICES_WS_PUBLIC_MOJOM_INPUT_DEVICES_INPUT_DEVICE_SERVER_MOJOM_TEST_UTILS_H_

#include "services/ws/public/mojom/input_devices/input_device_server.mojom.h"


namespace ws {
namespace mojom {


class  InputDeviceObserverMojoInterceptorForTesting : public InputDeviceObserverMojo {
  virtual InputDeviceObserverMojo* GetForwardingInterface() = 0;
  void OnKeyboardDeviceConfigurationChanged(const std::vector<ui::InputDevice>& devices) override;
  void OnTouchscreenDeviceConfigurationChanged(const std::vector<ui::TouchscreenDevice>& devices, bool touchscreen_target_display_ids_changed) override;
  void OnMouseDeviceConfigurationChanged(const std::vector<ui::InputDevice>& devices) override;
  void OnTouchpadDeviceConfigurationChanged(const std::vector<ui::InputDevice>& devices) override;
  void OnUncategorizedDeviceConfigurationChanged(const std::vector<ui::InputDevice>& devices) override;
  void OnDeviceListsComplete(const std::vector<ui::InputDevice>& keyboard_devices, const std::vector<ui::TouchscreenDevice>& touchscreen_devices, const std::vector<ui::InputDevice>& mouse_devices, const std::vector<ui::InputDevice>& touchpad_devices, const std::vector<ui::InputDevice>& uncategorized_devices, bool are_touchscreen_target_displays_valid) override;
  void OnStylusStateChanged(ui::StylusState state) override;
};
class  InputDeviceObserverMojoAsyncWaiter {
 public:
  explicit InputDeviceObserverMojoAsyncWaiter(InputDeviceObserverMojo* proxy);
  ~InputDeviceObserverMojoAsyncWaiter();

 private:
  InputDeviceObserverMojo* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(InputDeviceObserverMojoAsyncWaiter);
};


class  InputDeviceServerInterceptorForTesting : public InputDeviceServer {
  virtual InputDeviceServer* GetForwardingInterface() = 0;
  void AddObserver(InputDeviceObserverMojoPtr observer) override;
};
class  InputDeviceServerAsyncWaiter {
 public:
  explicit InputDeviceServerAsyncWaiter(InputDeviceServer* proxy);
  ~InputDeviceServerAsyncWaiter();

 private:
  InputDeviceServer* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(InputDeviceServerAsyncWaiter);
};




}  // namespace mojom
}  // namespace ws

#endif  // SERVICES_WS_PUBLIC_MOJOM_INPUT_DEVICES_INPUT_DEVICE_SERVER_MOJOM_TEST_UTILS_H_