// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERIAL_SERIAL_MOJOM_BLINK_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERIAL_SERIAL_MOJOM_BLINK_TEST_UTILS_H_

#include "third_party/blink/public/mojom/serial/serial.mojom-blink.h"
#include "third_party/blink/renderer/platform/platform_export.h"


namespace blink {
namespace mojom {
namespace blink {


class PLATFORM_EXPORT SerialServiceInterceptorForTesting : public SerialService {
  virtual SerialService* GetForwardingInterface() = 0;
  void GetPorts(GetPortsCallback callback) override;
  void RequestPort(WTF::Vector<SerialPortFilterPtr> filters, RequestPortCallback callback) override;
  void GetPort(const base::UnguessableToken& token, ::device::mojom::blink::SerialPortRequest port_request) override;
};
class PLATFORM_EXPORT SerialServiceAsyncWaiter {
 public:
  explicit SerialServiceAsyncWaiter(SerialService* proxy);
  ~SerialServiceAsyncWaiter();
  void GetPorts(
      WTF::Vector<SerialPortInfoPtr>* out_ports);
  void RequestPort(
      WTF::Vector<SerialPortFilterPtr> filters, SerialPortInfoPtr* out_port);

 private:
  SerialService* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(SerialServiceAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SERIAL_SERIAL_MOJOM_BLINK_TEST_UTILS_H_