// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "third_party/blink/public/mojom/sms/sms_manager.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/time.mojom.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SMS_SMS_MANAGER_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SMS_SMS_MANAGER_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#endif


namespace blink {
namespace mojom {


void SmsManagerInterceptorForTesting::GetNextMessage(base::TimeDelta timeout, GetNextMessageCallback callback) {
  GetForwardingInterface()->GetNextMessage(std::move(timeout), std::move(callback));
}
SmsManagerAsyncWaiter::SmsManagerAsyncWaiter(
    SmsManager* proxy) : proxy_(proxy) {}

SmsManagerAsyncWaiter::~SmsManagerAsyncWaiter() = default;

void SmsManagerAsyncWaiter::GetNextMessage(
    base::TimeDelta timeout, SmsMessagePtr* out_sms) {
  base::RunLoop loop;
  proxy_->GetNextMessage(std::move(timeout),
      base::BindOnce(
          [](base::RunLoop* loop,
             SmsMessagePtr* out_sms
,
             SmsMessagePtr sms) {*out_sms = std::move(sms);
            loop->Quit();
          },
          &loop,
          out_sms));
  loop.Run();
}





}  // namespace mojom
}  // namespace blink

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif