// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBAUTHN_INTERNAL_AUTHENTICATOR_MOJOM_PARAMS_DATA_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBAUTHN_INTERNAL_AUTHENTICATOR_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace blink {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) InternalAuthenticator_MakeCredential_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InternalAuthenticator_MakeCredential_Params_Data));
      new (data()) InternalAuthenticator_MakeCredential_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InternalAuthenticator_MakeCredential_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InternalAuthenticator_MakeCredential_Params_Data>(index_);
    }
    InternalAuthenticator_MakeCredential_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::PublicKeyCredentialCreationOptions_Data> options;

 private:
  InternalAuthenticator_MakeCredential_Params_Data();
  ~InternalAuthenticator_MakeCredential_Params_Data() = delete;
};
static_assert(sizeof(InternalAuthenticator_MakeCredential_Params_Data) == 16,
              "Bad sizeof(InternalAuthenticator_MakeCredential_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) InternalAuthenticator_MakeCredential_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InternalAuthenticator_MakeCredential_ResponseParams_Data));
      new (data()) InternalAuthenticator_MakeCredential_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InternalAuthenticator_MakeCredential_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InternalAuthenticator_MakeCredential_ResponseParams_Data>(index_);
    }
    InternalAuthenticator_MakeCredential_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::blink::mojom::internal::MakeCredentialAuthenticatorResponse_Data> credential;

 private:
  InternalAuthenticator_MakeCredential_ResponseParams_Data();
  ~InternalAuthenticator_MakeCredential_ResponseParams_Data() = delete;
};
static_assert(sizeof(InternalAuthenticator_MakeCredential_ResponseParams_Data) == 24,
              "Bad sizeof(InternalAuthenticator_MakeCredential_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) InternalAuthenticator_GetAssertion_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InternalAuthenticator_GetAssertion_Params_Data));
      new (data()) InternalAuthenticator_GetAssertion_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InternalAuthenticator_GetAssertion_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InternalAuthenticator_GetAssertion_Params_Data>(index_);
    }
    InternalAuthenticator_GetAssertion_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::PublicKeyCredentialRequestOptions_Data> options;

 private:
  InternalAuthenticator_GetAssertion_Params_Data();
  ~InternalAuthenticator_GetAssertion_Params_Data() = delete;
};
static_assert(sizeof(InternalAuthenticator_GetAssertion_Params_Data) == 16,
              "Bad sizeof(InternalAuthenticator_GetAssertion_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) InternalAuthenticator_GetAssertion_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InternalAuthenticator_GetAssertion_ResponseParams_Data));
      new (data()) InternalAuthenticator_GetAssertion_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InternalAuthenticator_GetAssertion_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InternalAuthenticator_GetAssertion_ResponseParams_Data>(index_);
    }
    InternalAuthenticator_GetAssertion_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::blink::mojom::internal::GetAssertionAuthenticatorResponse_Data> credential;

 private:
  InternalAuthenticator_GetAssertion_ResponseParams_Data();
  ~InternalAuthenticator_GetAssertion_ResponseParams_Data() = delete;
};
static_assert(sizeof(InternalAuthenticator_GetAssertion_ResponseParams_Data) == 24,
              "Bad sizeof(InternalAuthenticator_GetAssertion_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data));
      new (data()) InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data>(index_);
    }
    InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data();
  ~InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data() = delete;
};
static_assert(sizeof(InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data) == 8,
              "Bad sizeof(InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data));
      new (data()) InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data>(index_);
    }
    InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t available : 1;
  uint8_t padfinal_[7];

 private:
  InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data();
  ~InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data() = delete;
};
static_assert(sizeof(InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data) == 16,
              "Bad sizeof(InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data)");

}  // namespace internal
class InternalAuthenticator_MakeCredential_ParamsDataView {
 public:
  InternalAuthenticator_MakeCredential_ParamsDataView() {}

  InternalAuthenticator_MakeCredential_ParamsDataView(
      internal::InternalAuthenticator_MakeCredential_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetOptionsDataView(
      ::blink::mojom::PublicKeyCredentialCreationOptionsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOptions(UserType* output) {
    auto* pointer = data_->options.Get();
    return mojo::internal::Deserialize<::blink::mojom::PublicKeyCredentialCreationOptionsDataView>(
        pointer, output, context_);
  }
 private:
  internal::InternalAuthenticator_MakeCredential_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InternalAuthenticator_MakeCredential_ResponseParamsDataView {
 public:
  InternalAuthenticator_MakeCredential_ResponseParamsDataView() {}

  InternalAuthenticator_MakeCredential_ResponseParamsDataView(
      internal::InternalAuthenticator_MakeCredential_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::AuthenticatorStatus>(
        data_value, output);
  }

  ::blink::mojom::AuthenticatorStatus status() const {
    return static_cast<::blink::mojom::AuthenticatorStatus>(data_->status);
  }
  inline void GetCredentialDataView(
      ::blink::mojom::MakeCredentialAuthenticatorResponseDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCredential(UserType* output) {
    auto* pointer = data_->credential.Get();
    return mojo::internal::Deserialize<::blink::mojom::MakeCredentialAuthenticatorResponseDataView>(
        pointer, output, context_);
  }
 private:
  internal::InternalAuthenticator_MakeCredential_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InternalAuthenticator_GetAssertion_ParamsDataView {
 public:
  InternalAuthenticator_GetAssertion_ParamsDataView() {}

  InternalAuthenticator_GetAssertion_ParamsDataView(
      internal::InternalAuthenticator_GetAssertion_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetOptionsDataView(
      ::blink::mojom::PublicKeyCredentialRequestOptionsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOptions(UserType* output) {
    auto* pointer = data_->options.Get();
    return mojo::internal::Deserialize<::blink::mojom::PublicKeyCredentialRequestOptionsDataView>(
        pointer, output, context_);
  }
 private:
  internal::InternalAuthenticator_GetAssertion_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InternalAuthenticator_GetAssertion_ResponseParamsDataView {
 public:
  InternalAuthenticator_GetAssertion_ResponseParamsDataView() {}

  InternalAuthenticator_GetAssertion_ResponseParamsDataView(
      internal::InternalAuthenticator_GetAssertion_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::blink::mojom::AuthenticatorStatus>(
        data_value, output);
  }

  ::blink::mojom::AuthenticatorStatus status() const {
    return static_cast<::blink::mojom::AuthenticatorStatus>(data_->status);
  }
  inline void GetCredentialDataView(
      ::blink::mojom::GetAssertionAuthenticatorResponseDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCredential(UserType* output) {
    auto* pointer = data_->credential.Get();
    return mojo::internal::Deserialize<::blink::mojom::GetAssertionAuthenticatorResponseDataView>(
        pointer, output, context_);
  }
 private:
  internal::InternalAuthenticator_GetAssertion_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ParamsDataView {
 public:
  InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ParamsDataView() {}

  InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ParamsDataView(
      internal::InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_Params_Data* data_ = nullptr;
};

class InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParamsDataView {
 public:
  InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParamsDataView() {}

  InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParamsDataView(
      internal::InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool available() const {
    return data_->available;
  }
 private:
  internal::InternalAuthenticator_IsUserVerifyingPlatformAuthenticatorAvailable_ResponseParams_Data* data_ = nullptr;
};


inline void InternalAuthenticator_MakeCredential_ParamsDataView::GetOptionsDataView(
    ::blink::mojom::PublicKeyCredentialCreationOptionsDataView* output) {
  auto pointer = data_->options.Get();
  *output = ::blink::mojom::PublicKeyCredentialCreationOptionsDataView(pointer, context_);
}


inline void InternalAuthenticator_MakeCredential_ResponseParamsDataView::GetCredentialDataView(
    ::blink::mojom::MakeCredentialAuthenticatorResponseDataView* output) {
  auto pointer = data_->credential.Get();
  *output = ::blink::mojom::MakeCredentialAuthenticatorResponseDataView(pointer, context_);
}


inline void InternalAuthenticator_GetAssertion_ParamsDataView::GetOptionsDataView(
    ::blink::mojom::PublicKeyCredentialRequestOptionsDataView* output) {
  auto pointer = data_->options.Get();
  *output = ::blink::mojom::PublicKeyCredentialRequestOptionsDataView(pointer, context_);
}


inline void InternalAuthenticator_GetAssertion_ResponseParamsDataView::GetCredentialDataView(
    ::blink::mojom::GetAssertionAuthenticatorResponseDataView* output) {
  auto pointer = data_->credential.Get();
  *output = ::blink::mojom::GetAssertionAuthenticatorResponseDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace blink

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBAUTHN_INTERNAL_AUTHENTICATOR_MOJOM_PARAMS_DATA_H_