// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ui/accessibility/mojom/ax_relative_bounds.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/logging.h"
#include "base/run_loop.h"
#include "base/task/common/task_annotator.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/accessibility/mojom/ax_relative_bounds.mojom-params-data.h"
#include "ui/accessibility/mojom/ax_relative_bounds.mojom-shared-message-ids.h"

#include "ui/accessibility/mojom/ax_relative_bounds.mojom-import-headers.h"


#ifndef UI_ACCESSIBILITY_MOJOM_AX_RELATIVE_BOUNDS_MOJOM_JUMBO_H_
#define UI_ACCESSIBILITY_MOJOM_AX_RELATIVE_BOUNDS_MOJOM_JUMBO_H_
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/mojo/transform_struct_traits.h"
#endif
namespace ax {
namespace mojom {
AXRelativeBounds::AXRelativeBounds()
    : offset_container_id(),
      bounds(),
      transform() {}

AXRelativeBounds::AXRelativeBounds(
    int32_t offset_container_id_in,
    const gfx::RectF& bounds_in,
    const gfx::Transform& transform_in)
    : offset_container_id(std::move(offset_container_id_in)),
      bounds(std::move(bounds_in)),
      transform(std::move(transform_in)) {}

AXRelativeBounds::~AXRelativeBounds() = default;

bool AXRelativeBounds::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace ax

namespace mojo {


// static
bool StructTraits<::ax::mojom::AXRelativeBounds::DataView, ::ax::mojom::AXRelativeBoundsPtr>::Read(
    ::ax::mojom::AXRelativeBounds::DataView input,
    ::ax::mojom::AXRelativeBoundsPtr* output) {
  bool success = true;
  ::ax::mojom::AXRelativeBoundsPtr result(::ax::mojom::AXRelativeBounds::New());
  
      result->offset_container_id = input.offset_container_id();
      if (!input.ReadBounds(&result->bounds))
        success = false;
      if (!input.ReadTransform(&result->transform))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif